//
//  re_sync_insert_code.swift
//  ecp_sync_plugin
//
//  Created by Jalpa Dhaval Sodha Parmar on 05/01/24.
//

import Foundation
import SwiftyJSON
import FMDB


func insert_re_methods() {
    print("Hello from insert_re_methods!")
}

class CreateNewCustomer {
    var createdByUser: String?
    var createdOn: String?
    var customerName: String?
    var mobileNo: String?
    var syncByUser: String?
    var syncCode: String?
    var syncDate: String?
    var syncFlag: String?
    var customerTypeCountyId: String?
    var countryId: String?
    
    init() {}
    
    init?(json: JSON) {
        // Map JSON to your object properties
        createdByUser = json["created_by_user"].stringValue
        createdOn = json["created_on"].stringValue
        customerName = json["customer_name"].stringValue
        mobileNo = json["mobile_no"].stringValue
        syncByUser = json["sync_by_user"].stringValue
        syncCode = json["sync_code"].stringValue
        syncDate = json["sync_date"].stringValue
        syncFlag = json["sync_flag"].stringValue
        customerTypeCountyId = json["customer_type_country_id"].stringValue
        countryId = json["country_id"].stringValue
        
        // Check if any required property is nil
        if createdByUser == nil || createdOn == nil || customerName == nil {
            return nil
        }
    }
}

class MenuAccess {
    var order: String?
    var alias: String?
    var menuId: String?
    var title: String?
    
    init() {}
    
    init?(json: JSON) {
        // Map JSON to your object properties
        order = json["order"].stringValue
        alias = json["alias"].stringValue
        menuId = json["menu_id"].stringValue
        title = json["title"].stringValue
        
        // Check if any required property is nil
        
    }
}

class PoliticalLevel {
    var politicalGeographyCountrylevelId: String?
    var levelName: String?
    var level: String?
    
    init() {}
    
    init?(json: JSON) {
        // Map JSON to your object properties
        politicalGeographyCountrylevelId = json["political_geography_countrylevel_id"].stringValue
        levelName = json["level_name"].stringValue
        level = json["level"].stringValue
        
        // Check if any required property is nil
        
    }
}

class ScannedPoints {
    var totalInScanned: String?
    var dtMonth: String?
    var id: String?
    
    init() {}
    
    init?(json: JSON) {
        // Map JSON to your object properties
        totalInScanned = json["TotalInScanned"].stringValue
        dtMonth = json["dtmonth"].stringValue
        
        // Assuming 'id' is present in your JSON; otherwise, you can remove it
        id = json["id"].stringValue
        
        // Check if any required property is nil
        
    }
}



class CtoCMapping {
    var fromCustomerId: String?
    var toCustomerId: String?
    
    init() {}
    
    init?(json: JSON) {
        // Map JSON to your object properties
        fromCustomerId = json["from_customer_id"].stringValue
        toCustomerId = json["to_customer_id"].stringValue
        
        // Check if any required property is nil
        
    }
}

class CtoEMapping {
    var employeeId: String?
    var customerId: String?
    var userCode: String?
    var displayName: String?
    var email: String?
    var primaryMobileNo: String?
    
    init() {}
    
    init?(json: JSON) {
        // Map JSON to your object properties
        employeeId = json["employee_id"].stringValue
        customerId = json["customer_id"].stringValue
        userCode = json["user_code"].stringValue
        displayName = json["display_name"].stringValue
        email = json["email"].stringValue
        primaryMobileNo = json["primary_mobile_no"].stringValue
        
        // Check if any required property is nil
        
    }
}

class UserConfigurationMst {
    var id: String?
    var dispatchScanType: String?
    var received: String?
    var returned: String?
    var politicalGeoLevel4: String?
    var intReceiveDays: String?
    var charReceivePopUp: String?
    var chrCustSyncEnable: String?
    var intSyncMinutes: String?
    var intScanScreen: String?
    var chrPalletEnable: String?
    var chrScmCpm: String?
    var ftpHost: String?
    var ftpPort: String?
    var ftpUsername: String?
    var ftpPassword: String?
    var intSyncAlertBgMinutes: String?
    var isSyncPopUp: String?
    var isExpireEnable: String?
    var intMinimumMinutes: String?
    var intMaximumMinutes: String?
    var chrScanTypeRadioBtn: String?
    var intScanAlertBgMinutes: String?
    var intSalesReturnLimit: String?
    
    init() {}
    
    init?(json: JSON) {
        // Map JSON to your object properties
        id = json["id"].stringValue
        dispatchScanType = json["dispatch_scan_type"].stringValue
        received = json["received"].stringValue
        returned = json["returned"].stringValue
        politicalGeoLevel4 = json["political_geo_level_4"].stringValue
        intReceiveDays = json["int_receive_days"].stringValue
        charReceivePopUp = json["char_receive_pop_up"].stringValue
        chrCustSyncEnable = json["chr_cust_sync_enable"].stringValue
        intSyncMinutes = json["int_sync_minutes"].stringValue
        intScanScreen = json["int_scan_screen"].stringValue
        chrPalletEnable = json["chr_pallet_enable"].stringValue
        chrScmCpm = json["chr_scm_cpm"].stringValue
        ftpHost = json["ftp_host"].stringValue
        ftpPort = json["ftp_port"].stringValue
        ftpUsername = json["ftp_username"].stringValue
        ftpPassword = json["ftp_password"].stringValue
        intSyncAlertBgMinutes = json["int_sync_alert_bg_minutes"].stringValue
        isSyncPopUp = json["is_sync_pop_up"].stringValue
        isExpireEnable = json["is_expire_enable"].stringValue
        intMinimumMinutes = json["int_minimum_minutes"].stringValue
        intMaximumMinutes = json["int_maximum_minutes"].stringValue
        chrScanTypeRadioBtn = json["chr_scan_type_radio_btn"].stringValue
        intScanAlertBgMinutes = json["int_scan_alert_bg_minutes"].stringValue
        intSalesReturnLimit = json["int_sales_return_limit"].stringValue
        
        // Check if any required property is nil
        
    }
}

class CustomerTypeDetails {
    var customerTypeCountryId: String?
    var customerTypeNameCountry: String?
    var customerLevel: String?
    var customerTypeName: String?
    var autoSync: String?
    var autoSyncDay: String?
    
    init() {}
    
    init?(json: JSON) {
        // Map JSON to your object properties
        customerTypeCountryId = json["customer_type_country_id"].stringValue
        customerTypeNameCountry = json["customer_type_name_country"].stringValue
        customerLevel = json["customer_level"].stringValue
        customerTypeName = json["customer_type_name"].stringValue
        autoSync = json["auto_sync"].stringValue
        autoSyncDay = json["auto_sync_day"].stringValue
        
        // Check if any required property is nil
        
    }
}






var arrayListCustomer: [CreateNewCustomer] = []
var arrayListMenuAccess: [MenuAccess] = []
var arrayListPoliticalLevel: [PoliticalLevel] = []
var arrayListScannedPoints: [ScannedPoints] = []

var arrayListCtoCMapping: [CtoCMapping] = []
var arrayListCtoEMapping: [CtoEMapping] = []

var arrayListUserConfigurationMst: [UserConfigurationMst] = []
var arrayListCustomerType_Details: [CustomerTypeDetails] = []


//let customer_level : String = dict["customer_level"] ?? ""
//let role_code : String = dict["role_code"] ?? ""

//RET_SYNC_METHOD
func saveRetailerTransactionData(downloadFileName: String, database:FMDatabase, zipFolderName:String,user_id:String,country_id:String,customer_level:String,role_code:String){
    
    do {
        
        //database.open()
        var tableName = ""
        let extractProcessStart = Date().timeIntervalSince1970 * 1000
        var totalRecords = 0
        var sdtStart = Date().timeIntervalSince1970 * 1000
        
        let fileManager = FileManager.default
        //let filePath = DownloadFileFromURL.parentpath + "/" + downloadFileName + "/0.txt"
        let filePath = downloadFileName + "/" + zipFolderName + "/0.txt"
        
        let filePath_directory = downloadFileName + "/" + zipFolderName
        
        print(filePath)
        
        if fileManager.fileExists(atPath: filePath) {
            if let jsonString = try? String(contentsOfFile: filePath) {
                
                let objectResponse_old = JSON(jsonString)
                
                if let jsonData = jsonString.data(using: .utf8) {
                    let objectResponse = try? JSON(data: jsonData)
                    
                    // Now you can use objectResponse as a SwiftyJSON object
                    if let status = objectResponse?["status"].bool, status == true {
                        
                        if((objectResponse?["ishop_retailer_dispatch"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["ishop_retailer_dispatch"]
                            
                            
                            if(!jsonArrayEmployee.isEmpty){
                                
                                do {
                                    
                                    let items = insertRetailerDispatchNew(jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                    print("items:\(items)")
                                   
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                            
                        }
                        
                        if((objectResponse?["ishop_customer_scaned_in_sticker"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["ishop_customer_scaned_in_sticker"]
                            
                            if(arrayListScannedPoints.count > 0){
                                arrayListScannedPoints.removeAll()
                            }
                            
                            if let jsonArray = jsonArrayEmployee.array {
                                for jsonItem in jsonArray {
                                    // Create an instance of CreateNewCustomer using SwiftyJSON's convenient initializer
                                    if let customer = ScannedPoints(json: jsonItem) {
                                        // Append the customer to the array
                                        arrayListScannedPoints.append(customer)
                                    }
                                }
                            }
                            
                            if(arrayListScannedPoints.count > 0){
                                do {
                                    
                                    if database.open() {
                                        
                                        database.executeUpdate("DELETE FROM \(DBHelper.TABLE_RETAILER_SCANNED_IN_STICKER)", withArgumentsIn: [])
                                        for object in arrayListScannedPoints {
                                            insertRetailerScannedIn(object,database: database)
                                            //print("items:\(items)")
                                        }
                                        database.close()
                                    } else {
                                        // Handle the case where the database couldn't be opened
                                        print("Error opening database.")
                                    }
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                        }
                        
                        if((objectResponse?["ishop_customer_scaned_out_sticker"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["ishop_customer_scaned_out_sticker"]
                            
                            if(!jsonArrayEmployee.isEmpty){
                                do {
                                    if database.open() {
                                        //for object in arrayListCustomer {
                                        insertRetailerScannedOutSticker(jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                        //print("items:\(items)")
                                        //}
                                        database.close()
                                    }else {
                                        // Handle the case where the database couldn't be opened
                                        print("Error opening database.")
                                    }
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                            
                        }
                        
                        if((objectResponse?["Last_Sync_Date_Time"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["Last_Sync_Date_Time"]
                            
                            if(!jsonArrayEmployee.isEmpty){
                                do {
                                    if database.open() {
                                        //for object in arrayListCustomer {
                                        updateLastSyncDateTimeForWHMasterSync(jsonArrayEmployee.rawValue as! [[String : Any]],1,database: database)
                                        //print("items:\(items)")
                                        //}
                                        database.close()
                                    } else {
                                        // Handle the case where the database couldn't be opened
                                        print("Error opening database.")
                                    }
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                            
                        }
                        
                        do {
                            // Get the contents of the directory at the specified path
                            let contents = try fileManager.contentsOfDirectory(atPath: filePath_directory)
                            
                            // Filter only directories
                            let directories = contents.filter { (itemName) -> Bool in
                                var isDirectory: ObjCBool = false
                                let itemPath = (filePath_directory as NSString).appendingPathComponent(itemName)
                                return fileManager.fileExists(atPath: itemPath, isDirectory: &isDirectory) && isDirectory.boolValue
                            }
                            
                            // Print the list of directories
                            print("List of Directories:")
                            for directory in directories {
                                
                                print("==========NEW FILE=====================")
                                
                                print(directory)
                                
                                
                                // Get the contents of the current directory
                                let directoryPath = (filePath_directory as NSString).appendingPathComponent(directory)
                                let directoryContents = try fileManager.contentsOfDirectory(atPath: directoryPath)
                                
                                // Filter only files
                                let files = directoryContents.filter { (itemName) -> Bool in
                                    var isDirectory: ObjCBool = false
                                    let itemPath = (directoryPath as NSString).appendingPathComponent(itemName)
                                    return fileManager.fileExists(atPath: itemPath, isDirectory: &isDirectory) && !isDirectory.boolValue
                                }
                                
                                let sortedFiles = files.sorted()
                                // Print the list of files in the current directory
                                for file in sortedFiles {
                                    print("  - \(file)")
                                    
                                    let filePath_inner = downloadFileName + "/" + zipFolderName + "/" + directory + "/" + file
                                    
                                    print("file_innerPath:\(filePath_inner)")
                                    
                                    if fileManager.fileExists(atPath: filePath_inner) {
                                        print("File 1.txt exists at path: \(filePath_inner)")
                                        
                                        if let jsonString_inner = try? String(contentsOfFile: filePath_inner) {
                                            
                                            
                                            if let jsonData_inner = jsonString_inner.data(using: .utf8) {
                                                let objectResponse_inner = try? JSON(data: jsonData_inner)
                                                
                                                if((objectResponse_inner?["ishop_sticker_details"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_sticker_details"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                //for object in arrayListCustomer {
                                                                insertStickerDetailsNew(stickerArray: jsonArrayEmployee.rawValue as! [[String : Any]],loginId: user_id, customerLevel: customer_level, roleCode: role_code,database: database)
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                
                                                if((objectResponse_inner?["ishop_sticker"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_sticker"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                
                                                                /*if (role_code.equalsIgnoreCase("FO")) {
                                                                 databaseCRUD.InsertIshopStickerNew(jsonArrayEmployee);
                                                                 } else if (customer_level.equalsIgnoreCase("L2")) {
                                                                 databaseCRUD.InsertIshopStickerNew(jsonArrayEmployee);
                                                                 } else {
                                                                 //                                                databaseCRUD.InsertStickerNew(jsonArrayEmployee, item);
                                                                 databaseCRUD.InsertIshopStickerNew(jsonArrayEmployee);
                                                                 }*/
                                                                insertIshopStickerNew(ishopSticker: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                
                                                if((objectResponse_inner?["ishop_distributor_dispatch_product"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_distributor_dispatch_product"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                //for object in arrayListCustomer {
                                                                insertDistributorDispatchProductNew(ishopDistributorDispatchProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_distributor_dispatch"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_distributor_dispatch"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertDistributorDispatchNew(ishopDistributorDispatch: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                                
                                                                
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_retailer_received"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_retailer_received"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertRetailerReceivedNew(ishopRetailerReceived: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                                
                                                                
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_retailer_received_product"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_retailer_received_product"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                //for object in arrayListCustomer {
                                                                insertRetailerReceivedProductNew(ishopRetailerReceivedProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_retailer_return"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_retailer_return"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertRetailerReturnNew(ishopRetailerReturn: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                                
                                                                
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_retailer_return_product"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_retailer_return_product"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertRetailerReturnProductNew(ishopRetailerReturnProduct: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                                
                                                                
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_retailer_dispatch_product"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_retailer_dispatch_product"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                //for object in arrayListCustomer {
                                                                insertRetailerDispatchProductNew(ishopRetailerDispatchProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["cpm_customer_product_stock"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["cpm_customer_product_stock"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                //for object in arrayListCustomer {
                                                                insertCustomerProductStock(arrayCPMCustomerProductStock: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                                insertDispatchBatchwiseStockCalculate(arrayCPMCustomerProductStock: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["cpm_customer_product_damage_stock"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["cpm_customer_product_damage_stock"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                
                                                                insertCustomerProductDamageStock(arrayCPMCustomerProductStock: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                                
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["extra_sticker_detail"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["extra_sticker_detail"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertExtraStickerDetail(arrayCfaDispatchProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["sales_rep_initiated_product"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["sales_rep_initiated_product"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertSalesRepInitiatedProduct(jsonArraySalesRep: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                                
                                                                
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["sales_rep_initiated_product_current_limit"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["sales_rep_initiated_product_current_limit"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertSalesReturnCurrentLimit(arrayCurrentLimit: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                
                                                                
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                //RET_SYNC_METHOD_CHK
                                            }
                                        }
                                    }
                                }
                            }
                            
                            
                            
                            
                            if database.open() {
                                deleteSaveOfflineLogTable(database: database)
                                deleteUnreceivedValidData(database: database)
                                deleteRejectedOrder(database: database)
                                deleteDamageData(database: database)
                                deleteDeviceTokenTable(database: database)
                                deleteRejectedData(database: database)
                                deleteCfaDispatchIDNotInProductTable(database: database)
                                deleteCfaDispatchIDNotInMainTable(database: database)
                                deleteTransactionErrorLog(database: database)
                                //insertDelayedTransaction()
                                //updateRetailerReceiveProductSyncFlag(database: database)
                                //updateRetailerDispatchProductSyncFlag(database: database)
                                
                                if customer_level.uppercased() == "L3" {
                                    deleteDistributorReturnRequestData(customerId: user_id,database: database)
                                }
                                
                                
                            
                                database.close()
                            } else {
                                // Handle the case where the database couldn't be opened
                                print("Error opening database.")
                            }
                            
                        }catch {
                            print("Error: \(error)")
                        }
                        
                        
                        
                        
                    }
                }
            }
        } else {
            print("File does not exist.")
        }
    } catch {
        print("Error: \(error)")
    }
    
}

//DIST_SYNC_METHOD
func saveDistMasterData(downloadFileName: String, database:FMDatabase, zipFolderName:String,user_id:String,country_id:String,customer_level:String,role_code:String){
    
    do {
        
        //database.open()
        var tableName = ""
        let extractProcessStart = Date().timeIntervalSince1970 * 1000
        var totalRecords = 0
        var sdtStart = Date().timeIntervalSince1970 * 1000
        
        let fileManager = FileManager.default
        //let filePath = DownloadFileFromURL.parentpath + "/" + downloadFileName + "/0.txt"
        let filePath = downloadFileName + "/" + zipFolderName + "/0.txt"
        
        let filePath_directory = downloadFileName + "/" + zipFolderName
        
        print(filePath)
        
        if fileManager.fileExists(atPath: filePath) {
            if let jsonString = try? String(contentsOfFile: filePath) {
                
                let objectResponse_old = JSON(jsonString)
                
                if let jsonData = jsonString.data(using: .utf8) {
                    let objectResponse = try? JSON(data: jsonData)
                    
                    // Now you can use objectResponse as a SwiftyJSON object
                    if let status = objectResponse?["status"].bool, status == true {
                        
                        if((objectResponse?["ishop_distributor_received"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["ishop_distributor_received"]
                            
                            if(!jsonArrayEmployee.isEmpty){
                                do {
                                    //for object in arrayListCustomer {
                                    database.open()
                                    insertDistributorReturnNew(jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                    database.close()
                                    //print("items:\(items)")
                                    //}
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                            
                        }
                        
                        if((objectResponse?["ishop_customer_scaned_in_sticker"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["ishop_customer_scaned_in_sticker"]
                            
                            if(arrayListScannedPoints.count > 0){
                                arrayListScannedPoints.removeAll()
                            }
                            
                            if let jsonArray = jsonArrayEmployee.array {
                                for jsonItem in jsonArray {
                                    // Create an instance of CreateNewCustomer using SwiftyJSON's convenient initializer
                                    if let customer = ScannedPoints(json: jsonItem) {
                                        // Append the customer to the array
                                        arrayListScannedPoints.append(customer)
                                    }
                                }
                            }
                            
                            if(arrayListScannedPoints.count > 0){
                                do {
                                    
                                    if database.open() {
                                        
                                        database.executeUpdate("DELETE FROM \(DBHelper.TABLE_RETAILER_SCANNED_IN_STICKER)", withArgumentsIn: [])
                                        for object in arrayListScannedPoints {
                                            insertRetailerScannedIn(object,database: database)
                                            //print("items:\(items)")
                                        }
                                        database.close()
                                    } else {
                                        // Handle the case where the database couldn't be opened
                                        print("Error opening database.")
                                    }
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                        }
                        
                        if((objectResponse?["ishop_customer_scaned_out_sticker"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["ishop_customer_scaned_out_sticker"]
                            
                            if(!jsonArrayEmployee.isEmpty){
                                do {
                                    if database.open() {
                                        //for object in arrayListCustomer {
                                        insertRetailerScannedOutSticker(jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                        //print("items:\(items)")
                                        //}
                                        database.close()
                                    }else {
                                        // Handle the case where the database couldn't be opened
                                        print("Error opening database.")
                                    }
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                            
                        }
                        
                        if((objectResponse?["Last_Sync_Date_Time"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["Last_Sync_Date_Time"]
                            
                            if(!jsonArrayEmployee.isEmpty){
                                do {
                                    if database.open() {
                                        //for object in arrayListCustomer {
                                        updateLastSyncDateTimeForWHMasterSync(jsonArrayEmployee.rawValue as! [[String : Any]],1,database: database)
                                        //print("items:\(items)")
                                        //}
                                        database.close()
                                    } else {
                                        // Handle the case where the database couldn't be opened
                                        print("Error opening database.")
                                    }
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                            
                        }
                        
                        
                        do {
                            // Get the contents of the directory at the specified path
                            let contents = try fileManager.contentsOfDirectory(atPath: filePath_directory)
                            
                            // Filter only directories
                            let directories = contents.filter { (itemName) -> Bool in
                                var isDirectory: ObjCBool = false
                                let itemPath = (filePath_directory as NSString).appendingPathComponent(itemName)
                                return fileManager.fileExists(atPath: itemPath, isDirectory: &isDirectory) && isDirectory.boolValue
                            }
                            
                            // Print the list of directories
                            print("List of Directories:")
                            for directory in directories {
                                
                                print("==========NEW FILE=====================")
                                
                                print(directory)
                                
                                
                                // Get the contents of the current directory
                                let directoryPath = (filePath_directory as NSString).appendingPathComponent(directory)
                                let directoryContents = try fileManager.contentsOfDirectory(atPath: directoryPath)
                                
                                // Filter only files
                                let files = directoryContents.filter { (itemName) -> Bool in
                                    var isDirectory: ObjCBool = false
                                    let itemPath = (directoryPath as NSString).appendingPathComponent(itemName)
                                    return fileManager.fileExists(atPath: itemPath, isDirectory: &isDirectory) && !isDirectory.boolValue
                                }
                                
                                let sortedFiles = files.sorted()
                                // Print the list of files in the current directory
                                for file in sortedFiles {
                                    print("  - \(file)")
                                    
                                    let filePath_inner = downloadFileName + "/" + zipFolderName + "/" + directory + "/" + file
                                
                                    if fileManager.fileExists(atPath: filePath_inner) {
                                        print("File 1.txt exists at path: \(filePath_inner)")
                                        
                                        if let jsonString_inner = try? String(contentsOfFile: filePath_inner) {
                                            
                                            
                                            if let jsonData_inner = jsonString_inner.data(using: .utf8) {
                                                let objectResponse_inner = try? JSON(data: jsonData_inner)
                                                
                                                if((objectResponse_inner?["ishop_sticker_details"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_sticker_details"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                //for object in arrayListCustomer {
                                                                insertStickerDetailsNew(stickerArray: jsonArrayEmployee.rawValue as! [[String : Any]],loginId: user_id, customerLevel: customer_level, roleCode: role_code,database: database)
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_cfa_dispatch_product"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_cfa_dispatch_product"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                //for object in arrayListCustomer {
                                                                insertCFADispatchProductNew1(arrayCfaDispatchProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_sticker"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_sticker"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                
                                                                /*if (role_code.equalsIgnoreCase("FO")) {
                                                                 databaseCRUD.InsertIshopStickerNew(jsonArrayEmployee);
                                                                 } else if (customer_level.equalsIgnoreCase("L2")) {
                                                                 databaseCRUD.InsertIshopStickerNew(jsonArrayEmployee);
                                                                 } else {
                                                                 //                                                databaseCRUD.InsertStickerNew(jsonArrayEmployee, item);
                                                                 databaseCRUD.InsertIshopStickerNew(jsonArrayEmployee);
                                                                 }*/
                                                                insertIshopStickerNew(ishopSticker: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_cfa_dispatch"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_cfa_dispatch"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                //for object in arrayListCustomer {
                                                                insertCFADispatchNew(ishopCFADispatch: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse?["ishop_distributor_received_product"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse!["ishop_distributor_received_product"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            database.open()
                                                            insertDistributorReceivedProductNew(ishopDistributorReceivedProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                            database.close()
                                                            //print("items:\(items)")
                                                            //}
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["cpm_customer_product_stock"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["cpm_customer_product_stock"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                //for object in arrayListCustomer {
                                                                insertCustomerProductStock(arrayCPMCustomerProductStock: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                                insertDispatchBatchwiseStockCalculate(arrayCPMCustomerProductStock: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["cpm_customer_product_damage_stock"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["cpm_customer_product_damage_stock"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                
                                                                insertCustomerProductDamageStock(arrayCPMCustomerProductStock: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                                
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_distributor_return_request_product"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_distributor_return_request_product"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                
                                                                if customer_level == "L4" {
                                                                    insertDistributorReturnRequestProductNew(ishopDistributorReturnRequestProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                } else{
                                                                    insertDistributorReturnRequestProductNewForDist(ishopDistributorReturnRequestProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                }
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                            
                                                            
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_distributor_dispatch"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_distributor_dispatch"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertDistributorDispatchNew(ishopDistributorDispatch: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                                
                                                                
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_distributor_dispatch_product"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_distributor_dispatch_product"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                //for object in arrayListCustomer {
                                                                insertDistributorDispatchProductNew(ishopDistributorDispatchProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["extra_sticker_detail"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["extra_sticker_detail"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertExtraStickerDetail(arrayCfaDispatchProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_pallet_details"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_pallet_details"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertPalletDetails(arrayPalletDetails: jsonArrayEmployee.rawValue as! [[String : Any]],loginId: user_id, customerLevel: customer_level, roleCode: role_code,database: database)
                                                                
                                                                
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_extra_pallet_detail"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_extra_pallet_detail"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertPalletExtraStickerDetail(arrayCfaDispatchProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                
                                                                
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse?["ishop_distributor_received_product"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse!["ishop_distributor_received_product"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            database.open()
                                                            insertDistributorReceivedProductNew(ishopDistributorReceivedProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                            database.close()
                                                            //print("items:\(items)")
                                                            //}
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["sales_rep_initiated_product"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["sales_rep_initiated_product"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertSalesRepInitiatedProduct(jsonArraySalesRep: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                                
                                                                
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["sales_rep_initiated_product_current_limit"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["sales_rep_initiated_product_current_limit"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertSalesReturnCurrentLimit(arrayCurrentLimit: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                
                                                                
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_cfa_return_product"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_cfa_return_product"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertCFAReturnProductBulk(ishopCFAReturnProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                
                                                                
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_cfa_return"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_cfa_return"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertCFAReturnBulk(jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                
                                                                
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_distributor_return_request"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_distributor_return_request"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertDistributorReturnRequestBulk(jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                
                                                                
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                //DIST_SYNC_METHOD_CHK
                                            }
                                        }
                                    }
                                }
                            }
                            
                            if database.open() {
                                deleteSaveOfflineLogTable(database: database)
                                deleteUnreceivedValidData(database: database)
                                deleteRejectedOrder(database: database)
                                deleteDamageData(database: database)
                                deleteDeviceTokenTable(database: database)
                                deleteRejectedData(database: database)
                                deleteCfaDispatchIDNotInProductTable(database: database)
                                deleteCfaDispatchIDNotInMainTable(database: database)
                                deleteTransactionErrorLog(database: database)
                                //insertDelayedTransaction()
                                updateRetailerReceiveProductSyncFlag(database: database)
                                updateRetailerDispatchProductSyncFlag(database: database)
                                
                                if customer_level.uppercased() == "L3" {
                                    deleteDistributorReturnRequestData(customerId: user_id,database: database)
                                }
                                
                                
                            
                                database.close()
                            } else {
                                // Handle the case where the database couldn't be opened
                                print("Error opening database.")
                            }
                        }
                    }
                }
            }
        } else {
            print("File does not exist.")
        }
    } catch {
        print("Error: \(error)")
    }
    
}

//WH_SYNC_METHOD
func saveWHMasterData(downloadFileName: String, database:FMDatabase, zipFolderName:String,user_id:String,country_id:String,customer_level:String,role_code:String){
    
    do {
        
        //database.open()
        var tableName = ""
        let extractProcessStart = Date().timeIntervalSince1970 * 1000
        var totalRecords = 0
        var sdtStart = Date().timeIntervalSince1970 * 1000
        
        let fileManager = FileManager.default
        //let filePath = DownloadFileFromURL.parentpath + "/" + downloadFileName + "/0.txt"
        let filePath = downloadFileName + "/" + zipFolderName + "/0.txt"
        
        let filePath_directory = downloadFileName + "/" + zipFolderName
        
        print(filePath)
        
        if fileManager.fileExists(atPath: filePath) {
            if let jsonString = try? String(contentsOfFile: filePath) {
                
                let objectResponse_old = JSON(jsonString)
                
                if let jsonData = jsonString.data(using: .utf8) {
                    let objectResponse = try? JSON(data: jsonData)
                    
                    // Now you can use objectResponse as a SwiftyJSON object
                    if let status = objectResponse?["status"].bool, status == true {
                        
                        if((objectResponse?["Last_Sync_Date_Time"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["Last_Sync_Date_Time"]
                            
                            if(!jsonArrayEmployee.isEmpty){
                                do {
                                    if database.open() {
                                        //for object in arrayListCustomer {
                                        updateLastSyncDateTimeForWHMasterSync(jsonArrayEmployee.rawValue as! [[String : Any]],1,database: database)
                                        //print("items:\(items)")
                                        //}
                                        database.close()
                                    } else {
                                        // Handle the case where the database couldn't be opened
                                        print("Error opening database.")
                                    }
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                            
                        }
                        
                        
                        do {
                            // Get the contents of the directory at the specified path
                            let contents = try fileManager.contentsOfDirectory(atPath: filePath_directory)
                            
                            // Filter only directories
                            let directories = contents.filter { (itemName) -> Bool in
                                var isDirectory: ObjCBool = false
                                let itemPath = (filePath_directory as NSString).appendingPathComponent(itemName)
                                return fileManager.fileExists(atPath: itemPath, isDirectory: &isDirectory) && isDirectory.boolValue
                            }
                            
                            // Print the list of directories
                            print("List of Directories:")
                            for directory in directories {
                                
                                print("==========NEW FILE=====================")
                                
                                print(directory)
                                
                                
                                // Get the contents of the current directory
                                let directoryPath = (filePath_directory as NSString).appendingPathComponent(directory)
                                let directoryContents = try fileManager.contentsOfDirectory(atPath: directoryPath)
                                
                                // Filter only files
                                let files = directoryContents.filter { (itemName) -> Bool in
                                    var isDirectory: ObjCBool = false
                                    let itemPath = (directoryPath as NSString).appendingPathComponent(itemName)
                                    return fileManager.fileExists(atPath: itemPath, isDirectory: &isDirectory) && !isDirectory.boolValue
                                }
                                
                                let sortedFiles = files.sorted()
                                
                                // Print the list of files in the current directory
                                for file in sortedFiles {
                                    print("  - \(file)")
                                    
                                    let filePath_inner = downloadFileName + "/" + zipFolderName + "/" + directory + "/" + file
                                    
                                    if fileManager.fileExists(atPath: filePath_inner) {
                                        print("File 1.txt exists at path: \(filePath_inner)")
                                        
                                        if let jsonString_inner = try? String(contentsOfFile: filePath_inner) {
                                            
                                            
                                            if let jsonData_inner = jsonString_inner.data(using: .utf8) {
                                                let objectResponse_inner = try? JSON(data: jsonData_inner)
                                                
                                                
                                                
                                                if((objectResponse_inner?["ishop_sticker_details"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_sticker_details"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                //for object in arrayListCustomer {
                                                                insertStickerDetailsNew(stickerArray: jsonArrayEmployee.rawValue as! [[String : Any]],loginId: user_id, customerLevel: customer_level, roleCode: role_code,database: database)
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                /*if((objectResponse_inner?["ishop_cfa_dispatch_product"].exists()) != nil){
                                                 let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_cfa_dispatch_product"]
                                                 
                                                 if(!jsonArrayEmployee.isEmpty){
                                                 do {
                                                 if database.open() {
                                                 //for object in arrayListCustomer {
                                                 insertCFADispatchProductNew1(arrayCfaDispatchProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                 //print("items:\(items)")
                                                 //}
                                                 database.close()
                                                 } else {
                                                 // Handle the case where the database couldn't be opened
                                                 print("Error opening database.")
                                                 }
                                                 } catch {
                                                 print("Error: \(error)")
                                                 // Handle the error as needed, such as logging or displaying an alert
                                                 }
                                                 }
                                                 
                                                 }*/
                                                
                                                if((objectResponse_inner?["ishop_cfa_dispatch_product"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_cfa_dispatch_product"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                //for object in arrayListCustomer {
                                                                insertCFADispatchProductNew1(arrayCfaDispatchProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                
                                                if((objectResponse_inner?["ishop_sample_dispatch_product"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_sample_dispatch_product"]
                                                    
                                                    if database.open() {
                                                        if role_code == "FO" {
                                                            deleteSampleProductTable(database: database)
                                                        }
                                                        
                                                        if(!jsonArrayEmployee.isEmpty){
                                                            do {
                                                                //for object in arrayListCustomer {
                                                                insertSampleFocDispatchProduct(arraySampleDispatchProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                //print("items:\(items)")
                                                                //}
                                                            } catch {
                                                                print("Error: \(error)")
                                                                // Handle the error as needed, such as logging or displaying an alert
                                                            }
                                                        }
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database: ishop_sample_dispatch_product")
                                                    }
                                                    
                                                }
                                                
                                                /*if((objectResponse_inner?["employee_details"].exists()) != nil){
                                                 let jsonArrayEmployee:JSON = objectResponse_inner!["employee_details"]
                                                 
                                                 if(!jsonArrayEmployee.isEmpty){
                                                 do {
                                                 if database.open() {
                                                 //for object in arrayListCustomer {
                                                 insertEmployeeDetails(jsonArrayEmployeeDetails: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                 //print("items:\(items)")
                                                 //}
                                                 database.close()
                                                 } else {
                                                 // Handle the case where the database couldn't be opened
                                                 print("Error opening database.")
                                                 }
                                                 } catch {
                                                 print("Error: \(error)")
                                                 // Handle the error as needed, such as logging or displaying an alert
                                                 }
                                                 }
                                                 
                                                 }*/
                                                
                                                if((objectResponse_inner?["ishop_sticker"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_sticker"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                
                                                                /*if (role_code.equalsIgnoreCase("FO")) {
                                                                 databaseCRUD.InsertIshopStickerNew(jsonArrayEmployee);
                                                                 } else if (customer_level.equalsIgnoreCase("L2")) {
                                                                 databaseCRUD.InsertIshopStickerNew(jsonArrayEmployee);
                                                                 } else {
                                                                 //                                                databaseCRUD.InsertStickerNew(jsonArrayEmployee, item);
                                                                 databaseCRUD.InsertIshopStickerNew(jsonArrayEmployee);
                                                                 }*/
                                                                insertIshopStickerNew(ishopSticker: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_toller_dispatch"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_toller_dispatch"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                //for object in arrayListCustomer {
                                                                insertTollerDispatchNew(ishopTollerDispatch: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_toller_dispatch_product"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_toller_dispatch_product"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                //for object in arrayListCustomer {
                                                                insertTollerDispatchProductNew(ishopTollerDispatchProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                
                                                
                                                if((objectResponse_inner?["ishop_cfa_dispatch"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_cfa_dispatch"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                //for object in arrayListCustomer {
                                                                insertCFADispatchNew(ishopCFADispatch: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_sample_dispatch"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_sample_dispatch"]
                                                    
                                                    if role_code == "FO" {
                                                        deleteSampleMainTable(database: database)
                                                    }
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                //for object in arrayListCustomer {
                                                                insertSampleFocDispatchMain(ishopCFADispatch: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["cpm_customer_product_stock"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["cpm_customer_product_stock"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                //for object in arrayListCustomer {
                                                                insertCustomerProductStock(arrayCPMCustomerProductStock: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                                insertDispatchBatchwiseStockCalculate(arrayCPMCustomerProductStock: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["cpm_customer_product_damage_stock"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["cpm_customer_product_damage_stock"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                
                                                                insertCustomerProductDamageStock(arrayCPMCustomerProductStock: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                                
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_distributor_return_request_product"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_distributor_return_request_product"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            if database.open() {
                                                                
                                                                if customer_level == "L4" {
                                                                    insertDistributorReturnRequestProductNew(ishopDistributorReturnRequestProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                } else{
                                                                    insertDistributorReturnRequestProductNewForDist(ishopDistributorReturnRequestProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                }
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                            
                                                            
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_distributor_dispatch"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_distributor_dispatch"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertDistributorDispatchNew(ishopDistributorDispatch: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                                
                                                                
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["extra_sticker_detail"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["extra_sticker_detail"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertExtraStickerDetail(arrayCfaDispatchProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_pallet_details"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_pallet_details"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertPalletDetails(arrayPalletDetails: jsonArrayEmployee.rawValue as! [[String : Any]],loginId: user_id, customerLevel: customer_level, roleCode: role_code,database: database)
                                                                
                                                                
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_extra_pallet_detail"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_extra_pallet_detail"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertPalletExtraStickerDetail(arrayCfaDispatchProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                
                                                                
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["bf_scm_cpm_integration_data"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["bf_scm_cpm_integration_data"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertScmData(jsonScmData: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                
                                                                
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_cfa_return_product"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_cfa_return_product"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertCFAReturnProductBulk(ishopCFAReturnProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                
                                                                
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_cfa_return"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_cfa_return"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertCFAReturnBulk(jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                
                                                                
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                if((objectResponse_inner?["ishop_distributor_return_request"].exists()) != nil){
                                                    let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_distributor_return_request"]
                                                    
                                                    if(!jsonArrayEmployee.isEmpty){
                                                        do {
                                                            //for object in arrayListCustomer {
                                                            if database.open() {
                                                                insertDistributorReturnRequestBulk(jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                                
                                                                
                                                                //print("items:\(items)")
                                                                //}
                                                                database.close()
                                                            } else {
                                                                // Handle the case where the database couldn't be opened
                                                                print("Error opening database.")
                                                            }
                                                        } catch {
                                                            print("Error: \(error)")
                                                            // Handle the error as needed, such as logging or displaying an alert
                                                        }
                                                    }
                                                    
                                                }
                                                
                                                
                                                //CHECK_HERE_WH
                                                //inside_DIR_INSERT
                                                
                                                //////
                                            }
                                        }
                                    }
                                }
                            }
                            
                            if database.open() {
                                deleteSaveOfflineLogTable(database: database)
                                deleteUnreceivedValidData(database: database)
                                deleteRejectedOrder(database: database)
                                deleteDamageData(database: database)
                                deleteDeviceTokenTable(database: database)
                                deleteRejectedData(database: database)
                                deleteCfaDispatchIDNotInProductTable(database: database)
                                deleteCfaDispatchIDNotInMainTable(database: database)
                                deleteTransactionErrorLog(database: database)
                                //insertDelayedTransaction()
                                updateRetailerReceiveProductSyncFlag(database: database)
                                updateRetailerDispatchProductSyncFlag(database: database)
                                
                                if customer_level.uppercased() == "L3" {
                                    deleteDistributorReturnRequestData(customerId: user_id,database: database)
                                }
                                
                                
                                
                                database.close()
                            } else {
                                // Handle the case where the database couldn't be opened
                                print("Error opening database.")
                            }
                            
                            
                            //out_for_dir
                        } catch {
                            // Handle the error if unable to get contents
                            print("Error: \(error)")
                        }
                    }
                }
            }
        } else {
            print("File does not exist.")
        }
    } catch {
        print("Error: \(error)")
    }
    
}

func saveMasterData(downloadFileName: String, database:FMDatabase, zipFolderName:String,user_id:String,country_id:String,customer_level:String,role_code:String) {
    do {
        
        //database.open()
        var tableName = ""
        let extractProcessStart = Date().timeIntervalSince1970 * 1000
        var totalRecords = 0
        var sdtStart = Date().timeIntervalSince1970 * 1000
        
        let fileManager = FileManager.default
        //let filePath = DownloadFileFromURL.parentpath + "/" + downloadFileName + "/0.txt"
        let filePath = downloadFileName + "/" + zipFolderName + "/0.txt"
        
        let filePath_directory = downloadFileName + "/" + zipFolderName
        
        print(filePath)
        
        if fileManager.fileExists(atPath: filePath) {
            if let jsonString = try? String(contentsOfFile: filePath) {
                // if let objectResponse = try? JSONSerialization.jsonObject(with: jsonString.data(using: .utf8)!, options: []) as? [String: Any] {
                
                let objectResponse_old = JSON(jsonString)
                
                if let jsonData = jsonString.data(using: .utf8) {
                    let objectResponse = try? JSON(data: jsonData)
                    
                    // Now you can use objectResponse as a SwiftyJSON object
                    if let status = objectResponse?["status"].bool, status == true {
                        print("Status is true")
                        
                        if((objectResponse?["master_new_customer"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["master_new_customer"]
                            
                            if(arrayListCustomer.count > 0){
                                arrayListCustomer.removeAll()
                            }
                            
                            if let jsonArray = jsonArrayEmployee.array {
                                for jsonItem in jsonArray {
                                    // Create an instance of CreateNewCustomer using SwiftyJSON's convenient initializer
                                    if let customer = CreateNewCustomer(json: jsonItem) {
                                        // Append the customer to the array
                                        arrayListCustomer.append(customer)
                                    }
                                }
                            }
                            
                            if(arrayListCustomer.count > 0){
                                do {
                                    database.open()
                                    database.executeUpdate("DELETE FROM \(DBHelper.TABLE_NEW_CUSTOMER)", withArgumentsIn: [])
                                    
                                    for object in arrayListCustomer {
                                        let items = insertNewCustomer(object,database: database)
                                        print("items:\(items)")
                                    }
                                    database.close()
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                        }
                        
                        //sleep(2)
                        
                        if((objectResponse?["ishop_retailer_dispatch"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["ishop_retailer_dispatch"]
                            
                            if(!jsonArrayEmployee.isEmpty){
                                
                                do {
                                    database.open()
                                    //for object in arrayListCustomer {
                                    let items = insertRetailerDispatchNew(jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                    print("items:\(items)")
                                    database.close()
                                    //}
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                            
                        }
                        //sleep(2)
                        //insert done
                        if((objectResponse?["ishop_distributor_return"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["ishop_distributor_return"]
                            if(!jsonArrayEmployee.isEmpty){
                                
                                do {
                                    database.open()
                                    //for object in arrayListCustomer {
                                    insertDistributorReturnNew(jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                    database.close()
                                    //print("items:\(items)")
                                    //}
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                            
                        }
                        //sleep(2)
                        //insert done mst
                        if((objectResponse?["Menu_Access"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["Menu_Access"]
                            
                            if(arrayListMenuAccess.count > 0){
                                arrayListMenuAccess.removeAll()
                            }
                            
                            if let jsonArray = jsonArrayEmployee.array {
                                for jsonItem in jsonArray {
                                    
                                    // Create an instance of CreateNewCustomer using SwiftyJSON's convenient initializer
                                    if let customer = MenuAccess(json: jsonItem) {
                                        // Append the customer to the array
                                        arrayListMenuAccess.append(customer)
                                    }
                                }
                            }
                            
                            if(arrayListMenuAccess.count > 0){
                                do {
                                    
                                    if database.open() {
                                        let str = "DELETE FROM \(DBHelper.TABLE_MENU_ACCESS)"
                                        database.executeUpdate(str, withArgumentsIn: [])
                                        for object in arrayListMenuAccess {
                                            let items = insertMenuAccess(object,database: database)
                                            print("items:\(items)")
                                        }
                                        database.close()
                                    } else {
                                        // Handle the case where the database couldn't be opened
                                        print("Error opening database.")
                                    }
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                        }
                        //sleep(2)
                        //politicallevel
                        
                        if((objectResponse?["Political_Level"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["Political_Level"]
                            
                            if(arrayListPoliticalLevel.count > 0){
                                arrayListPoliticalLevel.removeAll()
                            }
                            
                            if let jsonArray = jsonArrayEmployee.array {
                                for jsonItem in jsonArray {
                                    // Create an instance of CreateNewCustomer using SwiftyJSON's convenient initializer
                                    if let customer = PoliticalLevel(json: jsonItem) {
                                        // Append the customer to the array
                                        arrayListPoliticalLevel.append(customer)
                                    }
                                }
                            }
                            
                            if(arrayListPoliticalLevel.count > 0){
                                do {
                                    
                                    if database.open() {
                                        
                                        database.executeUpdate("DELETE FROM \(DBHelper.TABLE_POLITICAL_LEVEL)", withArgumentsIn: [])
                                        for object in arrayListPoliticalLevel {
                                            insertPoliticalLevel(object,database: database)
                                            //print("items:\(items)")
                                        }
                                        database.close()
                                    } else {
                                        // Handle the case where the database couldn't be opened
                                        print("Error opening database.")
                                    }
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                        }
                        //sleep(2)
                        if((objectResponse?["ishop_distributor_received"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["ishop_distributor_received"]
                            
                            if(!jsonArrayEmployee.isEmpty){
                                do {
                                    //for object in arrayListCustomer {
                                    database.open()
                                    insertDistributorReturnNew(jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                    database.close()
                                    //print("items:\(items)")
                                    //}
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                            
                        }
                        //sleep(2)
                        if((objectResponse?["ishop_distributor_received_product"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["ishop_distributor_received_product"]
                            
                            if(!jsonArrayEmployee.isEmpty){
                                do {
                                    //for object in arrayListCustomer {
                                    database.open()
                                    insertDistributorReceivedProductNew(ishopDistributorReceivedProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                    database.close()
                                    //print("items:\(items)")
                                    //}
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                            
                        }
                        
                        //sleep(2)
                        // INSERT DONE
                        if((objectResponse?["ishop_customer_scaned_in_sticker"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["ishop_customer_scaned_in_sticker"]
                            
                            
                            if(arrayListScannedPoints.count > 0){
                                arrayListScannedPoints.removeAll()
                            }
                            
                            if let jsonArray = jsonArrayEmployee.array {
                                for jsonItem in jsonArray {
                                    // Create an instance of CreateNewCustomer using SwiftyJSON's convenient initializer
                                    if let customer = ScannedPoints(json: jsonItem) {
                                        // Append the customer to the array
                                        arrayListScannedPoints.append(customer)
                                    }
                                }
                            }
                            
                            if(arrayListScannedPoints.count > 0){
                                do {
                                    
                                    if database.open() {
                                        
                                        database.executeUpdate("DELETE FROM \(DBHelper.TABLE_RETAILER_SCANNED_IN_STICKER)", withArgumentsIn: [])
                                        for object in arrayListScannedPoints {
                                            insertRetailerScannedIn(object,database: database)
                                            //print("items:\(items)")
                                        }
                                        database.close()
                                    } else {
                                        // Handle the case where the database couldn't be opened
                                        print("Error opening database.")
                                    }
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                        }
                        //sleep(2)
                        //=========================================
                        if((objectResponse?["ishop_customer_scaned_out_sticker"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["ishop_customer_scaned_out_sticker"]
                            
                            if(!jsonArrayEmployee.isEmpty){
                                do {
                                    if database.open() {
                                        //for object in arrayListCustomer {
                                        insertRetailerScannedOutSticker(jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                        //print("items:\(items)")
                                        //}
                                        database.close()
                                    }else {
                                        // Handle the case where the database couldn't be opened
                                        print("Error opening database.")
                                    }
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                            
                        }
                        
                        //sleep(2)
                        //insert done
                        if((objectResponse?["ctocmapping"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["ctocmapping"]
                            
                            if(arrayListCtoCMapping.count > 0){
                                arrayListCtoCMapping.removeAll()
                            }
                            
                            if let jsonArray = jsonArrayEmployee.array {
                                for jsonItem in jsonArray {
                                    // Create an instance of CreateNewCustomer using SwiftyJSON's convenient initializer
                                    if let customer = CtoCMapping(json: jsonItem) {
                                        // Append the customer to the array
                                        arrayListCtoCMapping.append(customer)
                                    }
                                }
                            }
                            
                            if(arrayListCtoCMapping.count > 0){
                                do {
                                    
                                    if database.open() {
                                        
                                        database.executeUpdate("DELETE FROM \(DBHelper.TABLE_CTOCMAPPING)", withArgumentsIn: [])
                                        for object in arrayListCtoCMapping {
                                            let items = InsertCtoCMapping(object,database: database)
                                            print("items:\(items)")
                                        }
                                        database.close()
                                    } else {
                                        // Handle the case where the database couldn't be opened
                                        print("Error opening database.")
                                    }
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                        }
                        //sleep(2)
                        if((objectResponse?["ctoemapping"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["ctoemapping"]
                            
                            if(arrayListCtoEMapping.count > 0){
                                arrayListCtoEMapping.removeAll()
                            }
                            
                            if let jsonArray = jsonArrayEmployee.array {
                                for jsonItem in jsonArray {
                                    // Create an instance of CreateNewCustomer using SwiftyJSON's convenient initializer
                                    if let customer = CtoEMapping(json: jsonItem) {
                                        // Append the customer to the array
                                        arrayListCtoEMapping.append(customer)
                                    }
                                }
                            }
                            
                            if(arrayListCtoEMapping.count > 0){
                                do {
                                    
                                    if database.open() {
                                        
                                        database.executeUpdate("DELETE FROM \(DBHelper.TABLE_CTOEMAPPING)", withArgumentsIn: [])
                                        for object in arrayListCtoEMapping {
                                            let items = InsertCtoEMapping(object,database: database)
                                            print("items:\(items)")
                                        }
                                        database.close()
                                    } else {
                                        // Handle the case where the database couldn't be opened
                                        print("Error opening database.")
                                    }
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                        }
                        //sleep(2)
                        //+++++++++++++++++++++++
                        if((objectResponse?["user_configuration_mst"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["user_configuration_mst"]
                            
                            if(arrayListUserConfigurationMst.count > 0){
                                arrayListUserConfigurationMst.removeAll()
                            }
                            if let jsonArray = jsonArrayEmployee.array {
                                for jsonItem in jsonArray {
                                    // Create an instance of CreateNewCustomer using SwiftyJSON's convenient initializer
                                    if let customer = UserConfigurationMst(json: jsonItem) {
                                        // Append the customer to the array
                                        arrayListUserConfigurationMst.append(customer)
                                    }
                                }
                            }
                            
                            if(arrayListUserConfigurationMst.count > 0){
                                do {
                                    
                                    if database.open() {
                                        
                                        database.executeUpdate("DELETE FROM \(DBHelper.USER_CONFIGURATION_MST)", withArgumentsIn: [])
                                        for object in arrayListUserConfigurationMst {
                                            insertUserConfigurationMst(object,database: database)
                                            //print("items:\(items)")
                                        }
                                        database.close()
                                    } else {
                                        // Handle the case where the database couldn't be opened
                                        print("Error opening database.")
                                    }
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                        }
                        //sleep(2)
                        //###############
                        if((objectResponse?["Last_Sync_Date_Time"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["Last_Sync_Date_Time"]
                            
                            if(!jsonArrayEmployee.isEmpty){
                                do {
                                    if database.open() {
                                        //for object in arrayListCustomer {
                                        updateLastSyncDateTimeForWHMasterSync(jsonArrayEmployee.rawValue as! [[String : Any]],2,database: database)
                                        //print("items:\(items)")
                                        //}
                                        database.close()
                                    } else {
                                        // Handle the case where the database couldn't be opened
                                        print("Error opening database.")
                                    }
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                            
                        }
                        //sleep(2)
                        //arrayListCustomerType_Details
                        
                        if((objectResponse?["CustomerType_Details"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["CustomerType_Details"]
                            
                            if(arrayListCustomerType_Details.count > 0){
                                arrayListCustomerType_Details.removeAll()
                            }
                            
                            if let jsonArray = jsonArrayEmployee.array {
                                for jsonItem in jsonArray {
                                    // Create an instance of CreateNewCustomer using SwiftyJSON's convenient initializer
                                    if let customer = CustomerTypeDetails(json: jsonItem) {
                                        // Append the customer to the array
                                        arrayListCustomerType_Details.append(customer)
                                    }
                                }
                            }
                            
                            if(arrayListCustomerType_Details.count > 0){
                                do {
                                    
                                    if database.open() {
                                        
                                        database.executeUpdate("DELETE FROM \(DBHelper.TABLE_CustomerType_Details)", withArgumentsIn: [])
                                        for object in arrayListCustomerType_Details {
                                            insertCustomerTypeDetails(object,database: database)
                                            //print("items:\(items)")
                                        }
                                        database.close()
                                    } else {
                                        // Handle the case where the database couldn't be opened
                                        print("Error opening database.")
                                    }
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                        }
                        //sleep(2)
                        if((objectResponse?["etormapping"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["etormapping"]
                            
                            if(!jsonArrayEmployee.isEmpty){
                                do {
                                    //for object in arrayListCustomer {
                                    insertETORMAPPINGNew(jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                    //print("items:\(items)")
                                    //}
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                            
                        }
                        //sleep(2)
                        if((objectResponse?["rtormapping"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["rtormapping"]
                            
                            if(!jsonArrayEmployee.isEmpty){
                                do {
                                    //for object in arrayListCustomer {
                                    insertRtoRMappingNew(jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                    //print("items:\(items)")
                                    //}
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                            
                        }
                        //sleep(2)
                        if((objectResponse?["dtormapping"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["dtormapping"]
                            
                            if(!jsonArrayEmployee.isEmpty){
                                do {
                                    //for object in arrayListCustomer {
                                    insertDtoRMappingNew(jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                    //print("items:\(items)")
                                    //}
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                            
                        }
                        //sleep(2)
                        ///////////////////////////////////////
                        if((objectResponse?["lookup_values_config"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["lookup_values_config"]
                            
                            if(jsonArrayEmployee.isEmpty){
                                do {
                                    //for object in arrayListCustomer {
                                    
                                    if database.open() {
                                        deleteLookUpTable(database: database)
                                        //print("items:\(items)")
                                        //}
                                        database.close()
                                    } else {
                                        // Handle the case where the database couldn't be opened
                                        print("Error opening database.")
                                    }
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            } else {
                                do {
                                    if database.open() {
                                        insertLookUpValuesConfig(jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                        database.close()
                                    } else {
                                        // Handle the case where the database couldn't be opened
                                        print("Error opening database.")
                                    }
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                            
                        }
                        
                        //sleep(2)
                        if((objectResponse?["User_Help_Video"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["User_Help_Video"]
                            
                            if(!jsonArrayEmployee.isEmpty){
                                do {
                                    if database.open() {
                                        //for object in arrayListCustomer {
                                        insertHelpVideoData(videoArray: jsonArrayEmployee.rawValue as! [[String : Any]],loginId: user_id, countryID: country_id,database: database)
                                        //print("items:\(items)")
                                        //}
                                        database.close()
                                    } else {
                                        // Handle the case where the database couldn't be opened
                                        print("Error opening database.")
                                    }
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                            
                        }
                        //sleep(2)
                        if((objectResponse?["master_reason"].exists()) != nil){
                            let jsonArrayEmployee:JSON = objectResponse!["master_reason"]
                            
                            if(!jsonArrayEmployee.isEmpty){
                                do {
                                    if database.open() {
                                        //for object in arrayListCustomer {
                                        insertMasterReason(videoArray: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                        //print("items:\(items)")
                                        //}
                                        database.close()
                                    } else {
                                        // Handle the case where the database couldn't be opened
                                        print("Error opening database.")
                                    }
                                } catch {
                                    print("Error: \(error)")
                                    // Handle the error as needed, such as logging or displaying an alert
                                }
                            }
                            
                        }
                        //BEFORE_DIR_INSERT
                        
                    } else {
                        print("Status is not true or does not exist")
                    }
                } else {
                    print("Invalid JSON string")
                }
                
                //BEFORE_DIR_INSERT
                
                do {
                    // Get the contents of the directory at the specified path
                    let contents = try fileManager.contentsOfDirectory(atPath: filePath_directory)
                    
                    // Filter only directories
                    let directories = contents.filter { (itemName) -> Bool in
                        var isDirectory: ObjCBool = false
                        let itemPath = (filePath_directory as NSString).appendingPathComponent(itemName)
                        return fileManager.fileExists(atPath: itemPath, isDirectory: &isDirectory) && isDirectory.boolValue
                    }
                    
                    // Print the list of directories
                    print("List of Directories:")
                    for directory in directories {
                        
                        print("==========NEW FILE=====================")
                        
                        print(directory)
                        
                        // Get the contents of the current directory
                        let directoryPath = (filePath_directory as NSString).appendingPathComponent(directory)
                        let directoryContents = try fileManager.contentsOfDirectory(atPath: directoryPath)
                        
                        // Filter only files
                        let files = directoryContents.filter { (itemName) -> Bool in
                            var isDirectory: ObjCBool = false
                            let itemPath = (directoryPath as NSString).appendingPathComponent(itemName)
                            return fileManager.fileExists(atPath: itemPath, isDirectory: &isDirectory) && !isDirectory.boolValue
                        }
                        
                        let sortedFiles = files.sorted()
                        // Print the list of files in the current directory
                        for file in sortedFiles {
                            print("  - \(file)")
                            
                            
                            
                            let filePath_inner = downloadFileName + "/" + zipFolderName + "/" + directory + "/" + file
                            
                            print("file_innerPath:\(filePath_inner)")
                            
                            if fileManager.fileExists(atPath: filePath_inner) {
                                print("File 1.txt exists at path: \(filePath_inner)")
                                
                                if let jsonString_inner = try? String(contentsOfFile: filePath_inner) {
                                    
                                    
                                    if let jsonData_inner = jsonString_inner.data(using: .utf8) {
                                        let objectResponse_inner = try? JSON(data: jsonData_inner)
                                        
                                        
                                        
                                        if((objectResponse_inner?["ishop_sticker_details"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_sticker_details"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                
                                                //sleep(2)
                                                
                                                do {
                                                    if database.open() {
                                                        //for object in arrayListCustomer {
                                                        insertStickerDetailsNew(stickerArray: jsonArrayEmployee.rawValue as! [[String : Any]],loginId: user_id, customerLevel: customer_level, roleCode: role_code,database: database)
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["ishop_cfa_dispatch_product"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_cfa_dispatch_product"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                
                                                //sleep(2)
                                                
                                                do {
                                                    if database.open() {
                                                        //for object in arrayListCustomer {
                                                        insertCFADispatchProductNew1(arrayCfaDispatchProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["ishop_cfa_dispatch_product"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_cfa_dispatch_product"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                
                                                //sleep(2)
                                                
                                                do {
                                                    if database.open() {
                                                        //for object in arrayListCustomer {
                                                        insertCFADispatchProductNew1(arrayCfaDispatchProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        
                                        if((objectResponse_inner?["ishop_sample_dispatch_product"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_sample_dispatch_product"]
                                            
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                
                                                if role_code == "FO" {
                                                    deleteSampleProductTable(database: database)
                                                }
                                                if database.open() {
                                                    
                                                    
                                                    
                                                    do {
                                                        //for object in arrayListCustomer {
                                                        insertSampleFocDispatchProduct(arraySampleDispatchProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                        //print("items:\(items)")
                                                        //}
                                                    } catch {
                                                        print("Error: \(error)")
                                                        // Handle the error as needed, such as logging or displaying an alert
                                                    }
                                                    
                                                    database.close()
                                                } else {
                                                    // Handle the case where the database couldn't be opened
                                                    print("Error opening database.")
                                                }
                                            }
                                            
                                            
                                        }
                                        
                                        
                                        if((objectResponse_inner?["customer_details"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["customer_details"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    if database.open() {
                                                        insertCustomerDetails(jsonArrayCustomerDetails: jsonArrayEmployee.rawValue as! [[String : Any]], fileName: file, database: database)
                                                        updateLoginDetails(arrayCustomerDetails: jsonArrayEmployee.rawValue as! [[String : Any]], database: database)
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        
                                        if((objectResponse_inner?["employee_details"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["employee_details"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    if database.open() {
                                                        //for object in arrayListCustomer {
                                                        insertEmployeeDetails(jsonArrayEmployeeDetails: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["ishop_sticker"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_sticker"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    if database.open() {
                                                        //for object in arrayListCustomer {
                                                        insertIshopStickerNew(ishopSticker: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["ishop_toller_dispatch"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_toller_dispatch"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    if database.open() {
                                                        //for object in arrayListCustomer {
                                                        insertTollerDispatchNew(ishopTollerDispatch: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["ishop_toller_dispatch_product"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_toller_dispatch_product"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    if database.open() {
                                                        //for object in arrayListCustomer {
                                                        insertTollerDispatchProductNew(ishopTollerDispatchProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["ishop_distributor_dispatch_product"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_distributor_dispatch_product"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    if database.open() {
                                                        //for object in arrayListCustomer {
                                                        insertDistributorDispatchProductNew(ishopDistributorDispatchProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["product_sku_country"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["product_sku_country"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    if database.open() {
                                                        insertProductSkuCountry(arrayProductSkuCountry: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                        
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["ishop_distributor_received_product"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_distributor_received_product"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    if database.open() {
                                                        //for object in arrayListCustomer {
                                                        insertDistributorReceivedProductNew(ishopDistributorReceivedProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["ishop_distributor_return_product"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_distributor_return_product"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    if database.open() {
                                                        //for object in arrayListCustomer {
                                                        insertDistributorReturnProductNew(ishopDistributorReturnProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["ishop_retailer_dispatch_product"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_retailer_dispatch_product"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    if database.open() {
                                                        //for object in arrayListCustomer {
                                                        insertRetailerDispatchProductNew(ishopRetailerDispatchProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["ishop_retailer_received_product"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_retailer_received_product"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    if database.open() {
                                                        //for object in arrayListCustomer {
                                                        insertRetailerReceivedProductNew(ishopRetailerReceivedProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["product_type_name_country"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["product_type_name_country"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    if database.open() {
                                                        //for object in arrayListCustomer {
                                                        insertProductTypeNameCountry(arrayProductTypeCountryName: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["Scheme_Master"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["Scheme_Master"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    if database.open() {
                                                        //for object in arrayListCustomer {
                                                        insertSchemeMaster(jsonArray: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["ishop_cfa_dispatch"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_cfa_dispatch"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    if database.open() {
                                                        //for object in arrayListCustomer {
                                                        insertCFADispatchNew(ishopCFADispatch: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        
                                        if((objectResponse_inner?["ishop_sample_dispatch"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_sample_dispatch"]
                                            
                                            //sleep(2)
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                do {
                                                    if database.open() {
                                                        if role_code == "FO" {
                                                            deleteSampleMainTable(database: database)
                                                        }
                                                        //for object in arrayListCustomer {
                                                        insertSampleFocDispatchMain(ishopCFADispatch: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        
                                        if((objectResponse_inner?["cpm_customer_product_stock"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["cpm_customer_product_stock"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    if database.open() {
                                                        //for object in arrayListCustomer {
                                                        insertCustomerProductStock(arrayCPMCustomerProductStock: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                        insertDispatchBatchwiseStockCalculate(arrayCPMCustomerProductStock: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["ishop_distributor_return_request_product"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_distributor_return_request_product"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    if database.open() {
                                                        //for object in arrayListCustomer {
                                                        if customer_level == "L4" {
                                                            insertDistributorReturnRequestProductNew(ishopDistributorReturnRequestProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                        } else{
                                                            insertDistributorReturnRequestProductNewForDist(ishopDistributorReturnRequestProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                        }
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                    
                                                    //print("items:\(items)")
                                                    //}
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["ishop_distributor_dispatch"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_distributor_dispatch"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    //for object in arrayListCustomer {
                                                    if database.open() {
                                                        insertDistributorDispatchNew(ishopDistributorDispatch: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                        
                                                        
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["sales_rep_initiated_product"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["sales_rep_initiated_product"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    //for object in arrayListCustomer {
                                                    if database.open() {
                                                        insertSalesRepInitiatedProduct(jsonArraySalesRep: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                        
                                                        
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["ishop_retailer_received"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_retailer_received"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    //for object in arrayListCustomer {
                                                    if database.open() {
                                                        insertRetailerReceivedNew(ishopRetailerReceived: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                        
                                                        
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["Political_Details"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["Political_Details"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    //for object in arrayListCustomer {
                                                    if database.open() {
                                                        insertPoliticalDetails(arrayPoliticalDetails: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                        
                                                        
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["Political_Details_Emp"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["Political_Details_Emp"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    //for object in arrayListCustomer {
                                                    if database.open() {
                                                        insertPoliticalDetailsEmp(arrayPoliticalDetailsEmp: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                        
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        
                                        
                                        if((objectResponse_inner?["extra_sticker_detail"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["extra_sticker_detail"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    //for object in arrayListCustomer {
                                                    if database.open() {
                                                        insertExtraStickerDetail(arrayCfaDispatchProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                        
                                                        
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["ishop_retailer_return"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_retailer_return"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    //for object in arrayListCustomer {
                                                    if database.open() {
                                                        insertRetailerReturnNew(ishopRetailerReturn: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                        
                                                        
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["ishop_retailer_return_product"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_retailer_return_product"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    //for object in arrayListCustomer {
                                                    if database.open() {
                                                        insertRetailerReturnProductNew(ishopRetailerReturnProduct: jsonArrayEmployee.rawValue as! [[String : Any]],fileName:file,database: database)
                                                        
                                                        
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["sales_rep_initiated_product_current_limit"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["sales_rep_initiated_product_current_limit"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    //for object in arrayListCustomer {
                                                    if database.open() {
                                                        insertSalesReturnCurrentLimit(arrayCurrentLimit: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                        
                                                        
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["ishop_pallet_details"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_pallet_details"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    //for object in arrayListCustomer {
                                                    if database.open() {
                                                        insertPalletDetails(arrayPalletDetails: jsonArrayEmployee.rawValue as! [[String : Any]],loginId: user_id, customerLevel: customer_level, roleCode: role_code,database: database)
                                                        
                                                        
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["ishop_extra_pallet_detail"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_extra_pallet_detail"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    //for object in arrayListCustomer {
                                                    if database.open() {
                                                        insertPalletExtraStickerDetail(arrayCfaDispatchProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                        
                                                        
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["bf_scm_cpm_integration_data"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["bf_scm_cpm_integration_data"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    //for object in arrayListCustomer {
                                                    if database.open() {
                                                        insertScmData(jsonScmData: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                        
                                                        
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["ishop_cfa_return_product"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_cfa_return_product"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    //for object in arrayListCustomer {
                                                    if database.open() {
                                                        insertCFAReturnProductBulk(ishopCFAReturnProduct: jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                        
                                                        
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["ishop_cfa_return"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_cfa_return"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    //for object in arrayListCustomer {
                                                    if database.open() {
                                                        insertCFAReturnBulk(jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                        
                                                        
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        if((objectResponse_inner?["ishop_distributor_return_request"].exists()) != nil){
                                            let jsonArrayEmployee:JSON = objectResponse_inner!["ishop_distributor_return_request"]
                                            
                                            if(!jsonArrayEmployee.isEmpty){
                                                //sleep(2)
                                                do {
                                                    //for object in arrayListCustomer {
                                                    if database.open() {
                                                        insertDistributorReturnRequestBulk(jsonArrayEmployee.rawValue as! [[String : Any]],database: database)
                                                        
                                                        
                                                        //print("items:\(items)")
                                                        //}
                                                        database.close()
                                                    } else {
                                                        // Handle the case where the database couldn't be opened
                                                        print("Error opening database.")
                                                    }
                                                } catch {
                                                    print("Error: \(error)")
                                                    // Handle the error as needed, such as logging or displaying an alert
                                                }
                                            }
                                            
                                        }
                                        
                                        
                                        
                                        
                                        //inside_DIR_INSERT
                                        
                                        //////
                                    }
                                }
                            }
                            
                        }
                    }
                    
                    //sleep(2)
                    
                    if database.open() {
                        deleteSaveOfflineLogTable(database: database)
                        deleteUnreceivedValidData(database: database)
                        deleteRejectedOrder(database: database)
                        deleteDamageData(database: database)
                        deleteDeviceTokenTable(database: database)
                        deleteRejectedData(database: database)
                        deleteCfaDispatchIDNotInProductTable(database: database)
                        deleteCfaDispatchIDNotInMainTable(database: database)
                        deleteTransactionErrorLog(database: database)
                        //insertDelayedTransaction()
                        
                        if customer_level.uppercased() == "L3" {
                            deleteDistributorReturnRequestData(customerId: user_id,database: database)
                        }
                        database.close()
                    } else {
                        // Handle the case where the database couldn't be opened
                        print("Error opening database.")
                    }
                    
                    
                    //out_for_dir
                } catch {
                    // Handle the error if unable to get contents
                    print("Error: \(error)")
                }
                
                // database.close()
                
                
                
                
                
            }
            //  }
            //}
        } else {
            print("File does not exist.")
        }
    } catch {
        print("Error: \(error)")
    }
    
}

// other methods

func insertNewCustomer(_ object: CreateNewCustomer, database:FMDatabase) -> Bool {
    var success = false
    
    var contentValues = [String: Any]()
    contentValues[DBHelper.KEY_CUSTOMER_NAME] = object.customerName
    contentValues[DBHelper.KEY_CUSTOMER_TYPE_COUNTY_ID] = object.customerTypeCountyId
    contentValues[DBHelper.KEY_MOBILE_NO] = object.mobileNo
    contentValues[DBHelper.KEY_CREATED_BY_USER] = object.createdByUser
    contentValues[DBHelper.KEY_CREATE_ON] = object.createdOn
    contentValues[DBHelper.KEY_SYNC_CODE] = object.syncCode
    contentValues[DBHelper.KEY_SYNC_FLAG] = object.syncFlag
    contentValues[DBHelper.KEY_SYNC_DATE] = object.syncDate
    contentValues[DBHelper.KEY_SYNC_USER] = object.syncByUser
    
    do {
        let valuesArray = Array(contentValues.values)
        try database.executeUpdate("INSERT INTO \(DBHelper.TABLE_NEW_CUSTOMER) " +
                                   "(\(DBHelper.KEY_CUSTOMER_NAME), " +
                                   "\(DBHelper.KEY_CUSTOMER_TYPE_COUNTY_ID), " +
                                   "\(DBHelper.KEY_MOBILE_NO), " +
                                   "\(DBHelper.KEY_CREATED_BY_USER), " +
                                   "\(DBHelper.KEY_CREATE_ON), " +
                                   "\(DBHelper.KEY_SYNC_CODE), " +
                                   "\(DBHelper.KEY_SYNC_FLAG), " +
                                   "\(DBHelper.KEY_SYNC_DATE), " +
                                   "\(DBHelper.KEY_SYNC_USER)) " +
                                   "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)",
                                   values: valuesArray)
        print("TABLE NEW CUSTOMER INSERT SUCCESSFULLY")
        success = true
    } catch {
        print("FMDB exception: \(error)")
        // Handle the error as needed
    }
    
    return success
}

func insertRetailerDispatchNew(_ ishopRetailerDispatch: [[String: Any]], database:FMDatabase) {
    if !DBHelper.OPTIMIZE_MAIN_TABLE {
        do {
            try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_RETAILER_DISPATCH)", values: nil)
            database.beginTransaction()
            
            let sql = "INSERT INTO \(DBHelper.TABLE_RETAILER_DISPATCH) " +
            "(\(DBHelper.KEY_RETAILER_DISPATCH_ID), " +
            "\(DBHelper.KEY_CUSTOMER_FROM_ID), " +
            "\(DBHelper.KEY_CUSTOMER_TO_ID), " +
            "\(DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID), " +
            "\(DBHelper.KEY_IS_NEW_CUSTOMER), " +
            "\(DBHelper.KEY_DISPATCH_DATE), " +
            "\(DBHelper.KEY_COUNTRY_ID), " +
            "\(DBHelper.KEY_CREATED_BY_USER), " +
            "\(DBHelper.KEY_MODIFIED_BY_USER), " +
            "\(DBHelper.KEY_STATUS), " +
            "\(DBHelper.KEY_CREATE_ON), " +
            "\(DBHelper.KEY_MODIFIED_ON), " +
            "\(DBHelper.KEY_SYNC_CODE), " +
            "\(DBHelper.KEY_SYNC_FLAG), " +
            "\(DBHelper.KEY_SYNC_DATE), " +
            "\(DBHelper.KEY_READ), " +
            "\(DBHelper.KEY_customer_to_name), " +
            "\(DBHelper.KEY_customer_to_phone), " +
            "\(DBHelper.KEY_new_customer_type), " +
            "\(DBHelper.KEY_IS_DISPATCH), " +
            "\(DBHelper.KEY_READ_DATE), " +
            "\(DBHelper.KEY_SYNC_USER)) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)"
            
            for object in ishopRetailerDispatch {
                try database.executeUpdate(sql, values: [
                    object[DBHelper.KEY_RETAILER_DISPATCH_ID] ?? "",
                    object[DBHelper.KEY_CUSTOMER_FROM_ID] ?? "",
                    object[DBHelper.KEY_CUSTOMER_TO_ID] ?? "",
                    object[DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID] ?? "",
                    object[DBHelper.KEY_IS_NEW_CUSTOMER] ?? "",
                    object[DBHelper.KEY_DISPATCH_DATE] ?? "",
                    object[DBHelper.KEY_COUNTRY_ID] ?? "",
                    object[DBHelper.KEY_CREATED_BY_USER] ?? "",
                    object[DBHelper.KEY_MODIFIED_BY_USER] ?? "",
                    object[DBHelper.KEY_STATUS] ?? "",
                    object[DBHelper.KEY_CREATE_ON] ?? "",
                    object[DBHelper.KEY_MODIFIED_ON] ?? "",
                    object[DBHelper.KEY_SYNC_CODE] ?? "",
                    object[DBHelper.KEY_SYNC_FLAG] ?? "",
                    object[DBHelper.KEY_SYNC_DATE] ?? "",
                    object[DBHelper.KEY_READ] ?? "",
                    object[DBHelper.KEY_customer_to_name] ?? "",
                    object[DBHelper.KEY_customer_to_phone] ?? "",
                    object[DBHelper.KEY_new_customer_type] ?? "",
                    "1",
                    object[DBHelper.KEY_READ_DATE] ?? "",
                    object[DBHelper.KEY_SYNC_USER] ?? ""
                ])
            }
            
            database.commit()
        } catch {
            print("FMDB exception: \(error)")
        }
        
    } else {
        do {
            database.beginTransaction()
            try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_RETAILER_DISPATCH_COPY)", values: nil)
            
            let sql = "INSERT INTO \(DBHelper.TABLE_RETAILER_DISPATCH_COPY) " +
            "(\(DBHelper.KEY_RETAILER_DISPATCH_ID), " +
            "\(DBHelper.KEY_CUSTOMER_FROM_ID), " +
            "\(DBHelper.KEY_CUSTOMER_TO_ID), " +
            "\(DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID), " +
            "\(DBHelper.KEY_IS_NEW_CUSTOMER), " +
            "\(DBHelper.KEY_DISPATCH_DATE), " +
            "\(DBHelper.KEY_COUNTRY_ID), " +
            "\(DBHelper.KEY_CREATED_BY_USER), " +
            "\(DBHelper.KEY_MODIFIED_BY_USER), " +
            "\(DBHelper.KEY_STATUS), " +
            "\(DBHelper.KEY_CREATE_ON), " +
            "\(DBHelper.KEY_MODIFIED_ON), " +
            "\(DBHelper.KEY_SYNC_CODE), " +
            "\(DBHelper.KEY_SYNC_FLAG), " +
            "\(DBHelper.KEY_SYNC_DATE), " +
            "\(DBHelper.KEY_READ), " +
            "\(DBHelper.KEY_customer_to_name), " +
            "\(DBHelper.KEY_customer_to_phone), " +
            "\(DBHelper.KEY_new_customer_type), " +
            "\(DBHelper.KEY_IS_DISPATCH), " +
            "\(DBHelper.KEY_READ_DATE), " +
            "\(DBHelper.KEY_SYNC_USER)) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)"
            
            for object in ishopRetailerDispatch {
                try database.executeUpdate(sql, values: [
                    object[DBHelper.KEY_RETAILER_DISPATCH_ID] ?? "",
                    object[DBHelper.KEY_CUSTOMER_FROM_ID] ?? "",
                    object[DBHelper.KEY_CUSTOMER_TO_ID] ?? "",
                    object[DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID] ?? "",
                    object[DBHelper.KEY_IS_NEW_CUSTOMER] ?? "",
                    object[DBHelper.KEY_DISPATCH_DATE] ?? "",
                    object[DBHelper.KEY_COUNTRY_ID] ?? "",
                    object[DBHelper.KEY_CREATED_BY_USER] ?? "",
                    object[DBHelper.KEY_MODIFIED_BY_USER] ?? "",
                    object[DBHelper.KEY_STATUS] ?? "",
                    object[DBHelper.KEY_CREATE_ON] ?? "",
                    object[DBHelper.KEY_MODIFIED_ON] ?? "",
                    object[DBHelper.KEY_SYNC_CODE] ?? "",
                    object[DBHelper.KEY_SYNC_FLAG] ?? "",
                    object[DBHelper.KEY_SYNC_DATE] ?? "",
                    object[DBHelper.KEY_READ] ?? "",
                    object[DBHelper.KEY_customer_to_name] ?? "",
                    object[DBHelper.KEY_customer_to_phone] ?? "",
                    object[DBHelper.KEY_new_customer_type] ?? "",
                    "1",
                    object[DBHelper.KEY_READ_DATE] ?? "",
                    object[DBHelper.KEY_SYNC_USER] ?? ""
                ])
            }
            
            manageRetailerDispatchCopy(database: database)
            
            database.commit()
        } catch {
            print("FMDB exception: \(error)")
        }
    }
}


func manageRetailerDispatchCopy(database:FMDatabase) {
    do {
        //            let database = FMDatabase(url: URL(fileURLWithPath: "your_database_path")) // Replace with your actual database path
        guard database.open() else {
            print("Unable to open database")
            return
        }
        
        database.beginTransaction()
        
        // Delete rows in bf_ishop_retailer_dispatch where sync_code is in bf_ishop_retailer_dispatch_copy
        let deleteSQL = """
                DELETE FROM bf_ishop_retailer_dispatch
                WHERE sync_code IN (
                    SELECT st.sync_code
                    FROM bf_ishop_retailer_dispatch AS st
                    INNER JOIN bf_ishop_retailer_dispatch_copy AS st_copy ON st.sync_code = st_copy.sync_code
                );
            """
        
        database.executeStatements(deleteSQL)
        
        // Insert rows from bf_ishop_retailer_dispatch_copy to bf_ishop_retailer_dispatch
        let insertSQL = """
                INSERT INTO bf_ishop_retailer_dispatch (
                    retailer_dispatch_id,
                    customer_from_id,
                    customer_to_id,
                    customer_type_country_id,
                    is_new_customer,
                    dispatch_date,
                    country_id,
                    created_by_user,
                    modified_by_user,
                    status,
                    created_on,
                    modified_on,
                    sync_code,
                    sync_flag,
                    sync_date,
                    isRead,
                    customer_to_name,
                    customer_to_phone,
                    new_customer_type,
                    isDispatch,
                    read_date,
                    sync_by_user
                )
                SELECT
                    retailer_dispatch_id,
                    customer_from_id,
                    customer_to_id,
                    customer_type_country_id,
                    is_new_customer,
                    dispatch_date,
                    country_id,
                    created_by_user,
                    modified_by_user,
                    status,
                    created_on,
                    modified_on,
                    sync_code,
                    sync_flag,
                    sync_date,
                    isRead,
                    customer_to_name,
                    customer_to_phone,
                    new_customer_type,
                    isDispatch,
                    read_date,
                    sync_by_user
                FROM bf_ishop_retailer_dispatch_copy;
            """
        
        database.executeStatements(insertSQL)
        
        // Delete all rows in bf_ishop_retailer_dispatch_copy
        let deleteCopySQL = "DELETE FROM bf_ishop_distributor_return_request_copy"
        database.executeStatements(deleteCopySQL)
        
        database.commit()
        
        database.close()
        
    } catch {
        print("FMDB error: \(error)")
    }
}


func insertDistributorReturnNew(_ ishopDistributorReturn: [[String: Any]], database:FMDatabase) {
    if !DBHelper.OPTIMIZE_MAIN_TABLE {
        do {
            try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_DISTRIBUTOR_RETURN)", values: nil)
            database.beginTransaction()
            
            let sql = "INSERT INTO \(DBHelper.TABLE_DISTRIBUTOR_RETURN) " +
            "(\(DBHelper.KEY_DISTRIBUTOR_RETURN_ID), " +
            "\(DBHelper.KEY_CUSTOMER_FROM_ID), " +
            "\(DBHelper.KEY_CUSTOMER_TO_ID), " +
            "\(DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID), " +
            "\(DBHelper.KEY_IS_NEW_CUSTOMER), " +
            "\(DBHelper.KEY_RETURN_DATE), " +
            "\(DBHelper.KEY_COUNTRY_ID), " +
            "\(DBHelper.KEY_CREATED_BY_USER), " +
            "\(DBHelper.KEY_MODIFIED_BY_USER), " +
            "\(DBHelper.KEY_STATUS), " +
            "\(DBHelper.KEY_CREATE_ON), " +
            "\(DBHelper.KEY_MODIFIED_ON), " +
            "\(DBHelper.KEY_SYNC_CODE), " +
            "\(DBHelper.KEY_SYNC_FLAG), " +
            "\(DBHelper.KEY_SYNC_DATE), " +
            "\(DBHelper.KEY_SYNC_USER)) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)"
            
            for object in ishopDistributorReturn {
                try database.executeUpdate(sql, values: [
                    object[DBHelper.KEY_DISTRIBUTOR_RETURN_ID] ?? "",
                    object[DBHelper.KEY_CUSTOMER_FROM_ID] ?? "",
                    object[DBHelper.KEY_CUSTOMER_TO_ID] ?? "",
                    object[DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID] ?? "",
                    object[DBHelper.KEY_IS_NEW_CUSTOMER] ?? "",
                    object[DBHelper.KEY_RETURN_DATE] ?? "",
                    object[DBHelper.KEY_COUNTRY_ID] ?? "",
                    object[DBHelper.KEY_CREATED_BY_USER] ?? "",
                    object[DBHelper.KEY_MODIFIED_BY_USER] ?? "",
                    object[DBHelper.KEY_STATUS] ?? "",
                    object[DBHelper.KEY_CREATE_ON] ?? "",
                    object[DBHelper.KEY_MODIFIED_ON] ?? "",
                    object[DBHelper.KEY_SYNC_CODE] ?? "",
                    object[DBHelper.KEY_SYNC_FLAG] ?? "",
                    object[DBHelper.KEY_SYNC_DATE] ?? "",
                    object[DBHelper.KEY_SYNC_USER] ?? ""
                ])
            }
            
            database.commit()
        } catch {
            print("FMDB exception: \(error)")
        }
        
    } else {
        do {
            try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_DISTRIBUTOR_RETURN_COPY)", values: nil)
            database.beginTransaction()
            
            let sql = "INSERT INTO \(DBHelper.TABLE_DISTRIBUTOR_RETURN_COPY) " +
            "(\(DBHelper.KEY_DISTRIBUTOR_RETURN_ID), " +
            "\(DBHelper.KEY_CUSTOMER_FROM_ID), " +
            "\(DBHelper.KEY_CUSTOMER_TO_ID), " +
            "\(DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID), " +
            "\(DBHelper.KEY_IS_NEW_CUSTOMER), " +
            "\(DBHelper.KEY_RETURN_DATE), " +
            "\(DBHelper.KEY_COUNTRY_ID), " +
            "\(DBHelper.KEY_CREATED_BY_USER), " +
            "\(DBHelper.KEY_MODIFIED_BY_USER), " +
            "\(DBHelper.KEY_STATUS), " +
            "\(DBHelper.KEY_CREATE_ON), " +
            "\(DBHelper.KEY_MODIFIED_ON), " +
            "\(DBHelper.KEY_SYNC_CODE), " +
            "\(DBHelper.KEY_SYNC_FLAG), " +
            "\(DBHelper.KEY_SYNC_DATE), " +
            "\(DBHelper.KEY_SYNC_USER)) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)"
            
            for object in ishopDistributorReturn {
                try database.executeUpdate(sql, values: [
                    object[DBHelper.KEY_DISTRIBUTOR_RETURN_ID] ?? "",
                    object[DBHelper.KEY_CUSTOMER_FROM_ID] ?? "",
                    object[DBHelper.KEY_CUSTOMER_TO_ID] ?? "",
                    object[DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID] ?? "",
                    object[DBHelper.KEY_IS_NEW_CUSTOMER] ?? "",
                    object[DBHelper.KEY_RETURN_DATE] ?? "",
                    object[DBHelper.KEY_COUNTRY_ID] ?? "",
                    object[DBHelper.KEY_CREATED_BY_USER] ?? "",
                    object[DBHelper.KEY_MODIFIED_BY_USER] ?? "",
                    object[DBHelper.KEY_STATUS] ?? "",
                    object[DBHelper.KEY_CREATE_ON] ?? "",
                    object[DBHelper.KEY_MODIFIED_ON] ?? "",
                    object[DBHelper.KEY_SYNC_CODE] ?? "",
                    object[DBHelper.KEY_SYNC_FLAG] ?? "",
                    object[DBHelper.KEY_SYNC_DATE] ?? "",
                    object[DBHelper.KEY_SYNC_USER] ?? ""
                ])
            }
            
            manageDistRetunCopy(database: database)
            
            database.commit()
        } catch {
            print("FMDB exception: \(error)")
        }
    }
}

private func manageDistRetunCopy(database:FMDatabase) {
    do {
        try database.executeUpdate("DELETE FROM bf_ishop_distributor_return " +
                                   "WHERE sync_code IN (" +
                                   "SELECT st.sync_code " +
                                   "FROM bf_ishop_distributor_return AS st " +
                                   "INNER JOIN " +
                                   "bf_ishop_distributor_return_copy AS st_copy ON st.sync_code = st_copy.sync_code);", values: nil)
        
        try database.executeUpdate("INSERT INTO bf_ishop_distributor_return " +
                                   "(distributor_return_id, " +
                                   "customer_from_id, " +
                                   "customer_to_id, " +
                                   "customer_type_country_id, " +
                                   "is_new_customer, " +
                                   "return_date, " +
                                   "country_id, " +
                                   "created_by_user, " +
                                   "modified_by_user, " +
                                   "status, " +
                                   "created_on, " +
                                   "modified_on, " +
                                   "sync_code, " +
                                   "sync_flag, " +
                                   "sync_date, " +
                                   "sync_by_user) " +
                                   "SELECT distributor_return_id, " +
                                   "customer_from_id, " +
                                   "customer_to_id, " +
                                   "customer_type_country_id, " +
                                   "is_new_customer, " +
                                   "return_date, " +
                                   "country_id, " +
                                   "created_by_user, " +
                                   "modified_by_user, " +
                                   "status, " +
                                   "created_on, " +
                                   "modified_on, " +
                                   "sync_code, " +
                                   "sync_flag, " +
                                   "sync_date, " +
                                   "sync_by_user " +
                                   "FROM bf_ishop_distributor_return_copy;", values: nil)
        
        // Delete copy table data
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_DISTRIBUTOR_RETURN_COPY)", values: nil)
    } catch {
        print("FMDB exception: \(error)")
    }
}

func insertMenuAccess(_ object: MenuAccess,database:FMDatabase) -> Bool {
    
    
    var success = false
    
    var contentValues = [Any]()
    contentValues.append(object.order)
    contentValues.append(object.alias)
    contentValues.append(object.menuId)
    contentValues.append(object.title)
    
    do {
        try database.executeUpdate("INSERT INTO \(DBHelper.TABLE_MENU_ACCESS) " +
                                   "(\(DBHelper.KEY_ORDER), " +
                                   "\(DBHelper.KEY_ALIAS), " +
                                   "\(DBHelper.KEY_MENU_ID), " +
                                   "\(DBHelper.KEY_TITLE)) " +
                                   "VALUES (?, ?, ?, ?)",
                                   values: contentValues)
        print("TABLE TABLE_MENU_ACCESS INSERT SUCCESSFULLY")
        success = true
    } catch {
        print("FMDB exception: \(error)")
        // Handle the error as needed
    }
    
    return success
}

func insertPoliticalLevel(_ objectData: PoliticalLevel,database:FMDatabase) {
    var contentValues = [String: Any]()
    contentValues[DBHelper.KEY_POLITICAL_GEOGRAPHY_COUNTRY_LEVEL_ID] = objectData.politicalGeographyCountrylevelId
    contentValues[DBHelper.KEY_LEVEL_NAME] = objectData.levelName
    contentValues[DBHelper.KEY_LEVEL] = objectData.level
    
    do {
        try database.executeUpdate("INSERT INTO \(DBHelper.TABLE_POLITICAL_LEVEL) " +
                                   "(\(DBHelper.KEY_POLITICAL_GEOGRAPHY_COUNTRY_LEVEL_ID), " +
                                   "\(DBHelper.KEY_LEVEL_NAME), " +
                                   "\(DBHelper.KEY_LEVEL)) " +
                                   "VALUES (?, ?, ?)",
                                   values: [objectData.politicalGeographyCountrylevelId ?? "",
                                            objectData.levelName ?? "",
                                            objectData.level ?? ""])
        print("TABLE_POLITICAL_LEVEL Add SUCCESSFULLY")
    } catch {
        print("FMDB exception: \(error)")
        // Handle the error as needed
    }
}

func insertDistributorReceivedProductNew(ishopDistributorReceivedProduct: [[String: Any]],database:FMDatabase) {
    let table = DBHelper.TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_PRODUCT
    
    do {
        database.executeStatements("DELETE FROM \(table)")
    } catch {
        print("FMDB exception: \(error.localizedDescription)")
        return
    }
    
    database.beginTransaction()
    
    let sql = """
            INSERT INTO \(table) (
                \(DBHelper.DISTRIBUTOR_RECEIVED_PRODUCT_ID),
                \(DBHelper.DISTRIBUTOR_RECEIVED_ID),
                \(DBHelper.KEY_PRODUCT_SKU_ID),
                \(DBHelper.KEY_STICKER_DETAILS_ID),
                \(DBHelper.BTC_NO_OUT),
                \(DBHelper.KEY_QR_CODE_OUT),
                \(DBHelper.KEY_QUANTITY),
                \(DBHelper.KEY_AMOUNT),
                \(DBHelper.KEY_UNIT),
                \(DBHelper.KEY_QTY_KGL),
                \(DBHelper.KEY_IS_VALID),
                \(DBHelper.KEY_SYNC_CODE),
                \(DBHelper.KEY_SYNC_FLAG),
                \(DBHelper.KEY_SYNC_DATE),
                \(DBHelper.KEY_SYNC_USER),
                \(DBHelper.KEY_CREATE_ON),
                \(DBHelper.KEY_CREATE_BY)
            ) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
        """
    
    for item in ishopDistributorReceivedProduct {
        do {
            try database.executeUpdate(sql, values: [
                item["A"] as? String ?? "",
                item["B"] as? String ?? "",
                item["C"] as? String ?? "",
                item["D"] as? String ?? "",
                item["E"] as? String ?? "",
                item["F"] as? String ?? "",
                item["G"] as? String ?? "",
                item["H"] as? String ?? "",
                item["I"] as? String ?? "",
                item["J"] as? String ?? "",
                item["K"] as? String ?? "",
                item["L"] as? String ?? "",
                item["M"] as? String ?? "",
                item["N"] as? String ?? "",
                item["O"] as? String ?? "",
                item["Q"] as? String ?? "",
                item["P"] as? String ?? ""
            ])
        } catch {
            print("FMDB exception: \(error.localizedDescription)")
        }
    }
    
    database.commit()
    
    print("TABLE DistributorReceivedProduct Add SUCCESSFULLY")
}

func insertRetailerScannedIn(_ objectData: ScannedPoints,database:FMDatabase) {
    database.open()
    let query = "INSERT INTO \(DBHelper.TABLE_RETAILER_SCANNED_IN_STICKER) (\(DBHelper.TOTALINSCANNED), \(DBHelper.DTMONTH)) VALUES (?, ?)"
    
    do {
        try database.executeUpdate(query, values: [objectData.totalInScanned, objectData.dtMonth])
        print("TABLE_RETAILER_SCANNED_IN_STICKER inserted successfully")
    } catch {
        print("Error inserting into TABLE_RETAILER_SCANNED_IN_STICKER: \(error)")
    }
    database.close()
}

func insertRetailerScannedOutSticker(_ arrayRetailerScannedOutSticker: [[String: Any]],database:FMDatabase) {
    do {
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_RETAILER_SCANNED_OUT_STICKER)", values: nil)
        database.beginTransaction()
        
        let sql = "INSERT INTO \(DBHelper.TABLE_RETAILER_SCANNED_OUT_STICKER) " +
        "(\(DBHelper.TOTALINSCANNED), \(DBHelper.DTMONTH)) VALUES (?, ?)"
        
        for object in arrayRetailerScannedOutSticker {
            do {
                try database.executeUpdate(sql, values: [
                    object[DBHelper.TOTALINSCANNED] ?? "",
                    object[DBHelper.DTMONTH] ?? ""
                ])
            } catch {
                print("FMDB exception: \(error)")
                //                    if let callback = callback {
                //                        callback.onDatabaseError(String(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(error))
                //                    }
                //                    SynchronizationService.isSuccess = false
                //                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(error) + " In Method insertRetailerScannedOutSticker"
            }
        }
        
        database.commit()
    } catch {
        print("FMDB exception: \(error)")
        //            if let callback = callback {
        //                callback.onDatabaseError(String(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(error))
        //            }
        //            SynchronizationService.isSuccess = false
        //            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(error) + " In Method insertRetailerScannedOutSticker"
    }
    //        finally {
    //            database.endTransaction()
    //        }
}

func InsertCtoCMapping(_ objectData: CtoCMapping,database:FMDatabase) {
    var contentValues: [String: Any] = [:]
    contentValues[DBHelper.FROM_CUSTOMER_ID] = objectData.fromCustomerId
    contentValues[DBHelper.TO_CUSTOMER_ID] = objectData.toCustomerId
    
    do {
        try database.executeUpdate("INSERT INTO \(DBHelper.TABLE_CTOCMAPPING) " +
                                   "(\(DBHelper.FROM_CUSTOMER_ID), \(DBHelper.TO_CUSTOMER_ID)) " +
                                   "VALUES (?, ?)",
                                   values: [contentValues[DBHelper.FROM_CUSTOMER_ID] ?? "", contentValues[DBHelper.TO_CUSTOMER_ID] ?? ""])
        print("TABLE_SALES_REP_INITIATED_PRODUCT Add SUCCESSFULLY")
    } catch {
        print("FMDB exception: \(error)")
        // Handle the error as needed
    }
}

func InsertCtoEMapping(_ objectData: CtoEMapping,database:FMDatabase) {
    do {
        var contentValues = [String: Any]()
        contentValues[DBHelper.EMPLOYEE_ID] = objectData.employeeId
        contentValues[DBHelper.CUSTOMER_ID] = objectData.customerId
        contentValues[DBHelper.USER_CODE] = objectData.userCode
        contentValues[DBHelper.DISPLAY_NAME] = objectData.displayName
        contentValues[DBHelper.EMAIL] = objectData.email
        contentValues[DBHelper.PRIMARY_MOBILE_NO] = objectData.primaryMobileNo
        
        let values = Array(contentValues.values)
        
        try database.executeUpdate("INSERT INTO \(DBHelper.TABLE_CTOEMAPPING) " +
                                   "(\(DBHelper.EMPLOYEE_ID), " +
                                   "\(DBHelper.CUSTOMER_ID), " +
                                   "\(DBHelper.USER_CODE), " +
                                   "\(DBHelper.DISPLAY_NAME), " +
                                   "\(DBHelper.EMAIL), " +
                                   "\(DBHelper.PRIMARY_MOBILE_NO)) " +
                                   "VALUES (?, ?, ?, ?, ?, ?)",
                                   values: values)
        
        print("TABLE_SALES_REP_INITIATED_PRODUCT Add SUCCESSFULLY")
    } catch {
        print("FMDB exception: \(error)")
        // Handle the error as needed
    }
}


func insertUserConfigurationMst(_ objectData: UserConfigurationMst,database:FMDatabase) {
    do {
        var contentValues = [String: Any]()
        contentValues[DBHelper.ID] = objectData.id
        contentValues[DBHelper.DISPATCH_SCAN_TYPE] = objectData.dispatchScanType
        contentValues[DBHelper.RECEIVED] = objectData.received
        contentValues[DBHelper.RETURNED] = objectData.returned
        contentValues[DBHelper.Political_Geo_4] = objectData.politicalGeoLevel4
        contentValues[DBHelper.RECIEVE_Days] = objectData.intReceiveDays
        contentValues[DBHelper.RECIEVE_POPUP] = objectData.charReceivePopUp
        contentValues[DBHelper.CUSTOMER_SYNC_DISABLE] = objectData.chrCustSyncEnable
        contentValues[DBHelper.INT_SYNC_MINUTES] = objectData.intSyncMinutes
        contentValues[DBHelper.INT_SCAN_SCREEN] = objectData.intScanScreen
        contentValues[DBHelper.CHAR_PALLATE_ENABLE] = objectData.chrPalletEnable
        
        contentValues[DBHelper.FTP_HOST] = objectData.ftpHost
        contentValues[DBHelper.FTP_PORT] = objectData.ftpPort
        contentValues[DBHelper.FTP_USERNAME] = objectData.ftpUsername
        contentValues[DBHelper.FTP_PASSWORD] = objectData.ftpPassword
        contentValues[DBHelper.INT_SCAN_ALERT_MINUTES] = objectData.intScanAlertBgMinutes
        contentValues[DBHelper.INT_SYNC_ALERT_MINUTES] = objectData.intSyncAlertBgMinutes
        contentValues[DBHelper.CHR_SCM_CPM] = objectData.chrScmCpm
        contentValues[DBHelper.INT_SALES_RET_LIMIT] = objectData.intSalesReturnLimit
        contentValues[DBHelper.IS_SYNC_POPUP] = objectData.isSyncPopUp
        contentValues[DBHelper.IS_EXPIRE_ENABLE] = objectData.isExpireEnable
        contentValues[DBHelper.INT_MINIMUM_MINS] = objectData.intMinimumMinutes
        contentValues[DBHelper.INT_MAXIMUM_MINS] = objectData.intMaximumMinutes
        contentValues[DBHelper.CHR_SCAN_TYPE_RADIO_BTN] = objectData.chrScanTypeRadioBtn
        
        let values = Array(contentValues.values)
        
        try database.executeUpdate("INSERT INTO \(DBHelper.USER_CONFIGURATION_MST) " +
                                   "(\(DBHelper.ID), " +
                                   "\(DBHelper.DISPATCH_SCAN_TYPE), " +
                                   "\(DBHelper.RECEIVED), " +
                                   "\(DBHelper.RETURNED), " +
                                   "\(DBHelper.Political_Geo_4), " +
                                   "\(DBHelper.RECIEVE_Days), " +
                                   "\(DBHelper.RECIEVE_POPUP), " +
                                   "\(DBHelper.CUSTOMER_SYNC_DISABLE), " +
                                   "\(DBHelper.INT_SYNC_MINUTES), " +
                                   "\(DBHelper.INT_SCAN_SCREEN), " +
                                   "\(DBHelper.CHAR_PALLATE_ENABLE), " +
                                   "\(DBHelper.FTP_HOST), " +
                                   "\(DBHelper.FTP_PORT), " +
                                   "\(DBHelper.FTP_USERNAME), " +
                                   "\(DBHelper.FTP_PASSWORD), " +
                                   "\(DBHelper.INT_SCAN_ALERT_MINUTES), " +
                                   "\(DBHelper.INT_SYNC_ALERT_MINUTES), " +
                                   "\(DBHelper.CHR_SCM_CPM), " +
                                   "\(DBHelper.INT_SALES_RET_LIMIT), " +
                                   "\(DBHelper.IS_SYNC_POPUP), " +
                                   "\(DBHelper.IS_EXPIRE_ENABLE), " +
                                   "\(DBHelper.INT_MINIMUM_MINS), " +
                                   "\(DBHelper.INT_MAXIMUM_MINS), " +
                                   "\(DBHelper.CHR_SCAN_TYPE_RADIO_BTN)) " +
                                   "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)",
                                   values: values)
        
        print("TABLE UserConfigurationMst Add SUCCESSFULLY")
    } catch {
        print("FMDB exception: \(error)")
        // Handle the error as needed
    }
}

func updateLastSyncDateTimeForWHMasterSync(_ jsonArrayEmployee: [[String: Any]], _ type: Int,database:FMDatabase) {
    if jsonArrayEmployee.count > 0 {
        do {
            //                let db = writeDB()
            let lastSyncDate = getSyncDateAndTimeTransactionSync(type, database: database)
            
            try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_Last_Sync_Date_Time)", values: nil)
            
            var contentValues = [String: Any]()
            if type == 1 {
                // For Transaction Sync
                contentValues["Last_Sync_Date_Time_Trn_Get"] = jsonArrayEmployee[0]["Last_Sync_Date"]
                contentValues["Last_Sync_Date_Time"] = lastSyncDate
            } else {
                // For Master Sync
                contentValues["Last_Sync_Date_Time"] = jsonArrayEmployee[0]["Last_Sync_Date"]
                contentValues["Last_Sync_Date_Time_Trn_Get"] = lastSyncDate
            }
            
            let columns = contentValues.keys.joined(separator: ", ")
            let placeholders = Array(repeating: "?", count: contentValues.count).joined(separator: ", ")
            let values = contentValues.values
            
            let sql = "INSERT INTO \(DBHelper.TABLE_Last_Sync_Date_Time) (\(columns)) VALUES (\(placeholders))"
            
            try database.executeUpdate(sql, values: Array(values))
        } catch {
            print("FMDB exception: \(error)")
        }
    }
}

func getSyncDateAndTimeTransactionSync(_ type: Int,database:FMDatabase) -> String {
    var syncTime = ""
    do {
        //            let db = writeDB()
        let sql = "SELECT * FROM \(DBHelper.TABLE_Last_Sync_Date_Time)"
        let cursor = try database.executeQuery(sql, values: nil)
        
        while cursor.next() {
            if type == 1 {
                syncTime = cursor.string(forColumn: "Last_Sync_Date_Time") ?? ""
            } else {
                syncTime = cursor.string(forColumn: "Last_Sync_Date_Time_Trn_Get") ?? ""
            }
        }
        
        cursor.close()
        
        if syncTime == "null" {
            syncTime = ""
        }
        
        return syncTime
    } catch {
        print("FMDB exception: \(error)")
    }
    
    return syncTime
}

func insertCustomerTypeDetails(_ objectData: CustomerTypeDetails,database:FMDatabase) {
    var contentValues = [String: Any]()
    contentValues[DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID] = objectData.customerTypeCountryId
    contentValues[DBHelper.KEY_customer_level] = objectData.customerLevel
    contentValues[DBHelper.KEY_customer_type_name] = objectData.customerTypeName
    contentValues[DBHelper.KEY_Customer_type_name_country] = objectData.customerTypeNameCountry
    contentValues[DBHelper.AUTO_SYNC] = objectData.autoSync
    contentValues[DBHelper.AUTO_SYNC_DAY] = objectData.autoSyncDay
    
    let values = contentValues.map { $0.value }
    
    do {
        try database.executeUpdate("INSERT INTO \(DBHelper.TABLE_CustomerType_Details) " +
                                   "(\(DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID), " +
                                   "\(DBHelper.KEY_customer_level), " +
                                   "\(DBHelper.KEY_customer_type_name), " +
                                   "\(DBHelper.KEY_Customer_type_name_country), " +
                                   "\(DBHelper.AUTO_SYNC), " +
                                   "\(DBHelper.AUTO_SYNC_DAY)) " +
                                   "VALUES (?, ?, ?, ?, ?, ?)",
                                   values: values)
        
        print("TABLE CustomerTypeDetails Add SUCCESSFULLY")
    } catch {
        print("FMDB exception: \(error)")
        // Handle the error as needed
    }
}

func insertETORMAPPINGNew(_ arrayEToRMapping: [[String: Any]],database:FMDatabase) {
    //        if !DBHelper.OPTIMIZE_MAIN_TABLE {
    do {
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_ETORMAPPING)", values: nil)
        database.beginTransaction()
        
        let sql = "INSERT INTO \(DBHelper.TABLE_ETORMAPPING) ("
        + "\(DBHelper.KEY_ID), "
        + "\(DBHelper.KEY_EMAIL), "
        + "\(DBHelper.KEY_USER_CODE), "
        + "\(DBHelper.KEY_BUSSINESS_CODE), "
        + "\(DBHelper.KEY_DISPLAY_NAME), "
        + "\(DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID), "
        + "\(DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_CODE), "
        + "\(DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_NAME), "
        + "\(DBHelper.KEY_CUSTOMER_TYPE_REGIONAL_ID), "
        + "\(DBHelper.KEY_CUSTOMER_TYPE_REGIONAL_NAME), "
        + "\(DBHelper.KEY_CUSTOMER_TYPE_REGIONAL_CODE), "
        + "\(DBHelper.KEY_CUSTOMER_TYPE_REGIONAL_LEVEL), "
        + "\(DBHelper.KEY_POLITICAL_GEO_ID), "
        + "\(DBHelper.KEY_political_geography_countrylevel_id), "
        + "\(DBHelper.KEY_political_regional_level), "
        + "\(DBHelper.KEY_SAP_ID), "
        + "\(DBHelper.DISPATCH_SCAN_TYPE), "
        + "\(DBHelper.PRIMARY_MOBILE_NO)"
        + ") VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)"
        
        for object in arrayEToRMapping {
            try database.executeUpdate(sql, values: [
                object[DBHelper.KEY_ID] ?? "",
                object[DBHelper.KEY_EMAIL] ?? "",
                object[DBHelper.KEY_USER_CODE] ?? "",
                object[DBHelper.KEY_BUSSINESS_CODE] ?? "",
                object[DBHelper.KEY_DISPLAY_NAME] ?? "",
                object[DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID] ?? "",
                object[DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_CODE] ?? "",
                object[DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_NAME] ?? "",
                object[DBHelper.KEY_CUSTOMER_TYPE_REGIONAL_ID] ?? "",
                object[DBHelper.KEY_CUSTOMER_TYPE_REGIONAL_NAME] ?? "",
                object[DBHelper.KEY_CUSTOMER_TYPE_REGIONAL_CODE] ?? "",
                object[DBHelper.KEY_CUSTOMER_TYPE_REGIONAL_LEVEL] ?? "",
                object[DBHelper.KEY_POLITICAL_GEO_ID] ?? "",
                object[DBHelper.KEY_political_geography_countrylevel_id] ?? "",
                object[DBHelper.KEY_political_regional_level] ?? "",
                object[DBHelper.KEY_SAP_ID] ?? "",
                object[DBHelper.DISPATCH_SCAN_TYPE] ?? "",
                object[DBHelper.PRIMARY_MOBILE_NO] ?? ""
            ])
        }
        
        database.commit()
    } catch {
        print("FMDB exception: \(error)")
        //                if let callback = callback {
        //                    callback.onDatabaseError(String(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(error))
        //                }
        //                SynchronizationService.isSuccess = false
        //                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(error) + " In Method insertETORMAPPINGNew"
    }
    //        } else {
    //            // Handle the case when OPTIMIZE_MAIN_TABLE is true
    //        }
}


func insertRtoRMappingNew(_ arrayRtoRMapping: [[String: Any]],database:FMDatabase) {
    do {
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_RTORMAPPING)", values: nil)
        database.beginTransaction()
        
        let sql = "INSERT INTO \(DBHelper.TABLE_RTORMAPPING) ("
        + "\(DBHelper.FROM_CUSTOMER_LEVEL), "
        + "\(DBHelper.FROM_CUSTOMER_ID), "
        + "\(DBHelper.TO_CUSTOMER_LEVEL), "
        + "\(DBHelper.TO_CUSTOMER_ID)"
        + ") VALUES (?, ?, ?, ?)"
        
        for object in arrayRtoRMapping {
            do {
                try database.executeUpdate(sql, values: [
                    object[DBHelper.FROM_CUSTOMER_LEVEL] as? String ?? "",
                    object[DBHelper.FROM_CUSTOMER_ID] as? String ?? "",
                    object[DBHelper.TO_CUSTOMER_LEVEL] as? String ?? "",
                    object[DBHelper.TO_CUSTOMER_ID] as? String ?? ""
                ])
            } catch {
                print("FMDB exception: \(error)")
                //                    if let callback = callback {
                //                        callback.onDatabaseError(String(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(error))
                //                    }
                //                    SynchronizationService.isSuccess = false
                //                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(error) + " In Method insertRtoRMappingNew"
            }
        }
        
        database.commit()
    } catch {
        print("FMDB exception: \(error)")
        //            if let callback = callback {
        //                callback.onDatabaseError(String(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(error))
        //            }
        //            SynchronizationService.isSuccess = false
        //            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(error) + " In Method insertRtoRMappingNew"
    }
}

func insertDtoRMappingNew(_ arrayDtoRMapping: [[String: Any]],database:FMDatabase) {
    do {
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_DTORMAPPING)", values: nil)
        database.beginTransaction()
        
        let sql = "INSERT INTO \(DBHelper.TABLE_DTORMAPPING) ("
        + "\(DBHelper.FROM_CUSTOMER_LEVEL), "
        + "\(DBHelper.FROM_CUSTOMER_ID), "
        + "\(DBHelper.TO_CUSTOMER_LEVEL), "
        + "\(DBHelper.TO_CUSTOMER_ID)"
        + ") VALUES (?, ?, ?, ?)"
        
        for object in arrayDtoRMapping {
            do {
                try database.executeUpdate(sql, values: [
                    object[DBHelper.FROM_CUSTOMER_LEVEL] as? String ?? "",
                    object[DBHelper.FROM_CUSTOMER_ID] as? String ?? "",
                    object[DBHelper.TO_CUSTOMER_LEVEL] as? String ?? "",
                    object[DBHelper.TO_CUSTOMER_ID] as? String ?? ""
                ])
            } catch {
                print("FMDB exception: \(error)")
                //                    if let callback = callback {
                //                        callback.onDatabaseError(String(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(error))
                //                    }
                //                    SynchronizationService.isSuccess = false
                //                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(error) + " In Method insertDtoRMappingNew"
            }
        }
        
        database.commit()
    } catch {
        print("FMDB exception: \(error)")
        //            if let callback = callback {
        //                callback.onDatabaseError(String(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(error))
        //            }
        //            SynchronizationService.isSuccess = false
        //            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(error) + " In Method insertDtoRMappingNew"
    }
}

func deleteLookUpTable(database:FMDatabase) {
    do {
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_BLOCKING_LOOKUP_VALUES)", values: nil)
    } catch {
        print("FMDB exception: \(error)")
        // Handle the error as needed
    }
}


func insertLookUpValuesConfig(_ arrayLookupConfig: [[String: Any]],database:FMDatabase) {
    do {
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_BLOCKING_LOOKUP_VALUES)", values: nil)
        database.beginTransaction()
        
        let sql = "INSERT INTO \(DBHelper.TABLE_BLOCKING_LOOKUP_VALUES) ("
        + "\(DBHelper.KEY_LOOKUP_TYPE_ID), "
        + "\(DBHelper.KEY_LOOKUP_CODE), "
        + "\(DBHelper.KEY_LOOKUP_VALUE)"
        + ") VALUES (?, ?, ?)"
        
        for object in arrayLookupConfig {
            do {
                try database.executeUpdate(sql, values: [
                    object["lookuptype_id"] as? String ?? "",
                    object["varLookupCode"] as? String ?? "",
                    object["varLookupValue"] as? String ?? ""
                ])
            } catch {
                print("FMDB exception: \(error)")
                //                    if let callback = callback {
                //                        callback.onDatabaseError(String(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(error))
                //                    }
                //                    SynchronizationService.isSuccess = false
                //                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(error) + " In Method insertLookUpValuesConfig"
            }
        }
        
        database.commit()
    } catch {
        print("FMDB exception: \(error)")
        //            if let callback = callback {
        //                callback.onDatabaseError(String(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(error))
        //            }
        //            SynchronizationService.isSuccess = false
        //            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(error) + " In Method insertLookUpValuesConfig"
    }
}

func insertMasterReason(videoArray: [[String: Any]],database:FMDatabase) {
    do {
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_MASTER_REASON)", values: nil)
        
        database.beginTransaction()
        
        let insertSQL = """
                INSERT INTO \(DBHelper.TABLE_MASTER_REASON)
                (\(DBHelper.KEY_REASON_ID),
                \(DBHelper.KEY_REASON_NAME),
                \(DBHelper.KEY_REASON_CODE),
                \(DBHelper.KEY_USED_FOR_ID),
                \(DBHelper.KEY_USED_FOR_CODE),
                \(DBHelper.KEY_COUNTRY_ID),
                \(DBHelper.KEY_DELETED),
                \(DBHelper.KEY_STATUS),
                \(DBHelper.KEY_CREATED_BY_USER),
                \(DBHelper.KEY_MODIFIED_BY_USER),
                \(DBHelper.KEY_CREATE_ON),
                \(DBHelper.KEY_MODIFIED_ON))
                VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
            """
        
        for object in videoArray {
            let arguments: [Any] = [
                object["A"] as! String,
                object["B"] as! String,
                object["C"] as! String,
                object["D"] as! String,
                object["E"] as! String,
                object["F"] as! String,
                object["G"] as! String,
                object["H"] as! String,
                object["I"] as! String,
                object["J"] as! String,
                object["K"] as! String,
                object["L"] as! String
            ]
            
            try database.executeUpdate(insertSQL, values: arguments)
        }
        
        database.commit()
    } catch {
        print("FMDB exception: \(error)")
        // Handle the error as needed
    }
}


func insertHelpVideoData(videoArray: [[String: Any]], loginId: String, countryID: String,database:FMDatabase) {
    do {
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_HELP_VIDEO_DETAIL)", values: nil)
        
        database.beginTransaction()
        
        let insertSQL = """
                INSERT INTO \(DBHelper.TABLE_HELP_VIDEO_DETAIL)
                (\(DBHelper.VIDEO_TYPE_DETAIL_ID),
                \(DBHelper.VIDEO_TYPE_ID),
                \(DBHelper.VIDEO_MENU_ID),
                \(DBHelper.VIDEO_MENU_NAME),
                \(DBHelper.ROLE_ID_IN_VIDEO),
                \(DBHelper.VIDEO_FILE_NAME),
                \(DBHelper.VIDEO_LOCAL_PATH),
                \(DBHelper.VIDEO_UPLOAD_TYPE),
                \(DBHelper.IS_DOWNLOADED),
                \(DBHelper.KEY_MODIFIED_ON),
                \(DBHelper.KEY_SYNC_FLAG),
                \(DBHelper.VIDEO_CUSTOMER_ID),
                \(DBHelper.KEY_CREATE_ON),
                \(DBHelper.KEY_SYNC_DATE),
                \(DBHelper.KEY_SYNC_USER),
                \(DBHelper.KEY_COUNTRY_ID),
                \(DBHelper.KEY_IMEI_NO))
                VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
            """
        
        let maxId = getProductIdMaxId(column: DBHelper.VIDEO_TYPE_DETAIL_ID, table: DBHelper.TABLE_HELP_VIDEO_DETAIL, database: database)
        
        for object in videoArray {
            try database.executeUpdate(insertSQL,
                                       values: [
                                        maxId,
                                        object["A"] as! String,
                                        object["B"] as! String,
                                        object["C"] as! String,
                                        object["D"] as! String,
                                        object["E"] as! String,
                                        object["F"] as! String,
                                        object["G"] as! String,
                                        object["H"] as! String,
                                        object["I"] as! String,
                                        object["J"] as! String,
                                        loginId,
                                        getCurrentDate(),
                                        getCurrentDate(),
                                        loginId,
                                        countryID,
                                        object["K"] as! String
                                       ])
        }
        
        database.commit()
    } catch {
        print("FMDB exception: \(error)")
        // Handle the error as needed
    }
    
}

func getCurrentDate() -> String {
    let dateFormatter = DateFormatter()
    dateFormatter.dateFormat = "yyyy-MM-dd HH:mm:ss"
    dateFormatter.locale = Locale(identifier: "en_US")
    let currentDate = dateFormatter.string(from: Date())
    return currentDate
}

func getProductIdMaxId(column: String, table: String,database:FMDatabase) -> Int {
    var pid = 0
    
    do {
        let sql = "SELECT MAX(CAST(\(column) as INTEGER)) AS maxid FROM \(table);"
        let resultSet = try database.executeQuery(sql, values: nil)
        
        if resultSet != nil && resultSet.next() {
            pid = Int(resultSet.int(forColumn: "maxid")) + 1
        }
        
        resultSet.close()
    } catch {
        print("FMDB exception: \(error)")
        // Handle the error as needed
    }
    
    return pid
}

func insertStickerDetailsNew(stickerArray: [[String: Any]], loginId: String, customerLevel: String, roleCode: String,database:FMDatabase) -> Bool {
    let startTime = Date().timeIntervalSince1970 * 1000
    print("INSERT_TRACK START TIME:: \(startTime)")
    
    database.beginTransaction()
    
    do {
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_STICKER_DETAILS_COPY)", values: nil)
        
        let insertSQL = """
                INSERT INTO \(DBHelper.TABLE_STICKER_DETAILS_COPY)
                (\(DBHelper.KEY_STICKER_DETAILS_ID),
                \(DBHelper.KEY_STICKER_ID),
                \(DBHelper.KEY_BTC_NO_IN),
                \(DBHelper.KEY_BTC_NO_OUT),
                \(DBHelper.KEY_QR_CODE_IN),
                \(DBHelper.KEY_QR_CODE_OUT),
                \(DBHelper.KEY_STICKER_NO),
                \(DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID),
                \(DBHelper.KEY_CUSTOMER_ID),
                \(DBHelper.KEY_CREATED_BY_USER),
                \(DBHelper.KEY_CREATE_ON),
                \(DBHelper.KEY_SYNC_CODE),
                \(DBHelper.KEY_SYNC_FLAG),
                \(DBHelper.KEY_SYNC_DATE),
                \(DBHelper.KEY_ANDROID_SYNC),
                \(DBHelper.KEY_SYNC_USER),
                \(DBHelper.KEY_PALLET_DETAIL_ID)) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
            """
        
        for obj in stickerArray {
            let arguments: [Any] = [
                obj["A"] as! String,
                obj["B"] as! String,
                obj["C"] as! String,
                obj["D"] as! String,
                obj["E"] as! String,
                obj["F"] as! String,
                obj["G"] as! String,
                obj["H"] as! String,
                obj["I"] as! String,
                obj["J"] as! String,
                obj["K"] as! String,
                obj["L"] as! String,
                obj["M"] as! String,
                obj["N"] as! String,
                obj["O"] as! String,
                obj["P"] as! String,
                obj["Q"] as! String
            ]
            
            try database.executeUpdate(insertSQL, values: arguments)
            print("insert TABLE_STICKER_DETAILS_COPY")
        }
        
        try database.executeUpdate("DELETE FROM ishop_sticker_details\n" +
                                   "      WHERE sticker_details_id IN (\n" +
                                   "    SELECT st.sticker_details_id\n" +
                                   "      FROM ishop_sticker_details AS st\n" +
                                   "           INNER JOIN\n" +
                                   "           ishop_sticker_details_copy AS st_copy ON st.sticker_details_id = st_copy.sticker_details_id\n" +
                                   ");", values: nil)
        
        print("LOGGED_IN:: \(loginId)")
        
        if customerLevel != "L4" && roleCode != "FO" {
            try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_STICKER_DETAILS_COPY) WHERE customer_id <> '\(loginId)'", values: nil)
        }
        
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_STICKER_DETAILS_COPY) WHERE android_sync='D'", values: nil)
        
        if customerLevel == "L3" || customerLevel == "L2" {
            try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_STICKER_DETAILS_COPY) WHERE android_sync='R'", values: nil)
        }
        
        try database.executeUpdate("Insert into \(DBHelper.TABLE_STICKER_DETAILS) (sticker_details_id, sticker_id, btc_no_in, btc_no_out, qr_code_in, qr_code_out, sticker_no, isBuffer, customer_type_country_id, customer_id, deleted, created_by_user, created_on, sync_code, sync_flag, sync_date, android_sync, pallet_details_id, sync_by_user) SELECT sticker_details_id, sticker_id, btc_no_in, btc_no_out, qr_code_in, qr_code_out, sticker_no, isBuffer, customer_type_country_id, customer_id, deleted, created_by_user, created_on, sync_code, sync_flag, sync_date, android_sync, pallet_details_id, sync_by_user from \(DBHelper.TABLE_STICKER_DETAILS_COPY)", values: nil)
        
        try database.executeUpdate("delete from \(DBHelper.TABLE_STICKER_DETAILS_COPY)", values: nil)
        
        database.commit()
        
    } catch {
        print("FMDB exception: \(error)")
        return false
    }
    
    let endTime = Date().timeIntervalSince1970 * 1000
    print("INSERT_TRACK END TIME:: \(endTime)")
    print("---------------------------")
    
    return true
}

func insertCFADispatchProductNew1(arrayCfaDispatchProduct: [[String: Any]],database:FMDatabase) {
    
    do {
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_CFA_DISPATCH_PRODUCT_COPY)", values: nil)
        database.beginTransaction()
        
        let insertSQL = """
                INSERT INTO \(DBHelper.TABLE_CFA_DISPATCH_PRODUCT_COPY)
                (\(DBHelper.KEY_CFA_DISPATCH_PRODUCT_ID),
                \(DBHelper.KEY_CFA_DISPATCH_ID),
                \(DBHelper.KEY_PRODUCT_SKU_ID),
                \(DBHelper.KEY_STICKER_DETAILS_ID),
                \(DBHelper.KEY_BTC_NO_OUT),
                \(DBHelper.KEY_QR_CODE_OUT),
                \(DBHelper.KEY_QUANTITY),
                \(DBHelper.KEY_AMOUNT),
                \(DBHelper.KEY_UNIT),
                \(DBHelper.KEY_QTY_KGL),
                \(DBHelper.KEY_IS_VALID),
                \(DBHelper.KEY_SYNC_CODE),
                \(DBHelper.KEY_SYNC_FLAG),
                \(DBHelper.KEY_SYNC_DATE),
                \(DBHelper.KEY_SYNC_USER),
                \(DBHelper.KEY_RECEIVED),
                \(DBHelper.KEY_RECEIVED_DATE),
                \(DBHelper.DISPATCH_SCAN_TYPE)) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
            """
        
        for object in arrayCfaDispatchProduct {
            let arguments: [Any] = [
                object["A"] as! String,
                object["B"] as! String,
                object["C"] as! String,
                object["D"] as! String,
                object["E"] as! String,
                object["F"] as! String,
                object["G"] as! String,
                object["H"] as! String,
                object["I"] as! String,
                object["J"] as! String,
                object["K"] as! String,
                object["N"] as! String,
                object["O"] as! String,
                object["P"] as! String,
                object["Q"] as! String,
                object["L"] as! String,
                object["M"] as! String,
                object["R"] as! String
            ]
            
            try database.executeUpdate(insertSQL, values: arguments)
            print("KEY_DISPATCH_PRODUCT KEY_CFA_DISPATCH_PRODUCT_ID")
        }
        
        manageProductTable(database: database)
        
        database.commit()
        
    } catch {
        print("FMDB exception: \(error)")
        // Handle the error as needed
    }
    //        finally {
    //            database.endTransaction()
    //        }
}

func manageProductTable(database:FMDatabase) {
    // Delete new data from the original table
    do {
        try database.executeUpdate("DELETE FROM bf_ishop_cfa_dispatch_product WHERE sync_code IN (SELECT st.sync_code FROM bf_ishop_cfa_dispatch_product AS st INNER JOIN bf_ishop_cfa_dispatch_product_copy AS st_copy ON st.sync_code = st_copy.sync_code);", values: nil)
        
        try database.executeUpdate("INSERT INTO bf_ishop_cfa_dispatch_product (cfa_dispatch_product_id, cfa_dispatch_id, product_sku_id, sticker_details_id, btc_no_out, qr_code_out, quantity, amount, unit, qty_kgl, is_valid, sync_code, sync_flag, sync_date, sync_by_user, received, received_date, dispatch_scan_type) SELECT cfa_dispatch_product_id, cfa_dispatch_id, product_sku_id, sticker_details_id, btc_no_out, qr_code_out, quantity, amount, unit, qty_kgl, is_valid, sync_code, sync_flag, sync_date, sync_by_user, received, received_date, dispatch_scan_type FROM bf_ishop_cfa_dispatch_product_copy;", values: nil)
        
        // Delete copy table data
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_CFA_DISPATCH_PRODUCT_COPY)", values: nil)
    } catch {
        print("FMDB exception: \(error)")
        // Handle the error as needed
    }
}

func insertSampleFocDispatchProduct(arraySampleDispatchProduct: [[String: Any]],database:FMDatabase) {
    do {
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_ISHOP_SAMPLE_DISPATCH_PRODUCT_COPY)", values: nil)
        database.beginTransaction()
        
        let insertSQL = """
                INSERT INTO \(DBHelper.TABLE_ISHOP_SAMPLE_DISPATCH_PRODUCT_COPY)
                (\(DBHelper.COL_SAMPLE_DISPATCH_PRODUCT_ID),
                \(DBHelper.COL_SAMPLE_DISPATCH_ID),
                \(DBHelper.KEY_PRODUCT_SKU_ID),
                \(DBHelper.KEY_STICKER_DETAILS_ID),
                \(DBHelper.KEY_BTC_NO_OUT),
                \(DBHelper.KEY_QR_CODE_OUT),
                \(DBHelper.KEY_QUANTITY),
                \(DBHelper.KEY_AMOUNT),
                \(DBHelper.KEY_UNIT),
                \(DBHelper.KEY_QTY_KGL),
                \(DBHelper.KEY_IS_VALID),
                \(DBHelper.KEY_SYNC_CODE),
                \(DBHelper.KEY_SYNC_FLAG),
                \(DBHelper.KEY_SYNC_DATE),
                \(DBHelper.KEY_SYNC_USER),
                \(DBHelper.KEY_RECEIVED),
                \(DBHelper.KEY_RECEIVED_DATE),
                \(DBHelper.DISPATCH_SCAN_TYPE))
                VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
            """
        
        for object in arraySampleDispatchProduct {
            let arguments: [Any] = [
                object["A"] as! String,
                object["B"] as! String,
                object["C"] as! String,
                object["D"] as! String,
                object["E"] as! String,
                object["F"] as! String,
                object["G"] as! String,
                object["H"] as! String,
                object["I"] as! String,
                object["J"] as! String,
                object["K"] as! String,
                object["N"] as! String,
                object["O"] as! String,
                object["P"] as! String,
                object["Q"] as! String,
                object["L"] as! String,
                object["M"] as! String,
                object["R"] as! String
            ]
            
            try database.executeUpdate(insertSQL, values: arguments)
            print("insert \(DBHelper.TABLE_ISHOP_SAMPLE_DISPATCH_PRODUCT_COPY)")
        }
        
        manageProductTableSampleFoc(database: database)
        database.commit()
        
    } catch {
        print("FMDB exception: \(error)")
        // Handle the error as needed
    }
    
    //        database.endTransaction()
}

func manageProductTableSampleFoc(database:FMDatabase) {
    do {
        // Delete new data from the original table
        try database.executeUpdate("""
                DELETE FROM bf_ishop_sample_dispatch_product
                WHERE sync_code IN (
                    SELECT st.sync_code
                    FROM bf_ishop_sample_dispatch_product AS st
                    INNER JOIN
                    bf_ishop_sample_dispatch_product_copy AS st_copy ON st.sync_code = st_copy.sync_code
                );
            """, values: nil)
        
        // Insert into the original table from the copy table
        try database.executeUpdate("""
                INSERT INTO bf_ishop_sample_dispatch_product (
                    sample_dispatch_product_id,
                    sample_dispatch_id,
                    product_sku_id,
                    sticker_details_id,
                    btc_no_out,
                    qr_code_out,
                    quantity,
                    amount,
                    unit,
                    qty_kgl,
                    is_valid,
                    sync_code,
                    sync_flag,
                    sync_date,
                    sync_by_user,
                    received,
                    received_date,
                    dispatch_scan_type
                )
                SELECT
                    sample_dispatch_product_id,
                    sample_dispatch_id,
                    product_sku_id,
                    sticker_details_id,
                    btc_no_out,
                    qr_code_out,
                    quantity,
                    amount,
                    unit,
                    qty_kgl,
                    is_valid,
                    sync_code,
                    sync_flag,
                    sync_date,
                    sync_by_user,
                    received,
                    received_date,
                    dispatch_scan_type
                FROM bf_ishop_sample_dispatch_product_copy;
            """, values: nil)
        
        // Delete data from the copy table
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_ISHOP_SAMPLE_DISPATCH_PRODUCT_COPY)", values: nil)
    } catch {
        print("FMDB exception: \(error)")
        // Handle the error as needed
    }
}

func deleteSampleProductTable(database:FMDatabase) {
    do {
        
        try database.executeUpdate("DELETE FROM bf_ishop_sample_dispatch_product", values: nil)
        
    } catch {
        print("FMDB exception: \(error)")
        // Handle the error as needed
    }
}

func insertEmployeeDetails(jsonArrayEmployeeDetails: [[String: Any]], fileName: String,database:FMDatabase) {
    if fileName == "1.txt" {
        database.executeStatements("DELETE FROM \(DBHelper.TABLE_EMPLOYEE_DETAILS)")
    }
    
    database.beginTransaction()
    
    do {
        let sql = """
                INSERT INTO \(DBHelper.TABLE_EMPLOYEE_DETAILS)
                (\(DBHelper.KEY_ID), \(DBHelper.KEY_EMAIL), \(DBHelper.KEY_USER_CODE),
                \(DBHelper.KEY_BUSSINESS_CODE), \(DBHelper.KEY_DISPLAY_NAME), \(DBHelper.KEY_PRIMARY_MOBILE_NO),
                \(DBHelper.KEY_POLITICAL_GEO_ID), \(DBHelper.KEY_political_geography_countrylevel_id),
                \(DBHelper.KEY_political_regional_level), \(DBHelper.KEY_EMPLOYEE_TYPE_REGIONAL_LEVEL))
                VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
            """
        
        for object in jsonArrayEmployeeDetails {
            let arguments: [Any] = [
                object["A"] as! String,
                object["B"] as! String,
                object["C"] as! String,
                object["D"] as! String,
                object["E"] as! String,
                object["F"] as! String,
                object["G"] as! String,
                object["H"] as! String,
                object["I"] as! String,
                object["J"] as! String
            ]
            
            try database.executeUpdate(sql, values: arguments)
        }
        
        print("INSERT COMPLETE")
        database.commit()
    } catch {
        print("FMDB exception: \(error.localizedDescription)")
        // Handle the error as needed
    }
}

func insertIshopStickerNew(ishopSticker: [[String: Any]],database:FMDatabase) {
    do {
        try database.executeStatements("DELETE FROM \(DBHelper.TABLE_STICKER_COPY)")
        try database.beginTransaction()
        
        let sql = """
                INSERT INTO \(DBHelper.TABLE_STICKER_COPY)
                (\(DBHelper.KEY_STICKER_ID), \(DBHelper.KEY_REF_ID), \(DBHelper.KEY_CUSTOMER_ID),
                \(DBHelper.KEY_COUNTRY_ID), \(DBHelper.KEY_PBG_COUNTRY_ID), \(DBHelper.KEY_PRODUCT_SKU_COUNTRY_ID),
                \(DBHelper.KEY_BATCH_NO), \(DBHelper.KEY_EXPIRE_DATE), \(DBHelper.KEY_QUANTITY),
                \(DBHelper.KEY_STATUS), \(DBHelper.KEY_SYNC_CODE), \(DBHelper.KEY_SYNC_FLAG),
                \(DBHelper.KEY_SYNC_DATE), \(DBHelper.KEY_SYNC_DATE), \(DBHelper.KEY_BATCH_ID))
                VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
            """
        
        for object in ishopSticker {
            let arguments: [Any] = [
                object["A"] as! String,
                object["B"] as! String,
                object["C"] as! String,
                object["D"] as! String,
                object["E"] as! String,
                object["F"] as! String,
                object["G"] as! String,
                object["H"] as! String,
                object["I"] as! String,
                object["J"] as! String,
                object["K"] as! String,
                object["L"] as! String,
                object["M"] as! String,
                object["N"] as! String,
                object["O"] as! String
            ]
            
            try database.executeUpdate(sql, values: arguments)
        }
        
        manageIshopSticker(database: database)
        database.commit()
        
    } catch {
        print("FMDB exception: \(error.localizedDescription)")
        // Handle the error as needed
    }
    
    //        database?.endTransaction()
}

func manageIshopSticker(database:FMDatabase) {
    do {
        database.executeStatements("DELETE FROM \(DBHelper.TABLE_STICKER)")
        database.executeStatements("""
                INSERT INTO \(DBHelper.TABLE_STICKER) (
                    sticker_id, ref_Id, system_code, toller_code, customer_id, country_id, production_date,
                    PBG_Country_Id, product_sku_country_id, batch_no, batch_id, mfg_date, expire_date,
                    quantity, buffer, status, draft, draft_date, draft_reason, deleted, created_by_user,
                    created_on, modified_by_user, modified_on, sync_code, sync_flag, sync_date, sync_by_user
                )
                SELECT sticker_id, ref_Id, system_code, toller_code, customer_id, country_id, production_date,
                    PBG_Country_Id, product_sku_country_id, batch_no, batch_id, mfg_date, expire_date,
                    quantity, buffer, status, draft, draft_date, draft_reason, deleted, created_by_user,
                    created_on, modified_by_user, modified_on, sync_code, sync_flag, sync_date, sync_by_user
                FROM \(DBHelper.TABLE_STICKER_COPY)
            """)
        
        // delete copy table data
        database.executeStatements("DELETE FROM \(DBHelper.TABLE_STICKER_COPY)")
        
    } catch {
        print("FMDB exception: \(error.localizedDescription)")
        // Handle the error as needed
    }
}

/*func insertTollerDispatchNew(ishopTollerDispatch: [[String: Any]], fileName: String,database:FMDatabase) -> Bool {
    let table = DBHelper.OPTIMIZE_MAIN_TABLE ? DBHelper.TABLE_TOLLER_DISPATCH_COPY : DBHelper.TABLE_TOLLER_DISPATCH
    let deleteTable = DBHelper.OPTIMIZE_MAIN_TABLE ? DBHelper.TABLE_TOLLER_DISPATCH : DBHelper.TABLE_TOLLER_DISPATCH_COPY
    
    if !DBHelper.OPTIMIZE_MAIN_TABLE {
        if fileName == "1.txt" {
            do {
                try database.executeStatements("DELETE FROM \(deleteTable)")
            } catch {
                print("FMDB exception: \(error.localizedDescription)")
                return false
            }
        }
    } else {
        do {
            try database.executeStatements("DELETE FROM \(deleteTable)")
        } catch {
            print("FMDB exception: \(error.localizedDescription)")
            return false
        }
    }
    
    do {
        database.beginTransaction()
        
        let sql = """
                INSERT INTO \(table) (
                    toller_dispatch_id, customer_from_id, customer_to_id, dispatch_date, document_no, country_id,
                    created_by_user, modified_by_user, status, created_on, modified_on, sync_code, sync_flag,
                    sync_date, sync_by_user, received, isRead, read_date, received_date, reject, rejected_date
                ) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
            """
        
        for item in ishopTollerDispatch {
            do {
                try database.executeUpdate(sql, values: [
                    item["A"] as! String,
                    item["B"] as! String,
                    item["C"] as! String,
                    item["D"] as! String,
                    item["E"] as! String,
                    item["F"] as! String,
                    item["K"] as! String,
                    item["L"] as! String,
                    item["M"] as! String,
                    item["N"] as! String,
                    item["O"] as! String,
                    item["P"] as! String,
                    item["Q"] as! String,
                    item["R"] as! String,
                    item["S"] as! String,
                    item["G"] as! String,
                    item["I"] as! String,
                    item["J"] as! String,
                    item["H"] as! String,
                    item["T"] as! String,
                    item["U"] as! String
                ])
            } catch {
                print("FMDB exception: \(error.localizedDescription)")
                database.rollback()
                return false
            }
        }
        
        if DBHelper.OPTIMIZE_MAIN_TABLE {
            manageTollerDispatchCopy(database: database)
        }
        
        database.commit()
        
        return true
    } catch {
        print("FMDB exception: \(error.localizedDescription)")
        return false
    }
}*/

func insertTollerDispatchNew(ishopTollerDispatch: [[String: Any]], fileName: String, database: FMDatabase) -> Bool {
    let table = DBHelper.OPTIMIZE_MAIN_TABLE ? DBHelper.TABLE_TOLLER_DISPATCH_COPY : DBHelper.TABLE_TOLLER_DISPATCH
    let deleteTable = DBHelper.OPTIMIZE_MAIN_TABLE ? DBHelper.TABLE_TOLLER_DISPATCH : DBHelper.TABLE_TOLLER_DISPATCH_COPY

    if !DBHelper.OPTIMIZE_MAIN_TABLE {
        if fileName == "1.txt" {
            do {
                try database.executeUpdate("DELETE FROM \(deleteTable)", values: nil)
            } catch {
                print("FMDB exception: \(error.localizedDescription)")
                return false
            }
        }
    } else {
        do {
            try database.executeUpdate("DELETE FROM \(deleteTable)", values: nil)
        } catch {
            print("FMDB exception: \(error.localizedDescription)")
            return false
        }
    }

    do {
        database.beginTransaction()

        let sql = """
            INSERT INTO \(table) (
                toller_dispatch_id, customer_from_id, customer_to_id, dispatch_date, document_no, country_id,
                created_by_user, modified_by_user, status, created_on, modified_on, sync_code, sync_flag,
                sync_date, sync_by_user, received, isRead, read_date, received_date, reject, rejected_date
            ) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
        """

        for item in ishopTollerDispatch {
            do {
                try database.executeUpdate(sql, values: [
                    item["A"] as! String,
                    item["B"] as! String,
                    item["C"] as! String,
                    item["D"] as! String,
                    item["E"] as! String,
                    item["F"] as! String,
                    item["K"] as! String,
                    item["L"] as! String,
                    item["M"] as! String,
                    item["N"] as! String,
                    item["O"] as! String,
                    item["P"] as! String,
                    item["Q"] as! String,
                    item["R"] as! String,
                    item["S"] as! String,
                    item["G"] as! String,
                    item["I"] as! String,
                    item["J"] as! String,
                    item["H"] as! String,
                    item["T"] as! String,
                    item["U"] as! String
                ])
            } catch {
                print("FMDB exception: \(error.localizedDescription)")
                database.rollback()
                return false
            }
        }

        if DBHelper.OPTIMIZE_MAIN_TABLE {
            manageTollerDispatchCopy(database: database)
        }

        database.commit()
        return true
    } catch {
        print("FMDB exception: \(error.localizedDescription)")
        database.rollback()
        return false
    }
}



func manageTollerDispatchCopy(database:FMDatabase) {
    let deleteQuery = """
            DELETE FROM bf_ishop_toller_dispatch
            WHERE sync_code IN (
                SELECT st.sync_code
                FROM bf_ishop_toller_dispatch AS st
                INNER JOIN
                bf_ishop_toller_dispatch_copy AS st_copy ON st.sync_code = st_copy.sync_code
            );
        """
    
    let insertQuery = """
            INSERT INTO bf_ishop_toller_dispatch (
                toller_dispatch_id, customer_from_id, customer_to_id, dispatch_date, document_no,
                country_id, created_by_user, modified_by_user, status, created_on, modified_on,
                sync_code, sync_flag, sync_date, sync_by_user, received, isRead, read_date,
                received_date, reject, rejected_date, rejected_comment
            )
            SELECT
                toller_dispatch_id, customer_from_id, customer_to_id, dispatch_date, document_no,
                country_id, created_by_user, modified_by_user, status, created_on, modified_on,
                sync_code, sync_flag, sync_date, sync_by_user, received, isRead, read_date,
                received_date, reject, rejected_date, rejected_comment
            FROM bf_ishop_toller_dispatch_copy;
        """
    
    let deleteCopyTableQuery = "DELETE FROM \(DBHelper.TABLE_TOLLER_DISPATCH_COPY)"
    
    do {
        database.beginTransaction()
        
        database.executeStatements(deleteQuery)
        database.executeStatements(insertQuery)
        database.executeStatements(deleteCopyTableQuery)
        
        database.commit()
    } catch {
        print("FMDB exception: \(error.localizedDescription)")
    }
}

func insertTollerDispatchProductNew(ishopTollerDispatchProduct: [[String: Any]],database:FMDatabase) {
    let table = DBHelper.OPTIMIZE_MAIN_TABLE ? DBHelper.TABLE_TOLLER_DISPATCH_PRODUCT_COPY : DBHelper.TABLE_TOLLER_DISPATCH_PRODUCT
    let deleteTable = DBHelper.OPTIMIZE_MAIN_TABLE ? DBHelper.TABLE_TOLLER_DISPATCH_PRODUCT : DBHelper.TABLE_TOLLER_DISPATCH_PRODUCT_COPY
    
    do {
        database.beginTransaction()
        
        // Delete existing data from the specified table
        database.executeStatements("DELETE FROM \(deleteTable)")
        
        // Prepare and execute the INSERT SQL statement
        let sql = """
                INSERT INTO \(table) (
                    toller_dispatch_product_id, toller_dispatch_id, product_sku_country_id,
                    sticker_id, batch_no, quantity, amount, unit, qty_kgl, received, received_date,
                    sync_code, sync_flag, sync_date, sync_by_user
                ) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
            """
        
        for item in ishopTollerDispatchProduct {
            do {
                try database.executeUpdate(sql, values: [
                    //NSNumber(value: item["A"] as! Int64), // toller_dispatch_product_id
                    //NSNumber(value: item["B"] as! Int64), // toller_dispatch_id
                    //NSNumber(value: item["C"] as! Int64), // product_sku_country_id
                    //NSNumber(value: item["D"] as! Int64), // sticker_id
                    item["A"] as! String,
                    item["B"] as! String,
                    item["C"] as! String,
                    item["D"] as! String,
                    item["E"] as! String, // batch_no
                    item["F"] as! String, // quantity
                    item["G"] as! String, // amount
                    item["H"] as! String, // unit
                    item["I"] as! String, // qty_kgl
                    item["J"] as! String, // received
                    item["K"] as! String, // received_date
                    item["L"] as! String, // sync_code
                    item["M"] as! String, // sync_flag
                    item["N"] as! String, // sync_date
                    item["O"] as! String  // sync_by_user
                ])
            } catch {
                print("FMDB exception: \(error.localizedDescription)")
                database.rollback()
                return
            }
        }
        
        if DBHelper.OPTIMIZE_MAIN_TABLE {
            manageTollerDispatchProduct(database: database)
        }
        
        database.commit()
        
    } catch {
        print("FMDB exception: \(error.localizedDescription)")
        return
    }
}

func manageTollerDispatchProduct(database:FMDatabase) {
    //        guard let database = FMDatabase(path: YourDatabasePath) else {
    //            print("Unable to open database")
    //            return
    //        }
    
    //        database.open()
    
    // Delete new data from the original table
    let deleteQuery = """
            DELETE FROM bf_ishop_toller_dispatch_product
            WHERE sync_code IN (
                SELECT st.sync_code
                FROM bf_ishop_toller_dispatch_product AS st
                INNER JOIN
                bf_ishop_toller_dispatch_product_copy AS st_copy ON st.sync_code = st_copy.sync_code
            );
        """
    do {
        try database.executeUpdate(deleteQuery, values: nil)
    } catch {
        print("Error executing DELETE query: \(error.localizedDescription)")
    }
    
    // Insert into the original table from the copy table
    let insertQuery = """
            INSERT INTO bf_ishop_toller_dispatch_product (
                toller_dispatch_product_id,
                toller_dispatch_id,
                product_sku_country_id,
                sticker_id,
                batch_no,
                qr_code_out,
                quantity,
                amount,
                unit,
                qty_kgl,
                received,
                received_date,
                isRead,
                read_date,
                sync_code,
                sync_flag,
                sync_date,
                sync_by_user
            )
            SELECT toller_dispatch_product_id,
                toller_dispatch_id,
                product_sku_country_id,
                sticker_id,
                batch_no,
                qr_code_out,
                quantity,
                amount,
                unit,
                qty_kgl,
                received,
                received_date,
                isRead,
                read_date,
                sync_code,
                sync_flag,
                sync_date,
                sync_by_user
            FROM bf_ishop_toller_dispatch_product_copy;
        """
    do {
        try database.executeUpdate(insertQuery, values: nil)
    } catch {
        print("Error executing INSERT query: \(error.localizedDescription)")
    }
    
    // Delete data from the copy table
    let deleteCopyQuery = "DELETE FROM \(DBHelper.TABLE_TOLLER_DISPATCH_PRODUCT_COPY);"
    do {
        try database.executeUpdate(deleteCopyQuery, values: nil)
    } catch {
        print("Error executing DELETE query for copy table: \(error.localizedDescription)")
    }
    
}

func insertDistributorDispatchProductNew(ishopDistributorDispatchProduct: [[String: Any]],database:FMDatabase) {
    let table = DBHelper.OPTIMIZE_MAIN_TABLE ? DBHelper.TABLE_DISTRIBUTOR_DISPATCH_PRODUCT_COPY : DBHelper.TABLE_DISTRIBUTOR_DISPATCH_PRODUCT
    let deleteTable = DBHelper.OPTIMIZE_MAIN_TABLE ? DBHelper.TABLE_DISTRIBUTOR_DISPATCH_PRODUCT : DBHelper.TABLE_DISTRIBUTOR_DISPATCH_PRODUCT_COPY
    
    do {
        database.beginTransaction()
        
        // Delete existing data from the specified table
        database.executeStatements("DELETE FROM \(deleteTable)")
        
        // Prepare and execute the INSERT SQL statement
        let sql = """
                INSERT INTO \(table) (
                    distributor_dispatch_product_id, distributor_dispatch_id, product_sku_id, sticker_details_id,
                    btc_no_out, qr_code_out, quantity, amount, unit, qty_kgl, is_valid, sync_code, sync_flag,
                    sync_date, sync_by_user, received, received_date, dispatch_scan_type, btc_type
                ) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
            """
        
        for item in ishopDistributorDispatchProduct {
            do {
                try database.executeUpdate(sql, values: [
                    item["A"] as! String, // distributor_dispatch_product_id
                    item["B"] as! String, // distributor_dispatch_id
                    item["C"] as! String, // product_sku_id
                    item["D"] as! String, // sticker_details_id
                    item["E"] as! String, // btc_no_out
                    item["F"] as! String, // qr_code_out
                    item["G"] as! String, // quantity
                    item["H"] as! String, // amount
                    item["I"] as! String, // unit
                    item["J"] as! String, // qty_kgl
                    item["K"] as! String, // is_valid
                    item["N"] as! String, // sync_code
                    item["O"] as! String, // sync_flag
                    item["P"] as! String, // sync_date
                    item["Q"] as! String, // sync_by_user
                    item["L"] as! String, // received
                    item["M"] as! String, // received_date
                    item["R"] as! String, // dispatch_scan_type
                    item["S"] as! String  // btc_type
                ])
            } catch {
                print("FMDB exception: \(error.localizedDescription)")
                database.rollback()
                return
            }
        }
        
        manageDistributorProductTable(database: database)
        database.commit()
        
    } catch {
        print("FMDB exception: \(error.localizedDescription)")
        return
    }
}

func manageDistributorProductTable(database:FMDatabase) {
    do {
        // Delete rows from the main table where sync_code is present in the copy table
        try database.executeStatements("""
                DELETE FROM bf_ishop_distributor_dispatch_product
                WHERE sync_code IN (
                    SELECT st.sync_code
                    FROM bf_ishop_distributor_dispatch_product AS st
                    INNER JOIN bf_ishop_distributor_dispatch_product_copy AS st_copy
                    ON st.sync_code = st_copy.sync_code
                );
            """)
        
        // Insert rows into the main table from the copy table
        try database.executeStatements("""
                INSERT INTO bf_ishop_distributor_dispatch_product (
                    distributor_dispatch_product_id,
                    distributor_dispatch_id,
                    product_sku_id,
                    sticker_details_id,
                    btc_no_out,
                    qr_code_out,
                    quantity,
                    amount,
                    unit,
                    qty_kgl,
                    is_valid,
                    sync_code,
                    sync_flag,
                    sync_date,
                    sync_by_user,
                    received,
                    received_date,
                    dispatch_scan_type,
                    btc_type
                )
                SELECT
                    distributor_dispatch_product_id,
                    distributor_dispatch_id,
                    product_sku_id,
                    sticker_details_id,
                    btc_no_out,
                    qr_code_out,
                    quantity,
                    amount,
                    unit,
                    qty_kgl,
                    is_valid,
                    sync_code,
                    sync_flag,
                    sync_date,
                    sync_by_user,
                    received,
                    received_date,
                    dispatch_scan_type,
                    btc_type
                FROM bf_ishop_distributor_dispatch_product_copy;
            """)
        
        // Delete rows from the copy table
        try database.executeStatements("DELETE FROM " + DBHelper.TABLE_DISTRIBUTOR_DISPATCH_PRODUCT_COPY)
    } catch {
        print("FMDB exception: \(error.localizedDescription)")
        return
    }
}

func insertProductSkuCountry(arrayProductSkuCountry: [[String: Any]], fileName: String,database:FMDatabase) {
    let table = DBHelper.TABLE_MASTER_PRODUCT_SKU_COUNTRY
    
    if fileName.lowercased() == "1.txt" {
        do {
            database.executeStatements("DELETE FROM \(table)")
        } catch {
            print("FMDB exception: \(error.localizedDescription)")
            return
        }
    }
    
    do {
        database.beginTransaction()
        
        let sql = """
                INSERT INTO \(table) (
                    \(DBHelper.KEY_PRODUCT_SKU_COUNTRY_ID),
                    \(DBHelper.KEY_PRODUCT_SKU_ID),
                    \(DBHelper.KEY_PRODUCT_SKU_NAME),
                    \(DBHelper.KEY_COUNTRY_ID),
                    \(DBHelper.KEY_PBG_ID),
                    \(DBHelper.KEY_PRODUCT_SKU_CODE)
                ) VALUES (?, ?, ?, ?, ?, ?)
            """
        
        for item in arrayProductSkuCountry {
            do {
                try database.executeUpdate(sql, values: [
                    item["A"] as? String, // product_sku_country_id
                    item["B"] as? String, // product_sku_id
                    item["C"] as? String, // product_sku_name
                    item["D"] as? String, // country_id
                    item["E"] as? String, // PBG_ID
                    item["F"] as? String  // product_sku_code
                ])
            } catch {
                print("FMDB exception: \(error.localizedDescription)")
            }
        }
        
        database.commit()
    } catch {
        print("FMDB exception: \(error.localizedDescription)")
    }
}

func insertDistributorReturnProductNew(ishopDistributorReturnProduct: [[String: Any]],database:FMDatabase) {
    let table = DBHelper.TABLE_DISTRIBUTOR_RETURN_PRODUCT_COPY
    
    database.executeStatements("DELETE FROM \(table)")
    database.beginTransaction()
    
    let sql = """
            INSERT INTO \(table) (
                \(DBHelper.KEY_DISTRIBUTOR_RETURN_PRODUCT_ID),
                \(DBHelper.KEY_DISTRIBUTOR_RETURN_ID),
                \(DBHelper.KEY_PRODUCT_SKU_ID),
                \(DBHelper.KEY_STICKER_DETAILS_ID),
                \(DBHelper.KEY_BTC_NO_OUT),
                \(DBHelper.KEY_QR_CODE_OUT),
                \(DBHelper.KEY_QUANTITY),
                \(DBHelper.KEY_AMOUNT),
                \(DBHelper.KEY_UNIT),
                \(DBHelper.KEY_QTY_KGL),
                \(DBHelper.KEY_IS_VALID),
                \(DBHelper.KEY_SYNC_CODE),
                \(DBHelper.KEY_SYNC_FLAG),
                \(DBHelper.KEY_SYNC_DATE),
                \(DBHelper.KEY_SYNC_USER)
            ) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
        """
    
    for item in ishopDistributorReturnProduct {
        do {
            try database.executeUpdate(sql, values: [
                item["A"] as? String, // distributor_return_product_id
                item["B"] as? String, // distributor_return_id
                item["C"] as? String, // product_sku_id
                item["D"] as? String, // sticker_details_id
                item["E"] as? String, // btc_no_out
                item["F"] as? String, // qr_code_out
                item["G"] as? String, // quantity
                item["H"] as? String, // amount
                item["I"] as? String, // unit
                item["J"] as? String, // qty_kgl
                item["K"] as? String, // is_valid
                item["L"] as? String, // sync_code
                item["M"] as? String, // sync_flag
                item["N"] as? String, // sync_date
                item["O"] as? String  // sync_by_user
            ])
        } catch {
            print("FMDB exception: \(error.localizedDescription)")
        }
    }
    
    manageDistributorReturnProduct(database: database)
    database.commit()
    //        database.endTransaction()
}

private func manageDistributorReturnProduct(database:FMDatabase) {
    // Delete new data from the original table
    let deleteQuery = """
            DELETE FROM bf_ishop_distributor_return_product
            WHERE sync_code IN (
                SELECT st.sync_code
                FROM bf_ishop_distributor_return_product AS st
                INNER JOIN
                bf_ishop_distributor_return_product_copy AS st_copy ON st.sync_code = st_copy.sync_code
            );
        """
    
    // Insert into the original table from the copy table
    let insertQuery = """
            INSERT INTO bf_ishop_distributor_return_product (
                distributor_return_product_id,
                distributor_return_id,
                product_sku_id,
                sticker_details_id,
                btc_no_out,
                qr_code_out,
                quantity,
                amount,
                unit,
                qty_kgl,
                is_valid,
                sync_code,
                sync_flag,
                sync_date,
                sync_by_user
            )
            SELECT
                distributor_return_product_id,
                distributor_return_id,
                product_sku_id,
                sticker_details_id,
                btc_no_out,
                qr_code_out,
                quantity,
                amount,
                unit,
                qty_kgl,
                is_valid,
                sync_code,
                sync_flag,
                sync_date,
                sync_by_user
            FROM bf_ishop_distributor_return_product_copy;
        """
    
    // Delete copy table data
    let deleteCopyDataQuery = "DELETE FROM " + DBHelper.TABLE_DISTRIBUTOR_RETURN_PRODUCT_COPY
    
    do {
        database.executeStatements(deleteQuery)
        database.executeStatements(insertQuery)
        database.executeStatements(deleteCopyDataQuery)
    } catch {
        print("FMDB exception: \(error.localizedDescription)")
    }
}

func insertRetailerDispatchProductNew(ishopRetailerDispatchProduct: [[String: Any]],database:FMDatabase) {
    let table = DBHelper.TABLE_RETAILER_DISPATCH_PRODUCT_COPY
    
    do {
        try database.executeUpdate("DELETE FROM \(table)", values: nil)
    } catch {
        print("FMDB exception: \(error.localizedDescription)")
        return
    }
    
    database.beginTransaction()
    
    let sql = """
            INSERT INTO \(table) (
                \(DBHelper.KEY_RETAILER_DISPATCH_PRODUCT_ID),
                \(DBHelper.KEY_RETAILER_DISPATCH_ID),
                \(DBHelper.KEY_PRODUCT_SKU_ID),
                \(DBHelper.KEY_STICKER_DETAILS_ID),
                \(DBHelper.KEY_BTC_NO),
                \(DBHelper.KEY_qr_code),
                \(DBHelper.KEY_BTC_TYPE),
                \(DBHelper.KEY_QUANTITY),
                \(DBHelper.KEY_AMOUNT),
                \(DBHelper.KEY_UNIT),
                \(DBHelper.KEY_QTY_KGL),
                \(DBHelper.KEY_IS_VALID),
                \(DBHelper.KEY_RECEIVED),
                \(DBHelper.KEY_RECEIVED_DATE),
                \(DBHelper.KEY_SYNC_CODE),
                \(DBHelper.KEY_SYNC_FLAG),
                \(DBHelper.KEY_SYNC_DATE),
                \(DBHelper.KEY_SYNC_USER)
            ) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
        """
    
    for item in ishopRetailerDispatchProduct {
        do {
            try database.executeUpdate(sql, values: [
                item["A"] as? String ?? "",
                item["B"] as? String ?? "",
                item["C"] as? String ?? "",
                item["D"] as? String ?? "",
                item["E"] as? String ?? "",
                item["F"] as? String ?? "",
                item["G"] as? String ?? "",
                item["H"] as? String ?? "",
                item["I"] as? String ?? "",
                item["J"] as? String ?? "",
                item["K"] as? String ?? "",
                item["L"] as? String ?? "",
                item["M"] as? String ?? "",
                item["N"] as? String ?? "",
                item["O"] as? String ?? "",
                item["P"] as? String ?? "",
                item["Q"] as? String ?? "",
                item["R"] as? String ?? ""
            ])
        } catch {
            print("FMDB exception: \(error.localizedDescription)")
        }
    }
    
    manageRetailerDispatchProduct(database: database)
    database.commit()
    print("TABLE RetailerDispatchProduct Add SUCCESSFULLY")
}

private func manageRetailerDispatchProduct(database:FMDatabase) {
    // Delete new data from the original table
    let deleteQuery = """
            DELETE FROM bf_ishop_retailer_dispatch_product
            WHERE sync_code IN (
                SELECT st.sync_code
                FROM bf_ishop_retailer_dispatch_product AS st
                INNER JOIN bf_ishop_retailer_dispatch_product_copy AS st_copy ON st.sync_code = st_copy.sync_code
            );
        """
    do {
        try database.executeUpdate(deleteQuery, values: nil)
    } catch {
        print("FMDB exception: \(error.localizedDescription)")
        return
    }
    
    // Insert data from the copy table to the original table
    let insertQuery = """
            INSERT INTO bf_ishop_retailer_dispatch_product (
                retailer_dispatch_product_id,
                retailer_dispatch_id,
                product_sku_id,
                sticker_details_id,
                btc_no,
                qr_code,
                btc_type,
                quantity,
                amount,
                unit,
                qty_kgl,
                is_valid,
                received,
                received_date,
                sync_code,
                sync_flag,
                sync_date,
                sync_by_user,
                dispatch_scan_type
            )
            SELECT
                retailer_dispatch_product_id,
                retailer_dispatch_id,
                product_sku_id,
                sticker_details_id,
                btc_no,
                qr_code,
                btc_type,
                quantity,
                amount,
                unit,
                qty_kgl,
                is_valid,
                received,
                received_date,
                sync_code,
                sync_flag,
                sync_date,
                sync_by_user,
                dispatch_scan_type
            FROM bf_ishop_retailer_dispatch_product_copy;
        """
    do {
        try database.executeUpdate(insertQuery, values: nil)
    } catch {
        print("FMDB exception: \(error.localizedDescription)")
        return
    }
    
    // Delete data from the copy table
    let deleteCopyTableQuery = "DELETE FROM \(DBHelper.TABLE_RETAILER_DISPATCH_PRODUCT_COPY);"
    do {
        try database.executeUpdate(deleteCopyTableQuery, values: nil)
    } catch {
        print("FMDB exception: \(error.localizedDescription)")
    }
}

func insertRetailerReceivedProductNew(ishopRetailerReceivedProduct: [[String: Any]],database:FMDatabase) {
    let table = DBHelper.TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT_COPY
    
    do {
        try database.executeUpdate("DELETE FROM \(table)", values: nil)
    } catch {
        print("FMDB exception: \(error.localizedDescription)")
        return
    }
    
    database.beginTransaction()
    
    let sql = """
            INSERT INTO \(table) (
                \(DBHelper.RETAILER_RECEIVED_PRODUCT_ID),
                \(DBHelper.RETAILER_RECEIVED_ID),
                \(DBHelper.KEY_PRODUCT_SKU_ID),
                \(DBHelper.KEY_STICKER_DETAILS_ID),
                \(DBHelper.BTC_NO_OUT),
                \(DBHelper.KEY_QR_CODE_OUT),
                \(DBHelper.KEY_QUANTITY),
                \(DBHelper.KEY_AMOUNT),
                \(DBHelper.KEY_UNIT),
                \(DBHelper.KEY_QTY_KGL),
                \(DBHelper.KEY_IS_VALID),
                \(DBHelper.KEY_SYNC_CODE),
                \(DBHelper.KEY_SYNC_FLAG),
                \(DBHelper.KEY_SYNC_DATE),
                \(DBHelper.SYNC_BY_USER),
                \(DBHelper.KEY_CREATE_BY),
                \(DBHelper.KEY_CREATE_ON),
                \(DBHelper.KEY_OUT_POINT_CALCULATE),
                \(DBHelper.KEY_RECEIVE_SCAN_TYPE)
            ) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
        """
    
    for item in ishopRetailerReceivedProduct {
        do {
            try database.executeUpdate(sql, values: [
                item["A"] as? String ?? "",
                item["B"] as? String ?? "",
                item["C"] as? String ?? "",
                item["D"] as? String ?? "",
                item["E"] as? String ?? "",
                item["F"] as? String ?? "",
                item["G"] as? String ?? "",
                item["H"] as? String ?? "",
                item["I"] as? String ?? "",
                item["J"] as? String ?? "",
                item["K"] as? String ?? "",
                item["L"] as? String ?? "",
                item["M"] as? String ?? "",
                item["N"] as? String ?? "",
                item["O"] as? String ?? "",
                item["P"] as? String ?? "",
                item["Q"] as? String ?? "",
                item["R"] as? String ?? ""
            ])
            print("TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT Add SUCCESSFULLY")
        } catch {
            print("FMDB exception: \(error.localizedDescription)")
        }
    }
    
    manageRetailerReceiveProduct(database: database)
    database.commit()
    print("TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT Add SUCCESSFULLY")
}

private func manageRetailerReceiveProduct(database:FMDatabase) {
    // Delete new data from the original table
    let deleteQuery = """
            DELETE FROM bf_ishop_retailer_received_product
            WHERE sync_code IN (
                SELECT st.sync_code
                FROM bf_ishop_retailer_received_product AS st
                INNER JOIN bf_ishop_retailer_received_product_copy AS st_copy ON st.sync_code = st_copy.sync_code
            );
        """
    do {
        try database.executeUpdate(deleteQuery, values: nil)
    } catch {
        print("FMDB exception: \(error.localizedDescription)")
        return
    }
    
    // Insert data from the copy table to the original table
    let insertQuery = """
            INSERT INTO bf_ishop_retailer_received_product (
                retailer_received_product_id,
                retailer_received_id,
                product_sku_id,
                sticker_details_id,
                btc_no_out,
                qr_code_out,
                quantity,
                amount,
                unit,
                qty_kgl,
                is_valid,
                sync_code,
                sync_flag,
                sync_date,
                sync_by_user,
                created_by,
                created_on,
                out_point_calculate,
                received_scan_type
            )
            SELECT
                retailer_received_product_id,
                retailer_received_id,
                product_sku_id,
                sticker_details_id,
                btc_no_out,
                qr_code_out,
                quantity,
                amount,
                unit,
                qty_kgl,
                is_valid,
                sync_code,
                sync_flag,
                sync_date,
                sync_by_user,
                created_by,
                created_on,
                out_point_calculate,
                received_scan_type
            FROM bf_ishop_retailer_received_product_copy;
        """
    do {
        try database.executeUpdate(insertQuery, values: nil)
    } catch {
        print("FMDB exception: \(error.localizedDescription)")
        return
    }
    
    // Delete data from the copy table
    let deleteCopyTableQuery = "DELETE FROM \(DBHelper.TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT_COPY);"
    do {
        try database.executeUpdate(deleteCopyTableQuery, values: nil)
    } catch {
        print("FMDB exception: \(error.localizedDescription)")
    }
}

func insertProductTypeNameCountry(arrayProductTypeCountryName: [[String: Any]], fileName: String,database:FMDatabase) {
    if fileName.lowercased() == "1.txt" {
        do {
            try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_PRODUCT_TYPE_NAME_COUNTRY)", values: nil)
        } catch {
            print("FMDB exception: \(error.localizedDescription)")
            return
        }
    }
    
    database.beginTransaction()
    
    let sql = """
            INSERT INTO \(DBHelper.TABLE_PRODUCT_TYPE_NAME_COUNTRY) (
                \(DBHelper.KEY_PRODUCT_COUNTRY_ID),
                \(DBHelper.KEY_PRODUCT_REGIONAL_ID),
                \(DBHelper.KEY_PRODUCT_COUNTRY_NAME),
                \(DBHelper.KEY_PRODUCT_REGIONAL_CODE),
                \(DBHelper.KEY_DESCRIPTION),
                \(DBHelper.KEY_COUNTRY_ID),
                \(DBHelper.KEY_DELETED),
                \(DBHelper.KEY_STATUS)
            ) VALUES (?, ?, ?, ?, ?, ?, ?, ?)
        """
    
    for item in arrayProductTypeCountryName {
        do {
            try database.executeUpdate(sql, values: [
                item["A"] as? String ?? "",
                item["B"] as? String ?? "",
                item["C"] as? String ?? "",
                item["D"] as? String ?? "",
                item["E"] as? String ?? "",
                item["F"] as? String ?? "",
                item["G"] as? String ?? "",
                item["H"] as? String ?? ""
            ])
            print("TABLE_PRODUCT_TYPE_NAME_COUNTRY Add SUCCESSFULLY")
        } catch {
            print("FMDB exception: \(error.localizedDescription)")
        }
    }
    
    database.commit()
}

func insertSchemeMaster(jsonArray: [[String: Any]], fileName: String,database:FMDatabase) {
    if fileName.lowercased() == "1.txt" {
        do {
            try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_SCHEME_MASTER)", values: nil)
        } catch {
            print("FMDB exception: \(error.localizedDescription)")
            return
        }
    }
    
    database.beginTransaction()
    
    let sql = """
            INSERT INTO \(DBHelper.TABLE_SCHEME_MASTER) (
                \(DBHelper.KEY_SCHEME_ID),
                \(DBHelper.KEY_SCHEME_CODE),
                \(DBHelper.KEY_SCHEME_NAME),
                \(DBHelper.KEY_FROM_MONTH),
                \(DBHelper.KEY_TO_MONTH),
                \(DBHelper.KEY_PRODUCT_SKU_CODE),
                \(DBHelper.KEY_PRODUCT_SKU_NAME),
                \(DBHelper.KEY_VALUE_PER_POINT)
            ) VALUES (?, ?, ?, ?, ?, ?, ?, ?)
        """
    
    for item in jsonArray {
        do {
            try database.executeUpdate(sql, values: [
                item["A"] as? String ?? "",
                item["B"] as? String ?? "",
                item["C"] as? String ?? "",
                item["D"] as? String ?? "",
                item["E"] as? String ?? "",
                item["F"] as? String ?? "",
                item["G"] as? String ?? "",
                item["H"] as? String ?? ""
            ])
            print("TABLE_SCHEME_MASTER Add SUCCESSFULLY")
        } catch {
            print("FMDB exception: \(error.localizedDescription)")
        }
    }
    
    database.commit()
}

func insertCFADispatchNew(ishopCFADispatch: [[String: Any]], fileName: String,database:FMDatabase) -> Bool {
    //        LogHelper.printLog("TAG_DATA_CFA", "DAT::: \(ishopCFADispatch)")
    
    if !DBHelper.OPTIMIZE_MAIN_TABLE {
        if fileName.lowercased() == "1.txt" {
            do {
                try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_CFA_DISPATCH)", values: nil)
            } catch {
                print("FMDB exception: \(error.localizedDescription)")
                return false
            }
        }
        
        database.beginTransaction()
        
        let sql = """
                INSERT INTO \(DBHelper.TABLE_CFA_DISPATCH) (
                    \(DBHelper.KEY_CFA_DISPATCH_ID),
                    \(DBHelper.KEY_CUSTOMER_FROM_ID),
                    \(DBHelper.KEY_CUSTOMER_TO_ID),
                    \(DBHelper.KEY_SAP_ID),
                    \(DBHelper.KEY_DISPATCH_TYPE),
                    \(DBHelper.KEY_DO_STO_NO),
                    \(DBHelper.KEY_DISPATCH_DATE),
                    \(DBHelper.KEY_RECEIVED),
                    \(DBHelper.KEY_RECEIVED_DATE),
                    \(DBHelper.KEY_COUNTRY_ID),
                    \(DBHelper.KEY_CREATED_BY_USER),
                    \(DBHelper.KEY_MODIFIED_BY_USER),
                    \(DBHelper.KEY_STATUS),
                    \(DBHelper.KEY_CREATE_ON),
                    \(DBHelper.KEY_MODIFIED_ON),
                    \(DBHelper.KEY_SYNC_CODE),
                    \(DBHelper.KEY_SYNC_FLAG),
                    \(DBHelper.KEY_SYNC_DATE),
                    \(DBHelper.KEY_READ),
                    \(DBHelper.KEY_READ_DATE),
                    \(DBHelper.KEY_IS_DISPATCH),
                    \(DBHelper.KEY_SYNC_USER),
                    \(DBHelper.KEY_REJECT),
                    \(DBHelper.KEY_REJECT_DATE),
                    \(DBHelper.IS_DISPATCH_TYPE)
                ) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
            """
        
        for item in ishopCFADispatch {
            do {
                try database.executeUpdate(sql, values: [
                    item["A"] as? String ?? "",
                    item["B"] as? String ?? "",
                    item["C"] as? String ?? "",
                    item["D"] as? String ?? "",
                    item["E"] as? String ?? "",
                    item["F"] as? String ?? "",
                    item["G"] as? String ?? "",
                    item["H"] as? String ?? "",
                    item["I"] as? String ?? "",
                    item["L"] as? String ?? "",
                    item["M"] as? String ?? "",
                    item["N"] as? String ?? "",
                    item["O"] as? String ?? "",
                    item["P"] as? String ?? "",
                    item["Q"] as? String ?? "",
                    item["R"] as? String ?? "",
                    item["S"] as? String ?? "",
                    item["T"] as? String ?? "",
                    item["J"] as? String ?? "",
                    item["K"] as? String ?? "",
                    "1",
                    item["U"] as? String ?? "",
                    item["V"] as? String ?? "",
                    item["W"] as? String ?? "",
                    item["X"] as? String ?? ""
                ])
            } catch {
                print("FMDB exception: \(error.localizedDescription)")
                database.rollback()
                return false
            }
        }
        
        database.commit()
    } else {
        do {
            try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_CFA_DISPATCH_COPY)", values: nil)
        } catch {
            print("FMDB exception: \(error.localizedDescription)")
            return false
        }
        
        database.beginTransaction()
        
        let sql = """
                INSERT INTO \(DBHelper.TABLE_CFA_DISPATCH_COPY) (
                    \(DBHelper.KEY_CFA_DISPATCH_ID),
                    \(DBHelper.KEY_CUSTOMER_FROM_ID),
                    \(DBHelper.KEY_CUSTOMER_TO_ID),
                    \(DBHelper.KEY_SAP_ID),
                    \(DBHelper.KEY_DISPATCH_TYPE),
                    \(DBHelper.KEY_DO_STO_NO),
                    \(DBHelper.KEY_DISPATCH_DATE),
                    \(DBHelper.KEY_RECEIVED),
                    \(DBHelper.KEY_RECEIVED_DATE),
                    \(DBHelper.KEY_COUNTRY_ID),
                    \(DBHelper.KEY_CREATED_BY_USER),
                    \(DBHelper.KEY_MODIFIED_BY_USER),
                    \(DBHelper.KEY_STATUS),
                    \(DBHelper.KEY_CREATE_ON),
                    \(DBHelper.KEY_MODIFIED_ON),
                    \(DBHelper.KEY_SYNC_CODE),
                    \(DBHelper.KEY_SYNC_FLAG),
                    \(DBHelper.KEY_SYNC_DATE),
                    \(DBHelper.KEY_READ),
                    \(DBHelper.KEY_READ_DATE),
                    \(DBHelper.KEY_IS_DISPATCH),
                    \(DBHelper.KEY_SYNC_USER),
                    \(DBHelper.KEY_REJECT),
                    \(DBHelper.KEY_REJECT_DATE),
                    \(DBHelper.IS_DISPATCH_TYPE)
                ) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
            """
        
        for item in ishopCFADispatch {
            do {
                try database.executeUpdate(sql, values: [
                    item["A"] as? String ?? "",
                    item["B"] as? String ?? "",
                    item["C"] as? String ?? "",
                    item["D"] as? String ?? "",
                    item["E"] as? String ?? "",
                    item["F"] as? String ?? "",
                    item["G"] as? String ?? "",
                    item["H"] as? String ?? "",
                    item["I"] as? String ?? "",
                    item["L"] as? String ?? "",
                    item["M"] as? String ?? "",
                    item["N"] as? String ?? "",
                    item["O"] as? String ?? "",
                    item["P"] as? String ?? "",
                    item["Q"] as? String ?? "",
                    item["R"] as? String ?? "",
                    item["S"] as? String ?? "",
                    item["T"] as? String ?? "",
                    item["J"] as? String ?? "",
                    item["K"] as? String ?? "",
                    "1",
                    item["U"] as? String ?? "",
                    item["V"] as? String ?? "",
                    item["W"] as? String ?? "",
                    item["X"] as? String ?? ""
                ])
            } catch {
                print("FMDB exception: \(error.localizedDescription)")
                database.rollback()
                return false
            }
        }
        
        manageCfaDispatchCopy(database: database)
        
        database.commit()
    }
    
    return true
}

func manageCfaDispatchCopy(database:FMDatabase) {
    do {
        try database.executeUpdate("""
                DELETE FROM \(DBHelper.TABLE_CFA_DISPATCH)
                WHERE \(DBHelper.KEY_SYNC_CODE) IN (
                    SELECT st.\(DBHelper.KEY_SYNC_CODE)
                    FROM \(DBHelper.TABLE_CFA_DISPATCH) AS st
                    INNER JOIN
                    \(DBHelper.TABLE_CFA_DISPATCH_COPY) AS st_copy ON st.\(DBHelper.KEY_SYNC_CODE) = st_copy.\(DBHelper.KEY_SYNC_CODE)
                )
            """, values: nil)
        
        try database.executeUpdate("""
                INSERT INTO \(DBHelper.TABLE_CFA_DISPATCH) (
                    \(DBHelper.KEY_CFA_DISPATCH_ID),
                    \(DBHelper.KEY_CUSTOMER_FROM_ID),
                    \(DBHelper.KEY_CUSTOMER_TO_ID),
                    \(DBHelper.KEY_SAP_ID),
                    \(DBHelper.KEY_DISPATCH_TYPE),
                    \(DBHelper.KEY_DO_STO_NO),
                    \(DBHelper.KEY_DISPATCH_DATE),
                    \(DBHelper.KEY_RECEIVED),
                    \(DBHelper.KEY_RECEIVED_DATE),
                    \(DBHelper.KEY_COUNTRY_ID),
                    \(DBHelper.KEY_CREATED_BY_USER),
                    \(DBHelper.KEY_MODIFIED_BY_USER),
                    \(DBHelper.KEY_STATUS),
                    \(DBHelper.KEY_CREATE_ON),
                    \(DBHelper.KEY_MODIFIED_ON),
                    \(DBHelper.KEY_SYNC_CODE),
                    \(DBHelper.KEY_SYNC_FLAG),
                    \(DBHelper.KEY_SYNC_DATE),
                    \(DBHelper.KEY_READ),
                    \(DBHelper.KEY_READ_DATE),
                    \(DBHelper.KEY_IS_DISPATCH),
                    \(DBHelper.KEY_SYNC_USER),
                    \(DBHelper.KEY_REJECT),
                    \(DBHelper.KEY_REJECT_DATE),
                    \(DBHelper.IS_DISPATCH_TYPE)
                )
                SELECT
                    \(DBHelper.KEY_CFA_DISPATCH_ID),
                    \(DBHelper.KEY_CUSTOMER_FROM_ID),
                    \(DBHelper.KEY_CUSTOMER_TO_ID),
                    \(DBHelper.KEY_SAP_ID),
                    \(DBHelper.KEY_DISPATCH_TYPE),
                    \(DBHelper.KEY_DO_STO_NO),
                    \(DBHelper.KEY_DISPATCH_DATE),
                    \(DBHelper.KEY_RECEIVED),
                    \(DBHelper.KEY_RECEIVED_DATE),
                    \(DBHelper.KEY_COUNTRY_ID),
                    \(DBHelper.KEY_CREATED_BY_USER),
                    \(DBHelper.KEY_MODIFIED_BY_USER),
                    \(DBHelper.KEY_STATUS),
                    \(DBHelper.KEY_CREATE_ON),
                    \(DBHelper.KEY_MODIFIED_ON),
                    \(DBHelper.KEY_SYNC_CODE),
                    \(DBHelper.KEY_SYNC_FLAG),
                    \(DBHelper.KEY_SYNC_DATE),
                    \(DBHelper.KEY_READ),
                    \(DBHelper.KEY_READ_DATE),
                    \(DBHelper.KEY_IS_DISPATCH),
                    \(DBHelper.KEY_SYNC_USER),
                    \(DBHelper.KEY_REJECT),
                    \(DBHelper.KEY_REJECT_DATE),
                    \(DBHelper.IS_DISPATCH_TYPE)
                FROM \(DBHelper.TABLE_CFA_DISPATCH_COPY)
            """, values: nil)
        
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_CFA_DISPATCH_COPY)", values: nil)
    } catch {
        print("FMDB exception: \(error.localizedDescription)")
    }
}

func deleteSampleMainTable(database:FMDatabase) {
    do {
        try database.executeUpdate("delete from bf_ishop_sample_dispatch", values: nil)
        //            writeDB().close()
    } catch {
        print(error.localizedDescription)
    }
}

func insertSampleFocDispatchMain(ishopCFADispatch: [[String: Any]], fileName: String,database:FMDatabase) -> Bool {
    do {
        try database.executeStatements("DELETE FROM \(DBHelper.TABLE_ISHOP_SAMPLE_DISPATCH_COPY)")
        database.beginTransaction()
        
        let sql = "INSERT INTO \(DBHelper.TABLE_ISHOP_SAMPLE_DISPATCH_COPY) " +
        "(\(DBHelper.COL_SAMPLE_DISPATCH_ID), " +
        "\(DBHelper.KEY_CUSTOMER_FROM_ID), " +
        "\(DBHelper.KEY_CUSTOMER_TO_ID), " +
        "\(DBHelper.KEY_SAP_ID), " +
        "\(DBHelper.KEY_DISPATCH_TYPE), " +
        "\(DBHelper.KEY_DOC_NO), " +
        "\(DBHelper.KEY_DISPATCH_DATE), " +
        "\(DBHelper.KEY_RECEIVED), " +
        "\(DBHelper.KEY_RECEIVED_DATE), " +
        "\(DBHelper.KEY_COUNTRY_ID), " +
        "\(DBHelper.KEY_CREATED_BY_USER), " +
        "\(DBHelper.KEY_MODIFIED_BY_USER), " +
        "\(DBHelper.KEY_STATUS), " +
        "\(DBHelper.KEY_CREATE_ON), " +
        "\(DBHelper.KEY_MODIFIED_ON), " +
        "\(DBHelper.KEY_SYNC_CODE), " +
        "\(DBHelper.KEY_SYNC_FLAG), " +
        "\(DBHelper.KEY_SYNC_DATE), " +
        "\(DBHelper.KEY_SYNC_USER), " +
        "\(DBHelper.IS_DISPATCH_TYPE), " +
        "\(DBHelper.KEY_IS_DISPATCH)) " +
        "VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)"
        
        for object in ishopCFADispatch {
            do {
                try database.executeUpdate(sql, values: [
                    object["A"] as? String ?? "", // sample_dispatch_id
                    object["B"] as? String ?? "", // customer_from_id
                    object["C"] as? String ?? "", // customer_to_id
                    object["D"] as? String ?? "", // sap_id
                    object["E"] as? String ?? "", // dispatch_type
                    object["F"] as? String ?? "", // doc_no
                    object["G"] as? String ?? "", // dispatch_date
                    object["H"] as? String ?? "", // received
                    object["I"] as? String ?? "", // received_date
                    object["J"] as? String ?? "", // country_id
                    object["K"] as? String ?? "", // created_by_user
                    object["L"] as? String ?? "", // modified_by_user
                    object["M"] as? String ?? "", // status
                    object["N"] as? String ?? "", // created_on
                    object["O"] as? String ?? "", // modified_on
                    object["P"] as? String ?? "", // sync_code
                    object["Q"] as? String ?? "", // sync_flag
                    object["R"] as? String ?? "", // sync_date
                    object["S"] as? String ?? "", // sync_by_user
                    object["T"] as? String ?? "", // is_dispatch_type
                    "1" // key_is_dispatch
                ])
            } catch {
                print(error.localizedDescription)
                //                    if let callback = callback {
                //                        callback.onDatabaseError(String(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(error))
                //                    }
                //                    SynchronizationService.isSuccess = false
                //                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(error) + " In Method InsertCFADispatchNew"
                //                    database.rollback()
                return false
            }
        }
        
        manageSampleDispatchMain(database: database)
        
        database.commit()
    } catch {
        print(error.localizedDescription)
        //            if let callback = callback {
        //                callback.onDatabaseError(String(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(error))
        //            }
        //            SynchronizationService.isSuccess = false
        //            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(error) + " In Method InsertCFADispatchNew"
        //            database.rollback()
        return false
    }
    
    return true
}

func manageSampleDispatchMain(database:FMDatabase) {
    let deleteQuery = "DELETE FROM bf_ishop_sample_dispatch " +
    "WHERE sync_code IN (" +
    "    SELECT st.sync_code " +
    "    FROM bf_ishop_sample_dispatch AS st " +
    "    INNER JOIN " +
    "    bf_ishop_sample_dispatch_copy AS st_copy ON st.sync_code = st_copy.sync_code" +
    ");"
    
    do {
        try database.executeUpdate(deleteQuery, values: nil)
        
        let insertQuery = "INSERT INTO bf_ishop_sample_dispatch " +
        "(sample_dispatch_id, customer_from_id, customer_to_id, sap_id, dispatch_type, doc_no, dispatch_date, received, " +
        "received_date, country_id, created_by_user, modified_by_user, status, created_on, modified_on, sync_code, " +
        "sync_flag, sync_date, isDispatch, sync_by_user, is_dispatch_type) " +
        "SELECT sample_dispatch_id, customer_from_id, customer_to_id, sap_id, dispatch_type, doc_no, dispatch_date, " +
        "received, received_date, country_id, created_by_user, modified_by_user, status, created_on, modified_on, " +
        "sync_code, sync_flag, sync_date, isDispatch, sync_by_user, is_dispatch_type " +
        "FROM bf_ishop_sample_dispatch_copy;"
        
        try database.executeUpdate(insertQuery, values: nil)
        
        // Delete copy table data
        let deleteCopyQuery = "DELETE FROM \(DBHelper.TABLE_ISHOP_SAMPLE_DISPATCH_COPY);"
        try database.executeUpdate(deleteCopyQuery, values: nil)
    } catch {
        print("Error: \(error.localizedDescription)")
    }
}

func insertCustomerProductStock(arrayCPMCustomerProductStock: [[String: Any]], fileName: String,database:FMDatabase) {
    let deleteQuery = "DELETE FROM \(DBHelper.TABLE_CUSTOMER_PRODUCT_STOCK);"
    
    if fileName.caseInsensitiveCompare("1.txt") == .orderedSame {
        do {
            try database.executeUpdate(deleteQuery, values: nil)
        } catch {
            print("Error deleting records: \(error.localizedDescription)")
            return
        }
    }
    
    database.beginTransaction()
    
    let insertQuery = "INSERT INTO \(DBHelper.TABLE_CUSTOMER_PRODUCT_STOCK) " +
    "(\(DBHelper.KEY_CUSTOMER_PRODUCT_STOCK_ID), " +
    "\(DBHelper.KEY_CUSTOMER_ID), " +
    "\(DBHelper.KEY_PRODUCT_SKU_ID), " +
    "\(DBHelper.KEY_PRODUCT_STOCK_BOX), " +
    "\(DBHelper.KEY_PRODUCT_STOCK_KGL), " +
    "\(DBHelper.KEY_BATCH_NO), " +
    "\(DBHelper.KEY_EXPIRE_DATE)) " +
    "VALUES (?, ?, ?, ?, ?, ?, ?)"
    
    for object in arrayCPMCustomerProductStock {
        do {
            try database.executeUpdate(insertQuery, values: [
                object["A"] as? String ?? "", // cpm_customer_product_stock_id
                object["B"] as? String ?? "", // customer_id
                object["C"] as? String ?? "", // product_sku_id
                object["E"] as? String ?? "", // current_stock_box
                object["F"] as? String ?? "", // current_stock_kgl
                object["D"] as? String ?? "", // batch_no
                object["G"] as? String ?? ""  // expire_date
            ])
        } catch {
            print("Error inserting records: \(error.localizedDescription)")
        }
    }
    
    database.commit()
}

func insertDispatchBatchwiseStockCalculate(arrayCPMCustomerProductStock: [[String: Any]], fileName: String,database:FMDatabase) {
    let deleteQuery = "DELETE FROM \(DBHelper.TABLE_DISPATCH_BATCHWISE_STOCK_CALCULATE);"
    
    if fileName.caseInsensitiveCompare("1.txt") == .orderedSame {
        do {
            try database.executeUpdate(deleteQuery, values: nil)
        } catch {
            print("Error deleting records: \(error.localizedDescription)")
            return
        }
    }
    
    database.beginTransaction()
    
    let insertQuery = "INSERT INTO \(DBHelper.TABLE_DISPATCH_BATCHWISE_STOCK_CALCULATE) " +
    "(\(DBHelper.KEY_CUSTOMER_ID), " +
    "\(DBHelper.KEY_PRODUCT_SKU_ID), " +
    "\(DBHelper.KEY_PRODUCT_STOCK_BOX), " +
    "\(DBHelper.KEY_BATCH_NO), " +
    "\(DBHelper.KEY_REMAINING_STOCK_BOX), " +
    "\(DBHelper.KEY_NEW_REMAINING_STOCK_BOX)) " +
    "VALUES (?, ?, ?, ?, ?, ?)"
    
    for object in arrayCPMCustomerProductStock {
        do {
            try database.executeUpdate(insertQuery, values: [
                object["B"] as? String ?? "", // customer_id
                object["C"] as? String ?? "", // product_sku_id
                object["E"] as? String ?? "", // product_stock_box
                object["D"] as? String ?? "", // batch_no
                object["E"] as? String ?? "", // remaining_stock_box
                object["E"] as? String ?? ""  // new_remaining_stock_box
            ])
        } catch {
            print("Error inserting records: \(error.localizedDescription)")
        }
    }
    
    database.commit()
}

func insertDistributorReturnRequestProductNewForDist(ishopDistributorReturnRequestProduct: [[String: Any]],database:FMDatabase) {
    let deleteQuery = "DELETE FROM \(DBHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_COPY);"
    
    do {
        database.executeStatements(deleteQuery)
        
        database.beginTransaction()
        
        let insertQuery = "INSERT INTO \(DBHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_COPY) " +
        "(\(DBHelper.KEY_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_ID), " +
        "\(DBHelper.KEY_DISTRIBUTOR_RETURN_REQUEST_ID), " +
        "\(DBHelper.KEY_PRODUCT_SKU_ID), " +
        "\(DBHelper.KEY_STICKER_DETAILS_ID), " +
        "\(DBHelper.KEY_BTC_NO_OUT), " +
        "\(DBHelper.KEY_QR_CODE_OUT), " +
        "\(DBHelper.KEY_QUANTITY), " +
        "\(DBHelper.KEY_AMOUNT), " +
        "\(DBHelper.KEY_UNIT), " +
        "\(DBHelper.KEY_QTY_KGL), " +
        "\(DBHelper.KEY_IS_VALID), " +
        "\(DBHelper.KEY_RECEIVED), " +
        "\(DBHelper.KEY_RECEIVED_DATE), " +
        "\(DBHelper.KEY_SYNC_CODE), " +
        "\(DBHelper.KEY_SYNC_FLAG), " +
        "\(DBHelper.KEY_SYNC_DATE), " +
        "\(DBHelper.KEY_SYNC_USER), " +
        "\(DBHelper.KEY_REJECT), " +
        "\(DBHelper.KEY_REJECT_DATE)) " +
        "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)"
        
        for object in ishopDistributorReturnRequestProduct {
            do {
                try database.executeUpdate(insertQuery, values: [
                    object["A"] ?? "", // distributor_return_request_product_id
                    object["B"] ?? "", // distributor_return_request_id
                    object["C"] ?? "", // product_sku_id
                    object["D"] ?? "", // sticker_details_id
                    object["E"] ?? "", // btc_no_out
                    object["F"] ?? "", // qr_code_out
                    object["G"]  ?? "", // quantity
                    object["H"] ?? "", // amount
                    object["I"] ?? "", // unit
                    object["J"] ?? "", // qty_kgl
                    object["M"] ?? "", // is_valid
                    object["K"] ?? "", // received
                    object["L"] ?? "", // received_date
                    object["N"] ?? "", // sync_code
                    object["O"]  ?? "", // sync_flag
                    object["P"] ?? "", // sync_date
                    object["Q"]  ?? "", // sync_by_user
                    object["R"] ?? "", // reject
                    object["S"] ?? ""  // reject_date
                ])
            } catch {
                print("Error inserting records: \(error.localizedDescription)")
            }
        }
        
        manageDistributorReturnRequestProductForDist(database: database)
        
        database.commit()
    } catch {
        print("Error managing distributor return request product: \(error.localizedDescription)")
    }
}

func manageDistributorReturnRequestProductForDist(database:FMDatabase) {
    // delete new data from original table
    let deleteQuery = """
            DELETE FROM bf_ishop_distributor_return_request_product
            WHERE sync_code IN (
                SELECT st.sync_code
                FROM bf_ishop_distributor_return_request_product AS st
                INNER JOIN
                bf_ishop_distributor_return_request_product_copy AS st_copy
                ON st.sync_code = st_copy.sync_code
            );
        """
    
    do {
        try database.executeStatements(deleteQuery)
        
        let insertQuery = """
                INSERT INTO bf_ishop_distributor_return_request_product (
                    distributor_return_request_product_id,
                    distributor_return_request_id,
                    product_sku_id,
                    sticker_details_id,
                    btc_no_out,
                    qr_code_out,
                    quantity,
                    amount,
                    unit,
                    qty_kgl,
                    is_valid,
                    received,
                    received_date,
                    sync_code,
                    sync_flag,
                    sync_date,
                    sync_by_user,
                    reject,
                    rejected_date,
                    rejected_comment,
                    rejected_reason
                )
                SELECT distributor_return_request_product_id,
                       distributor_return_request_id,
                       product_sku_id,
                       sticker_details_id,
                       btc_no_out,
                       qr_code_out,
                       quantity,
                       amount,
                       unit,
                       qty_kgl,
                       is_valid,
                       received,
                       received_date,
                       sync_code,
                       sync_flag,
                       sync_date,
                       sync_by_user,
                       reject,
                       rejected_date,
                       rejected_comment,
                       rejected_reason
                FROM bf_ishop_distributor_return_request_product_copy;
            """
        
        try database.executeStatements(insertQuery)
        
        // delete copy table data
        try database.executeStatements("DELETE FROM \(DBHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_COPY);")
        try database.executeStatements("DELETE FROM \(DBHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT) WHERE reject='1';")
    } catch {
        print("Error managing distributor return request product: \(error.localizedDescription)")
    }
}

func insertDistributorReturnRequestProductNew(ishopDistributorReturnRequestProduct: [[String: Any]],database:FMDatabase) {
    database.executeStatements("DELETE FROM \(DBHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_COPY)")
    database.beginTransaction()
    
    let insertQuery = "INSERT INTO \(DBHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_COPY) " +
    "(\(DBHelper.KEY_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_ID), " +
    "\(DBHelper.KEY_DISTRIBUTOR_RETURN_REQUEST_ID), " +
    "\(DBHelper.KEY_PRODUCT_SKU_ID), " +
    "\(DBHelper.KEY_STICKER_DETAILS_ID), " +
    "\(DBHelper.KEY_BTC_NO_OUT), " +
    "\(DBHelper.KEY_QR_CODE_OUT), " +
    "\(DBHelper.KEY_QUANTITY), " +
    "\(DBHelper.KEY_AMOUNT), " +
    "\(DBHelper.KEY_UNIT), " +
    "\(DBHelper.KEY_QTY_KGL), " +
    "\(DBHelper.KEY_IS_VALID), " +
    "\(DBHelper.KEY_RECEIVED), " +
    "\(DBHelper.KEY_RECEIVED_DATE), " +
    "\(DBHelper.KEY_SYNC_CODE), " +
    "\(DBHelper.KEY_SYNC_FLAG), " +
    "\(DBHelper.KEY_SYNC_DATE), " +
    "\(DBHelper.KEY_SYNC_USER), " +
    "\(DBHelper.KEY_REJECT), " +
    "\(DBHelper.KEY_REJECT_DATE)) " +
    "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)"
    
    for object in ishopDistributorReturnRequestProduct {
        do {
            try database.executeUpdate(insertQuery, values: [
                object["A"] as? String ?? "", // distributor_return_request_product_id
                object["B"] as? String ?? "", // distributor_return_request_id
                object["C"] as? String ?? "", // product_sku_id
                object["D"] as? String ?? "", // sticker_details_id
                object["E"] as? String ?? "", // btc_no_out
                object["F"] as? String ?? "", // qr_code_out
                object["G"] as? String ?? "", // quantity
                object["H"] as? String ?? "", // amount
                object["I"] as? String ?? "", // unit
                object["J"] as? String ?? "", // qty_kgl
                object["M"] as? String ?? "", // is_valid
                object["K"] as? String ?? "", // received
                object["L"] as? String ?? "", // received_date
                object["N"] as? String ?? "", // sync_code
                object["O"] as? String ?? "", // sync_flag
                object["P"] as? String ?? "", // sync_date
                object["Q"] as? String ?? "", // sync_by_user
                object["R"] as? String ?? "", // reject
                object["S"] as? String ?? ""  // reject_date
            ])
        } catch {
            print("Error inserting records: \(error.localizedDescription)")
            //                if let callback = callback {
            //                    callback.onDatabaseError(String(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(error))
            //                }
            //                SynchronizationService.isSuccess = false
            //                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(error) + " In Method InsertDistributorReturnRequestProductNew"
        }
    }
    
    manageDistributorReturnRequestProduct(database: database)
    database.commit()
}

private func manageDistributorReturnRequestProduct(database:FMDatabase) {
    // Delete new data from the original table
    do {
        try database.executeStatements("DELETE FROM bf_ishop_distributor_return_request_product " +
                                       "WHERE sync_code IN (" +
                                       "SELECT st.sync_code " +
                                       "FROM bf_ishop_distributor_return_request_product AS st " +
                                       "INNER JOIN " +
                                       "bf_ishop_distributor_return_request_product_copy AS st_copy " +
                                       "ON st.sync_code = st_copy.sync_code);")
        
        // Insert into the original table from the copy table
        try database.executeStatements("INSERT INTO bf_ishop_distributor_return_request_product " +
                                       "(distributor_return_request_product_id, " +
                                       "distributor_return_request_id, " +
                                       "product_sku_id, " +
                                       "sticker_details_id, " +
                                       "btc_no_out, " +
                                       "qr_code_out, " +
                                       "quantity, " +
                                       "amount, " +
                                       "unit, " +
                                       "qty_kgl, " +
                                       "is_valid, " +
                                       "received, " +
                                       "received_date, " +
                                       "sync_code, " +
                                       "sync_flag, " +
                                       "sync_date, " +
                                       "sync_by_user, " +
                                       "reject, " +
                                       "rejected_date, " +
                                       "rejected_comment, " +
                                       "rejected_reason) " +
                                       "SELECT distributor_return_request_product_id, " +
                                       "distributor_return_request_id, " +
                                       "product_sku_id, " +
                                       "sticker_details_id, " +
                                       "btc_no_out, " +
                                       "qr_code_out, " +
                                       "quantity, " +
                                       "amount, " +
                                       "unit, " +
                                       "qty_kgl, " +
                                       "is_valid, " +
                                       "received, " +
                                       "received_date, " +
                                       "sync_code, " +
                                       "sync_flag, " +
                                       "sync_date, " +
                                       "sync_by_user, " +
                                       "reject, " +
                                       "rejected_date, " +
                                       "rejected_comment, " +
                                       "rejected_reason " +
                                       "FROM bf_ishop_distributor_return_request_product_copy;")
        
        // Delete data from the copy table
        try database.executeStatements("DELETE FROM \(DBHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_COPY);")
    } catch {
        print("Error managing distributor return request product: \(error.localizedDescription)")
    }
}

func insertDistributorDispatchNew(ishopDistributorDispatch: [[String: Any]], fileName: String,database:FMDatabase) {
    let table = DBHelper.OPTIMIZE_MAIN_TABLE ? DBHelper.TABLE_DISTRIBUTOR_DISPATCH_COPY : DBHelper.TABLE_DISTRIBUTOR_DISPATCH
    
    if !DBHelper.OPTIMIZE_MAIN_TABLE || (DBHelper.OPTIMIZE_MAIN_TABLE && fileName.lowercased() == "1.txt") {
        do {
            try database.executeUpdate("DELETE FROM \(table);", values: nil)
            
            database.beginTransaction()
            
            let insertQuery = "INSERT INTO \(table) " +
            "(\(DBHelper.KEY_DISTRIBUTOR_DISPATCH_ID), " +
            "\(DBHelper.KEY_CUSTOMER_FROM_ID), " +
            "\(DBHelper.KEY_CUSTOMER_TO_ID), " +
            "\(DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID), " +
            "\(DBHelper.KEY_IS_NEW_CUSTOMER), " +
            "\(DBHelper.KEY_DISPATCH_DATE), " +
            "\(DBHelper.KEY_customer_to_name), " +
            "\(DBHelper.KEY_customer_to_phone), " +
            "\(DBHelper.KEY_new_customer_type), " +
            "\(DBHelper.KEY_COUNTRY_ID), " +
            "\(DBHelper.KEY_CREATED_BY_USER), " +
            "\(DBHelper.KEY_MODIFIED_BY_USER), " +
            "\(DBHelper.KEY_STATUS), " +
            "\(DBHelper.KEY_CREATE_ON), " +
            "\(DBHelper.KEY_MODIFIED_ON), " +
            "\(DBHelper.KEY_SYNC_CODE), " +
            "\(DBHelper.KEY_SYNC_FLAG), " +
            "\(DBHelper.KEY_SYNC_DATE), " +
            "\(DBHelper.KEY_READ), " +
            "\(DBHelper.KEY_READ_DATE), " +
            "\(DBHelper.KEY_IS_DISPATCH), " +
            "\(DBHelper.KEY_SYNC_USER)) " +
            "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)"
            
            for object in ishopDistributorDispatch {
                do {
                    try database.executeUpdate(insertQuery, values: [
                        object["A"] as? String ?? "", // distributor_dispatch_id
                        object["B"] as? String ?? "", // customer_from_id
                        object["C"] as? String ?? "", // customer_to_id
                        object["F"] as? String ?? "", // customer_type_country_id
                        object["G"] as? String ?? "", // is_new_customer
                        object["I"] as? String ?? "", // dispatch_date
                        object["D"] as? String ?? "", // customer_to_name
                        object["E"] as? String ?? "", // customer_to_phone
                        object["H"] as? String ?? "", // new_customer_type
                        object["L"] as? String ?? "", // country_id
                        object["M"] as? String ?? "", // created_by_user
                        object["N"] as? String ?? "", // modified_by_user
                        object["O"] as? String ?? "", // status
                        object["P"] as? String ?? "", // created_on
                        object["Q"] as? String ?? "", // modified_on
                        object["R"] as? String ?? "", // sync_code
                        object["S"] as? String ?? "", // sync_flag
                        object["T"] as? String ?? "", // sync_date
                        object["J"] as? String ?? "", // isRead
                        object["K"] as? String ?? "", // read_date
                        "1",
                        object["U"] as? String ?? ""  // sync_by_user
                    ])
                } catch {
                    print("Error inserting records: \(error.localizedDescription)")
                }
            }
            
            if DBHelper.OPTIMIZE_MAIN_TABLE {
                manageDistDispatchCopy(database: database)
            }
            
            database.commit()
        } catch {
            print("Error managing distributor dispatch: \(error.localizedDescription)")
        }
    }
}

func insertSalesRepInitiatedProduct(jsonArraySalesRep: [[String: Any]], fileName: String,database:FMDatabase) {
    if fileName == "1.txt" {
        do {
            try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_SALES_REP_INITIATED_PRODUCT);", values: nil)
        } catch {
            print("Error deleting records: \(error.localizedDescription)")
        }
    }
    
    database.beginTransaction()
    
    let sql = "INSERT INTO \(DBHelper.TABLE_SALES_REP_INITIATED_PRODUCT) " +
    "(\(DBHelper.SRIP_ID), " +
    "\(DBHelper.KEY_CUSTOMER_FROM_ID), " +
    "\(DBHelper.KEY_CUSTOMER_TO_ID), " +
    "\(DBHelper.FK_PBG_COUNTRY_ID), " +
    "\(DBHelper.FK_SKU_COUNTRY_ID), " +
    "\(DBHelper.DECQTY), " +
    "\(DBHelper.VARREMARKS), " +
    "\(DBHelper.KEY_DELETED), " +
    "\(DBHelper.KEY_STATUS), " +
    "\(DBHelper.KEY_CREATED_BY_USER), " +
    "\(DBHelper.KEY_MODIFIED_BY_USER), " +
    "\(DBHelper.KEY_CREATE_ON), " +
    "\(DBHelper.KEY_MODIFIED_ON), " +
    "\(DBHelper.KEY_SYNC_CODE), " +
    "\(DBHelper.KEY_SYNC_FLAG), " +
    "\(DBHelper.KEY_SYNC_DATE), " +
    "\(DBHelper.CREATED_BY_NAME), " +
    "\(DBHelper.MODIFIED_BY_NAME), " +
    "\(DBHelper.SCAN_COUNT), " +
    "\(DBHelper.SYNC_BY_USER)) " +
    "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)"
    
    for object in jsonArraySalesRep {
        do {
            try database.executeUpdate(sql, values: [
                object["A"] ?? "",  // srip_id
                object["B"] ?? "",  // customer_from_id
                object["C"] ?? "",  // customer_to_id
                object["D"] ?? "",  // fk_PBG_Country_id
                object["E"] ?? "",  // fk_Sku_Country_id
                object["F"] ?? "",  // decQty
                object["H"] ?? "",  // varRemarks
                object["I"] ?? "",  // deleted
                object["J"] ?? "",  // status
                object["K"] ?? "",  // created_by_user
                object["M"] ?? "",  // modified_by_user
                object["O"] ?? "",  // created_on
                object["P"] ?? "",  // modified_on
                object["Q"] ?? "",  // sync_code
                object["R"] ?? "",  // sync_flag
                object["S"] ?? "",  // sync_date
                object["L"] ?? "",  // created_by_name
                object["N"] ?? "",  // modified_by_name
                object["G"] ?? "",  // scan_count
                object["T"] ?? ""   // sync_by_user
            ])
        } catch {
            print("Error inserting records: \(error.localizedDescription)")
        }
    }
    
    database.commit()
}

func insertRetailerReceivedNew(ishopRetailerReceived: [[String: Any]], fileName: String,database:FMDatabase) {
    if !DBHelper.OPTIMIZE_MAIN_TABLE {
        if fileName == "1.txt" {
            do {
                try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_BF_ISHOP_RETAILER_RECEIVED);", values: nil)
            } catch {
                print("Error deleting records: \(error.localizedDescription)")
            }
        }
        
        database.beginTransaction()
        
        let sql = "INSERT INTO \(DBHelper.TABLE_BF_ISHOP_RETAILER_RECEIVED) " +
        "(\(DBHelper.RETAILER_RECEIVED_ID), " +
        "\(DBHelper.KEY_CUSTOMER_FROM_ID), " +
        "\(DBHelper.KEY_CUSTOMER_TO_ID), " +
        "\(DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID), " +
        "\(DBHelper.KEY_RECEIVED_DATE), " +
        "\(DBHelper.KEY_COUNTRY_ID), " +
        "\(DBHelper.KEY_CREATED_BY_USER), " +
        "\(DBHelper.KEY_MODIFIED_BY_USER), " +
        "\(DBHelper.KEY_STATUS), " +
        "\(DBHelper.KEY_CREATE_ON), " +
        "\(DBHelper.KEY_MODIFIED_ON), " +
        "\(DBHelper.KEY_SYNC_CODE), " +
        "\(DBHelper.KEY_SYNC_FLAG), " +
        "\(DBHelper.KEY_SYNC_DATE), " +
        "\(DBHelper.KEY_isDispatch), " +
        "\(DBHelper.SYNC_BY_USER)) " +
        "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)"
        
        for object in ishopRetailerReceived {
            do {
                try database.executeUpdate(sql, values: [
                    object["A"] ?? "",  // retailer_received_id
                    object["B"] ?? "",  // customer_from_id
                    object["C"] ?? "",  // customer_to_id
                    object["D"] ?? "",  // customer_type_country_id
                    object["E"] ?? "",  // received_date
                    object["F"] ?? "",  // country_id
                    object["G"] ?? "",  // created_by_user
                    object["H"] ?? "",  // modified_by_user
                    object["I"] ?? "",  // status
                    object["J"] ?? "",  // created_on
                    object["K"] ?? "",  // modified_on
                    object["L"] ?? "",  // sync_code
                    object["M"] ?? "",  // sync_flag
                    object["N"] ?? "",  // sync_date
                    "1",  // isDispatch
                    object["O"] ?? ""   // sync_by_user
                ])
            } catch {
                print("Error inserting records: \(error.localizedDescription)")
            }
            print("TABLE_BF_ISHOP_RETAILER_RECEIVED Add SUCCESSFULLY")
        }
        
        database.commit()
    } else {
        
        do{
            try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_BF_ISHOP_RETAILER_RECEIVED_COPY);", values: nil)
            database.beginTransaction()
            
            let sql = "INSERT INTO \(DBHelper.TABLE_BF_ISHOP_RETAILER_RECEIVED_COPY) " +
            "(\(DBHelper.RETAILER_RECEIVED_ID), " +
            "\(DBHelper.KEY_CUSTOMER_FROM_ID), " +
            "\(DBHelper.KEY_CUSTOMER_TO_ID), " +
            "\(DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID), " +
            "\(DBHelper.KEY_RECEIVED_DATE), " +
            "\(DBHelper.KEY_COUNTRY_ID), " +
            "\(DBHelper.KEY_CREATED_BY_USER), " +
            "\(DBHelper.KEY_MODIFIED_BY_USER), " +
            "\(DBHelper.KEY_STATUS), " +
            "\(DBHelper.KEY_CREATE_ON), " +
            "\(DBHelper.KEY_MODIFIED_ON), " +
            "\(DBHelper.KEY_SYNC_CODE), " +
            "\(DBHelper.KEY_SYNC_FLAG), " +
            "\(DBHelper.KEY_SYNC_DATE), " +
            "\(DBHelper.KEY_isDispatch), " +
            "\(DBHelper.SYNC_BY_USER)) " +
            "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)"
            
            for object in ishopRetailerReceived {
                do {
                    try database.executeUpdate(sql, values: [
                        object["A"] ?? "",  // retailer_received_id
                        object["B"] ?? "",  // customer_from_id
                        object["C"] ?? "",  // customer_to_id
                        object["D"] ?? "",  // customer_type_country_id
                        object["E"] ?? "",  // received_date
                        object["F"] ?? "",  // country_id
                        object["G"] ?? "",  // created_by_user
                        object["H"] ?? "",  // modified_by_user
                        object["I"] ?? "",  // status
                        object["J"] ?? "",  // created_on
                        object["K"] ?? "",  // modified_on
                        object["L"] ?? "",  // sync_code
                        object["M"] ?? "",  // sync_flag
                        object["N"] ?? "",  // sync_date
                        "1",  // isDispatch
                        object["O"] ?? ""   // sync_by_user
                    ])
                } catch {
                    print("Error inserting records: \(error.localizedDescription)")
                }
                print("TABLE_BF_ISHOP_RETAILER_RECEIVED Add SUCCESSFULLY")
            }
            
            manageRetailerReceiveCopy(database: database)
            
            database.commit()
        }catch {
            print("Error inserting records: \(error.localizedDescription)")
        }
    }
}

func manageRetailerReceiveCopy(database:FMDatabase) {
    do{
        try database.executeUpdate("DELETE FROM bf_ishop_retailer_received " +
                                   "WHERE sync_code IN ( " +
                                   "SELECT st.sync_code " +
                                   "FROM bf_ishop_retailer_received AS st " +
                                   "INNER JOIN bf_ishop_retailer_received_copy AS st_copy ON st.sync_code = st_copy.sync_code );", values: nil)
        
        let insertQuery = "INSERT INTO bf_ishop_retailer_received " +
        "(retailer_received_id, " +
        "customer_from_id, " +
        "customer_to_id, " +
        "customer_type_country_id, " +
        "received_date, " +
        "country_id, " +
        "created_by_user, " +
        "modified_by_user, " +
        "status, " +
        "created_on, " +
        "modified_on, " +
        "sync_code, " +
        "sync_flag, " +
        "sync_date, " +
        "isDispatch, " +
        "sync_by_user) " +
        "SELECT retailer_received_id, " +
        "customer_from_id, " +
        "customer_to_id, " +
        "customer_type_country_id, " +
        "received_date, " +
        "country_id, " +
        "created_by_user, " +
        "modified_by_user, " +
        "status, " +
        "created_on, " +
        "modified_on, " +
        "sync_code, " +
        "sync_flag, " +
        "sync_date, " +
        "isDispatch, " +
        "sync_by_user " +
        "FROM bf_ishop_retailer_received_copy;"
        
        try database.executeUpdate(insertQuery, values: nil)
        
        // Delete copy table data
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_BF_ISHOP_RETAILER_RECEIVED_COPY);", values: nil)
        
    } catch {
        print("Error managing distributor dispatch copy: \(error.localizedDescription)")
    }
}

func insertPoliticalDetailsEmp(arrayPoliticalDetailsEmp: [[String: Any]], fileName: String,database:FMDatabase) {
    if fileName == "1.txt" {
        do {
            try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_POLITICAL_DETAILS_EMP);", values: nil)
        } catch {
            print("Error deleting records: \(error.localizedDescription)")
        }
    }
    
    database.beginTransaction()
    
    let sql = "INSERT INTO \(DBHelper.TABLE_POLITICAL_DETAILS_EMP) " +
    "(\(DBHelper.KEY_POLITICAL_GEO_ID), " +
    "\(DBHelper.KEY_GEO_LEVEL_ID), " +
    "\(DBHelper.KEY_PARENT_GEO_ID), " +
    "\(DBHelper.KEY_POLITICAL_GEOGRAPHY_CODE), " +
    "\(DBHelper.KEY_POLITICAL_GEOGRAPHY_NAME), " +
    "\(DBHelper.KEY_COUNTRY_ID)) " +
    "VALUES (?, ?, ?, ?, ?, ?)"
    
    for object in arrayPoliticalDetailsEmp {
        do {
            try database.executeUpdate(sql, values: [
                object["A"],  // political_geo_id
                object["B"],  // geo_level_id
                object["C"],  // parent_geo_id
                object["D"],  // political_geography_code
                object["E"],  // political_geography_name
                object["F"]   // country_id
            ])
        } catch {
            print("Error inserting records: \(error.localizedDescription)")
        }
    }
    
    database.commit()
}

func insertPoliticalDetailsEmp(arrayPoliticalDetailsEmp: [[String: String]], fileName: String,database:FMDatabase) {
    if fileName == "1.txt" {
        do {
            try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_POLITICAL_DETAILS_EMP);", values: nil)
        } catch {
            print("Error deleting records: \(error.localizedDescription)")
        }
    }
    
    database.beginTransaction()
    
    let sql = "INSERT INTO \(DBHelper.TABLE_POLITICAL_DETAILS_EMP) " +
    "(\(DBHelper.KEY_POLITICAL_GEO_ID), " +
    "\(DBHelper.KEY_GEO_LEVEL_ID), " +
    "\(DBHelper.KEY_PARENT_GEO_ID), " +
    "\(DBHelper.KEY_POLITICAL_GEOGRAPHY_CODE), " +
    "\(DBHelper.KEY_POLITICAL_GEOGRAPHY_NAME), " +
    "\(DBHelper.KEY_COUNTRY_ID)) " +
    "VALUES (?, ?, ?, ?, ?, ?)"
    
    for object in arrayPoliticalDetailsEmp {
        do {
            try database.executeUpdate(sql, values: [
                object["A"],  // political_geo_id
                object["B"],  // geo_level_id
                object["C"],  // parent_geo_id
                object["D"],  // political_geography_code
                object["E"],  // political_geography_name
                object["F"]   // country_id
            ])
        } catch {
            print("Error inserting records: \(error.localizedDescription)")
        }
    }
    
    database.commit()
}

func insertPoliticalDetails(arrayPoliticalDetails: [[String: Any]], fileName: String,database:FMDatabase) {
    if fileName == "1.txt" {
        do {
            try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_POLITICAL_DETAILS);", values: nil)
        } catch {
            print("Error deleting records: \(error.localizedDescription)")
        }
    }
    
    database.beginTransaction()
    
    let sql = "INSERT INTO \(DBHelper.TABLE_POLITICAL_DETAILS) " +
    "(\(DBHelper.KEY_POLITICAL_GEO_ID), " +
    "\(DBHelper.KEY_GEO_LEVEL_ID), " +
    "\(DBHelper.KEY_PARENT_GEO_ID), " +
    "\(DBHelper.KEY_POLITICAL_GEOGRAPHY_CODE), " +
    "\(DBHelper.KEY_POLITICAL_GEOGRAPHY_NAME), " +
    "\(DBHelper.KEY_COUNTRY_ID)) " +
    "VALUES (?, ?, ?, ?, ?, ?)"
    
    for object in arrayPoliticalDetails {
        do {
            try database.executeUpdate(sql, values: [
                object["A"] ?? "",  // political_geo_id
                object["B"] ?? "",  // geo_level_id
                object["C"] ?? "",  // parent_geo_id
                object["D"] ?? "",  // political_geography_code
                object["E"] ?? "",  // political_geography_name
                object["F"] ?? ""   // country_id
            ])
        } catch {
            print("Error inserting records: \(error.localizedDescription)")
        }
    }
    
    database.commit()
}

func manageDistDispatchCopy(database:FMDatabase) {
    // Delete new data from the original table
    do {
        try database.executeUpdate("DELETE FROM bf_ishop_distributor_dispatch " +
                                   "WHERE sync_code IN ( " +
                                   "    SELECT st.sync_code " +
                                   "    FROM bf_ishop_distributor_dispatch AS st " +
                                   "         INNER JOIN " +
                                   "         bf_ishop_distributor_dispatch_copy AS st_copy ON st.sync_code = st_copy.sync_code " +
                                   ");", values: nil)
        
        // Insert into the original table from the copy table
        try database.executeUpdate("INSERT INTO bf_ishop_distributor_dispatch " +
                                   "(distributor_dispatch_id, " +
                                   "customer_from_id, " +
                                   "customer_to_id, " +
                                   "customer_type_country_id, " +
                                   "is_new_customer, " +
                                   "dispatch_date, " +
                                   "customer_to_name, " +
                                   "customer_to_phone, " +
                                   "new_customer_type, " +
                                   "country_id, " +
                                   "created_by_user, " +
                                   "modified_by_user, " +
                                   "status, " +
                                   "created_on, " +
                                   "modified_on, " +
                                   "sync_code, " +
                                   "sync_flag, " +
                                   "sync_date, " +
                                   "isRead, " +
                                   "read_date, " +
                                   "isDispatch, " +
                                   "sync_by_user) " +
                                   "SELECT " +
                                   "distributor_dispatch_id, " +
                                   "customer_from_id, " +
                                   "customer_to_id, " +
                                   "customer_type_country_id, " +
                                   "is_new_customer, " +
                                   "dispatch_date, " +
                                   "customer_to_name, " +
                                   "customer_to_phone, " +
                                   "new_customer_type, " +
                                   "country_id, " +
                                   "created_by_user, " +
                                   "modified_by_user, " +
                                   "status, " +
                                   "created_on, " +
                                   "modified_on, " +
                                   "sync_code, " +
                                   "sync_flag, " +
                                   "sync_date, " +
                                   "isRead, " +
                                   "read_date, " +
                                   "isDispatch, " +
                                   "sync_by_user " +
                                   "FROM bf_ishop_distributor_dispatch_copy;", values: nil)
        
        // Delete data from the copy table
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_DISTRIBUTOR_DISPATCH_COPY);", values: nil)
    } catch {
        print("Error managing distributor dispatch copy: \(error.localizedDescription)")
    }
}

func insertExtraStickerDetail(arrayCfaDispatchProduct: [[String: Any]],database:FMDatabase) {
    do {
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_EXTRA_STICKER_COPY);", values: nil)
    } catch {
        print("Error deleting records: \(error.localizedDescription)")
    }
    
    database.beginTransaction()
    
    let sql = "INSERT INTO \(DBHelper.TABLE_EXTRA_STICKER_COPY) " +
    "(\(DBHelper.EXTRA_STICKER_DETAIL_ID), " +
    "\(DBHelper.EXTRA_STICKER_ID), " +
    "\(DBHelper.BASE_BTC_NO_OUT), " +
    "\(DBHelper.BASE_QR_CODE_OUT), " +
    "\(DBHelper.BTC_NO_OUT), " +
    "\(DBHelper.QR_CODE_OUT), " +
    "\(DBHelper.STICKER_DETAIL_ID), " +
    "\(DBHelper.MAPPED_ON), " +
    "\(DBHelper.CREATE_BY_USER), " +
    "\(DBHelper.CREATE_ON), " +
    "\(DBHelper.SYNC_CODE), " +
    "\(DBHelper.SYNC_FLAG), " +
    "\(DBHelper.SYNC_DATE), " +
    "\(DBHelper.SYNC_BY_USER), " +
    "\(DBHelper.BASE_BTC_NO_IN), " +
    "\(DBHelper.BASE_QR_CODE_IN), " +
    "\(DBHelper.KEY_BTC_NO_IN), " +
    "\(DBHelper.QR_CODE_IN), " +
    "\(DBHelper.KEY_ANDROID_SYNC)) " +
    "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)"
    
    for object in arrayCfaDispatchProduct {
        do {
            try database.executeUpdate(sql, values: [
                object["A"] ?? "",  // extra_sticker_detail_id
                object["B"] ?? "",  // extra_sticker_id
                object["C"] ?? "",  // base_btc_no_out
                object["D"] ?? "",  // base_qr_code_out
                object["E"] ?? "",  // btc_no_out
                object["F"] ?? "",  // qr_code_out
                object["G"] ?? "",  // sticker_details_id
                object["H"] ?? "",  // mapped_on
                object["I"] ?? "",  // created_by_user
                object["J"] ?? "",  // created_on
                object["K"] ?? "",  // sync_code
                object["L"] ?? "",  // sync_flag
                object["M"] ?? "",  // sync_date
                object["N"] ?? "",  // sync_by_user
                object["P"] ?? "",  // base_btc_no_in
                object["Q"] ?? "",  // base_qr_code_in
                object["R"] ?? "",  // btc_no_in
                object["S"] ?? "",  // qr_code_in
                object["O"] ?? ""   // android_sync
            ])
        } catch {
            print("Error inserting records: \(error.localizedDescription)")
        }
    }
    
    manageExtraStickerDetailTable(database: database)
    database.commit()
    //        database.endTransaction()
}

func manageExtraStickerDetailTable(database:FMDatabase) {
    // Delete new data from the original table
    do {
        try database.executeUpdate("DELETE FROM extra_sticker_detail " +
                                   "WHERE sync_code IN (" +
                                   "    SELECT st.sync_code " +
                                   "    FROM extra_sticker_detail AS st " +
                                   "    INNER JOIN " +
                                   "    extra_sticker_detail_copy AS st_copy ON st.sync_code = st_copy.sync_code" +
                                   ");", values: nil)
    } catch {
        print("Error deleting records: \(error.localizedDescription)")
    }
    
    // Delete records with android_sync='D' from the copy table
    do {
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_EXTRA_STICKER_COPY) WHERE android_sync='D';", values: nil)
    } catch {
        print("Error deleting records: \(error.localizedDescription)")
    }
    
    // Insert data from the copy table to the original table
    let insertSQL = "INSERT INTO extra_sticker_detail (" +
    "extra_sticker_detail_id, " +
    "extra_sticker_id, " +
    "base_btc_no_out, " +
    "base_qr_code_out, " +
    "btc_no_out, " +
    "qr_code_out, " +
    "sticker_details_id, " +
    "mapped_on, " +
    "created_by_user, " +
    "created_on, " +
    "sync_code, " +
    "sync_flag, " +
    "sync_date, " +
    "sync_by_user, " +
    "base_btc_no_in, " +
    "base_qr_code_in, " +
    "btc_no_in, " +
    "qr_code_in, " +
    "android_sync) " +
    "SELECT " +
    "extra_sticker_detail_id, " +
    "extra_sticker_id, " +
    "base_btc_no_out, " +
    "base_qr_code_out, " +
    "btc_no_out, " +
    "qr_code_out, " +
    "sticker_details_id, " +
    "mapped_on, " +
    "created_by_user, " +
    "created_on, " +
    "sync_code, " +
    "sync_flag, " +
    "sync_date, " +
    "sync_by_user, " +
    "base_btc_no_in, " +
    "base_qr_code_in, " +
    "btc_no_in, " +
    "qr_code_in, " +
    "android_sync " +
    "FROM extra_sticker_detail_copy;"
    
    do {
        try database.executeUpdate(insertSQL, values: nil)
    } catch {
        print("Error inserting records: \(error.localizedDescription)")
    }
    
    // Delete copy table data
    do {
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_EXTRA_STICKER_COPY);", values: nil)
    } catch {
        print("Error deleting records: \(error.localizedDescription)")
    }
}

func insertRetailerReturnNew(ishopRetailerReturn: [[String: Any]], fileName: String,database:FMDatabase) {
    let retailerReturnTable = DBHelper.OPTIMIZE_MAIN_TABLE ? DBHelper.TABLE_RETAILER_RETURN_COPY : DBHelper.TABLE_RETAILER_RETURN
    
    do {
        if fileName == "1.txt" {
            try database.executeUpdate("DELETE FROM \(retailerReturnTable);", values: nil)
        }
        
        database.beginTransaction()
        
        let sql = "INSERT INTO \(retailerReturnTable) " +
        "(\(DBHelper.KEY_RETAILER_RETURN_ID), " +
        "\(DBHelper.KEY_CUSTOMER_FROM_ID), " +
        "\(DBHelper.KEY_CUSTOMER_TO_ID), " +
        "\(DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID), " +
        "\(DBHelper.KEY_IS_NEW_CUSTOMER), " +
        "\(DBHelper.KEY_RETURN_DATE), " +
        "\(DBHelper.KEY_COUNTRY_ID), " +
        "\(DBHelper.KEY_CREATED_BY_USER), " +
        "\(DBHelper.KEY_MODIFIED_BY_USER), " +
        "\(DBHelper.KEY_STATUS), " +
        "\(DBHelper.KEY_CREATE_ON), " +
        "\(DBHelper.KEY_MODIFIED_ON), " +
        "\(DBHelper.KEY_SYNC_CODE), " +
        "\(DBHelper.KEY_SYNC_FLAG), " +
        "\(DBHelper.KEY_SYNC_DATE), " +
        "\(DBHelper.KEY_SYNC_USER)) " +
        "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)"
        
        for retailerReturn in ishopRetailerReturn {
            do {
                try database.executeUpdate(sql, values: [
                    retailerReturn["A"] as! String,
                    retailerReturn["B"] as! String,
                    retailerReturn["C"] as! String,
                    retailerReturn["D"] as! String,
                    retailerReturn["E"] as! String,
                    retailerReturn["F"] as! String,
                    retailerReturn["G"] as! String,
                    retailerReturn["H"] as! String,
                    retailerReturn["I"] as! String,
                    retailerReturn["J"] as! String,
                    retailerReturn["K"] as! String,
                    retailerReturn["L"] as! String,
                    retailerReturn["M"] as! String,
                    retailerReturn["N"] as! String,
                    retailerReturn["O"] as! String,
                    retailerReturn["P"] as! String
                ])
            } catch {
                print("Error executing statement: \(error.localizedDescription)")
            }
        }
        
        if DBHelper.OPTIMIZE_MAIN_TABLE {
            manageRetailerReturnCopy(database: database)
        }
        
        database.commit()
    } catch {
        print("Error in insertRetailerReturnNew: \(error.localizedDescription)")
    }
}

func manageRetailerReturnCopy(database:FMDatabase) {
    do {
        try database.executeUpdate("DELETE FROM bf_ishop_retailer_return " +
                                   "WHERE sync_code IN " +
                                   "(SELECT st.sync_code FROM bf_ishop_retailer_return AS st " +
                                   "INNER JOIN bf_ishop_retailer_return_copy AS st_copy " +
                                   "ON st.sync_code = st_copy.sync_code);", withArgumentsIn: [])
        
        let insertSQL = "INSERT INTO bf_ishop_retailer_return " +
        "(retailer_return_id, customer_from_id, customer_to_id, " +
        "customer_type_country_id, is_new_customer, return_date, " +
        "country_id, created_by_user, modified_by_user, status, " +
        "created_on, modified_on, sync_code, sync_flag, sync_date, sync_by_user) " +
        "SELECT retailer_return_id, customer_from_id, customer_to_id, " +
        "customer_type_country_id, is_new_customer, return_date, " +
        "country_id, created_by_user, modified_by_user, status, " +
        "created_on, modified_on, sync_code, sync_flag, sync_date, sync_by_user " +
        "FROM bf_ishop_retailer_return_copy;"
        
        try database.executeUpdate(insertSQL, values: nil)
        
        try database.executeUpdate("DELETE FROM " + DBHelper.TABLE_RETAILER_RETURN_COPY + ";", values: nil)
    } catch {
        print("Error in manageRetailerReturnCopy: \(error.localizedDescription)")
    }
}

func insertRetailerReturnProductNew(ishopRetailerReturnProduct: [[String: Any]], fileName: String,database:FMDatabase) {
    let retailerReturnProductTable = DBHelper.OPTIMIZE_MAIN_TABLE ?
    DBHelper.TABLE_RETAILER_RETURN_PRODUCT_COPY :
    DBHelper.TABLE_RETAILER_RETURN_PRODUCT
    
    do {
        if fileName == "1.txt" {
            try database.executeUpdate("DELETE FROM \(retailerReturnProductTable);", values: nil)
        }
        
        database.beginTransaction()
        
        let sql = "INSERT INTO \(retailerReturnProductTable) " +
        "(\(DBHelper.KEY_RETAILER_RETURN_PRODUCT_ID), " +
        "\(DBHelper.KEY_RETAILER_RETURN_ID), " +
        "\(DBHelper.KEY_PRODUCT_SKU_ID), " +
        "\(DBHelper.KEY_STICKER_DETAILS_ID), " +
        "\(DBHelper.KEY_BTC_NO_OUT), " +
        "\(DBHelper.KEY_QR_CODE_OUT), " +
        "\(DBHelper.KEY_QUANTITY), " +
        "\(DBHelper.KEY_AMOUNT), " +
        "\(DBHelper.KEY_UNIT), " +
        "\(DBHelper.KEY_QTY_KGL), " +
        "\(DBHelper.KEY_IS_VALID), " +
        "\(DBHelper.KEY_SYNC_CODE), " +
        "\(DBHelper.KEY_SYNC_FLAG), " +
        "\(DBHelper.KEY_SYNC_DATE), " +
        "\(DBHelper.KEY_SYNC_USER)) " +
        "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)"
        
        for retailerReturnProduct in ishopRetailerReturnProduct {
            do {
                try database.executeUpdate(sql, values: [
                    retailerReturnProduct["A"] as! String,
                    retailerReturnProduct["B"] as! String,
                    retailerReturnProduct["C"] as! String,
                    retailerReturnProduct["D"] as! String,
                    retailerReturnProduct["E"] as! String,
                    retailerReturnProduct["F"] as! String,
                    retailerReturnProduct["G"] as! String,
                    retailerReturnProduct["H"] as! String,
                    retailerReturnProduct["I"] as! String,
                    retailerReturnProduct["J"] as! String,
                    retailerReturnProduct["K"] as! String,
                    retailerReturnProduct["L"] as! String,
                    retailerReturnProduct["M"] as! String,
                    retailerReturnProduct["N"] as! String,
                    retailerReturnProduct["O"] as! String
                ])
            } catch {
                print("Error executing statement: \(error.localizedDescription)")
            }
        }
        
        manageRetailerReturnProduct(database: database)
        database.commit()
    } catch {
        print("Error in insertRetailerReturnProductNew: \(error.localizedDescription)")
    }
}

func manageRetailerReturnProduct(database:FMDatabase) {
    let retailerReturnProductTable = DBHelper.OPTIMIZE_MAIN_TABLE ?
    DBHelper.TABLE_RETAILER_RETURN_PRODUCT_COPY :
    DBHelper.TABLE_RETAILER_RETURN_PRODUCT
    
    // Delete new data from the original table
    do {
        try database.executeUpdate("DELETE FROM \(retailerReturnProductTable) " +
                                   "WHERE sync_code IN ( " +
                                   "SELECT st.sync_code " +
                                   "FROM \(DBHelper.TABLE_RETAILER_RETURN_PRODUCT) AS st " +
                                   "INNER JOIN \(DBHelper.TABLE_RETAILER_RETURN_PRODUCT_COPY) AS st_copy " +
                                   "ON st.sync_code = st_copy.sync_code );", values: nil)
        
        // Insert data into the original table from the copy table
        try database.executeUpdate("INSERT INTO \(DBHelper.TABLE_RETAILER_RETURN_PRODUCT) " +
                                   "(\(DBHelper.KEY_RETAILER_RETURN_PRODUCT_ID), " +
                                   "\(DBHelper.KEY_RETAILER_RETURN_ID), " +
                                   "\(DBHelper.KEY_PRODUCT_SKU_ID), " +
                                   "\(DBHelper.KEY_STICKER_DETAILS_ID), " +
                                   "\(DBHelper.KEY_BTC_NO_OUT), " +
                                   "\(DBHelper.KEY_QR_CODE_OUT), " +
                                   "\(DBHelper.KEY_QUANTITY), " +
                                   "\(DBHelper.KEY_AMOUNT), " +
                                   "\(DBHelper.KEY_UNIT), " +
                                   "\(DBHelper.KEY_QTY_KGL), " +
                                   "\(DBHelper.KEY_IS_VALID), " +
                                   "\(DBHelper.KEY_SYNC_CODE), " +
                                   "\(DBHelper.KEY_SYNC_FLAG), " +
                                   "\(DBHelper.KEY_SYNC_DATE), " +
                                   "\(DBHelper.KEY_SYNC_USER)) " +
                                   "SELECT " +
                                   "\(DBHelper.KEY_RETAILER_RETURN_PRODUCT_ID), " +
                                   "\(DBHelper.KEY_RETAILER_RETURN_ID), " +
                                   "\(DBHelper.KEY_PRODUCT_SKU_ID), " +
                                   "\(DBHelper.KEY_STICKER_DETAILS_ID), " +
                                   "\(DBHelper.KEY_BTC_NO_OUT), " +
                                   "\(DBHelper.KEY_QR_CODE_OUT), " +
                                   "\(DBHelper.KEY_QUANTITY), " +
                                   "\(DBHelper.KEY_AMOUNT), " +
                                   "\(DBHelper.KEY_UNIT), " +
                                   "\(DBHelper.KEY_QTY_KGL), " +
                                   "\(DBHelper.KEY_IS_VALID), " +
                                   "\(DBHelper.KEY_SYNC_CODE), " +
                                   "\(DBHelper.KEY_SYNC_FLAG), " +
                                   "\(DBHelper.KEY_SYNC_DATE), " +
                                   "\(DBHelper.KEY_SYNC_USER) " +
                                   "FROM \(DBHelper.TABLE_RETAILER_RETURN_PRODUCT_COPY);", values: nil)
        
        // Delete data from the copy table
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_RETAILER_RETURN_PRODUCT_COPY);", values: nil)
    } catch {
        print("Error in manageRetailerReturnProduct: \(error.localizedDescription)")
    }
}

func insertSalesReturnCurrentLimit(arrayCurrentLimit: [[String: Any]],database:FMDatabase) {
    do {
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_SALES_INITIATED_PRODUCT_CURRENT_LIMIT);", values: nil)
        
        database.beginTransaction()
        
        let sql = "INSERT INTO \(DBHelper.TABLE_SALES_INITIATED_PRODUCT_CURRENT_LIMIT) " +
        "(\(DBHelper.CUSTOMER_ID), \(DBHelper.KEY_PRODUCT_SKU_COUNTRY_ID), \(DBHelper.KEY_CURRENT_LIMIT)) " +
        "VALUES (?, ?, ?);"
        
        for currentLimit in arrayCurrentLimit {
            do {
                try database.executeUpdate(sql, values: [
                    currentLimit["A"] as! String, // customer_id
                    currentLimit["B"] as! String, // product_sku_id
                    currentLimit["C"] as! String  // current_limit
                ])
            } catch {
                print("Error executing statement: \(error.localizedDescription)")
            }
        }
        
        database.commit()
    } catch {
        print("Error in insertSalesReturnCurrentLimit: \(error.localizedDescription)")
    }
}

func insertPalletDetails(arrayPalletDetails: [[String: Any]], loginId: String, customerLevel: String, roleCode: String,database:FMDatabase) {
    do {
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_ISHOP_PALLET_DETAILS_COPY);", values: nil)
        
        database.beginTransaction()
        
        let sql = "INSERT INTO \(DBHelper.TABLE_ISHOP_PALLET_DETAILS_COPY) " +
        "(\(DBHelper.KEY_PALLET_DETAIL_ID), " +
        "\(DBHelper.KEY_STICKER_ID), " +
        "\(DBHelper.KEY_PALLET_SERIAL_NO), " +
        "\(DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID), " +
        "\(DBHelper.KEY_CUSTOMER_ID), " +
        "\(DBHelper.KEY_IS_PARTIAL_DISPATCH), " +
        "\(DBHelper.KEY_PARTIAL_DISPATCH_CUSTOMER_ID), " +
        "\(DBHelper.KEY_PARTIAL_DISPATCH_DATE), " +
        "\(DBHelper.KEY_CREATED_BY_USER), " +
        "\(DBHelper.KEY_CREATED_ON), " +
        "\(DBHelper.KEY_SYNC_CODE), " +
        "\(DBHelper.KEY_SYNC_FLAG), " +
        "\(DBHelper.KEY_SYNC_DATE), " +
        "\(DBHelper.KEY_SYNC_BY_USER), " +
        "\(DBHelper.KEY_ANDROID_SYNC), " +
        "\(DBHelper.KEY_DELETED), " +
        "\(DBHelper.KEY_IS_PALLET_SCAN)) " +
        "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?);"
        
        for palletDetail in arrayPalletDetails {
            do {
                _ = 1
                try database.executeUpdate(sql, values: [
                    palletDetail["A"] as! String, // pallet_details_id
                    palletDetail["B"] as! String, // sticker_id
                    palletDetail["C"] as! String, // pallet_serial_no
                    palletDetail["D"] as! String, // customer_type_country_id
                    palletDetail["E"] as! String, // customer_id
                    palletDetail["F"] as! String, // is_partial_dispatch
                    palletDetail["G"] as! String, // partial_dispatch_customer_id
                    palletDetail["H"] as! String, // partial_dispatch_date
                    palletDetail["I"] as! String, // created_by_user
                    palletDetail["J"] as! String, // created_on
                    palletDetail["K"] as! String, // sync_code
                    palletDetail["L"] as! String, // sync_flag
                    palletDetail["M"] as! String, // sync_date
                    palletDetail["N"] as! String, // sync_by_user
                    palletDetail["O"] as! String, // android_sync
                    palletDetail["P"] as! String, // deleted
                    palletDetail["Q"] as! String  // is_pallet_scan
                ])
            } catch {
                print("Error executing statement: \(error.localizedDescription)")
            }
        }
        
        do {
            try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_ISHOP_PALLET_DETAILS) " +
                                       "WHERE pallet_details_id IN " +
                                       "(SELECT st.pallet_details_id " +
                                       "FROM \(DBHelper.TABLE_ISHOP_PALLET_DETAILS) AS st " +
                                       "INNER JOIN \(DBHelper.TABLE_ISHOP_PALLET_DETAILS_COPY) AS st_copy " +
                                       "ON st.pallet_details_id = st_copy.pallet_details_id);", values: nil)
            
            if customerLevel.uppercased() == "L3" && roleCode.uppercased() != "FO" {
                let deleteSql = "DELETE FROM \(DBHelper.TABLE_ISHOP_PALLET_DETAILS_COPY) WHERE customer_id <> '\(loginId)'"
                print("TAG_PALLET_DELETE: SQL DELETE::: \(deleteSql)")
                try database.executeUpdate(deleteSql, values: nil)
            }
            
            try database.executeUpdate("INSERT INTO \(DBHelper.TABLE_ISHOP_PALLET_DETAILS) " +
                                       "(pallet_details_id,sticker_id,pallet_serial_no,customer_type_country_id,customer_id,deleted,is_partial_dispatch,partial_dispatch_customer_id,partial_dispatch_date,created_by_user,created_on,sync_code,sync_flag,sync_date,sync_by_user,android_sync,is_pallet_scan) " +
                                       "SELECT pallet_details_id,sticker_id,pallet_serial_no,customer_type_country_id,customer_id,deleted,is_partial_dispatch,partial_dispatch_customer_id,partial_dispatch_date,created_by_user,created_on,sync_code,sync_flag,sync_date,sync_by_user,android_sync,is_pallet_scan " +
                                       "FROM \(DBHelper.TABLE_ISHOP_PALLET_DETAILS_COPY);", values: nil)
            
            try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_ISHOP_PALLET_DETAILS_COPY);", values: nil)
            
            database.commit()
        } catch {
            print("Error in insertPalletDetails: \(error.localizedDescription)")
        }
    } catch {
        print("Error in insertPalletDetails: \(error.localizedDescription)")
    }
}

func insertPalletExtraStickerDetail(arrayCfaDispatchProduct: [[String: Any]],database:FMDatabase) {
    do {
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_EXTRA_PALLET_STICKER_DETAIL_COPY);", values: nil)
        
        database.beginTransaction()
        
        let sql = "INSERT INTO \(DBHelper.TABLE_EXTRA_PALLET_STICKER_DETAIL_COPY) " +
        "(\(DBHelper.EXTRA_PALLET_STICKER_DETAIL_ID), " +
        "\(DBHelper.EXTRA_STICKER_ID), " +
        "\(DBHelper.BASE_PALLET_SERIAL_NO), " +
        "\(DBHelper.BASE_PALLET_QR_CODE), " +
        "\(DBHelper.PALLET_SERIAL_NO), " +
        "\(DBHelper.PALLET_QR_CODE), " +
        "\(DBHelper.KEY_PALLET_DETAIL_ID), " +
        "\(DBHelper.KEY_CREATED_BY_USER), " +
        "\(DBHelper.CREATE_ON), " +
        "\(DBHelper.SYNC_CODE), " +
        "\(DBHelper.SYNC_FLAG), " +
        "\(DBHelper.KEY_SYNC_DATE), " +
        "\(DBHelper.SYNC_BY_USER), " +
        "\(DBHelper.KEY_MODIFIED_BY_USER), " +
        "\(DBHelper.KEY_MODIFIED_ON), " +
        "\(DBHelper.KEY_ANDROID_SYNC)) " +
        "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?);"
        
        do {
            for cfaDispatchProduct in arrayCfaDispatchProduct {
                var j = 1
                try database.executeUpdate(sql, values: [
                    cfaDispatchProduct["A"] as! String, // extra_pallet_sticker_detail_id
                    cfaDispatchProduct["B"] as! String, // extra_sticker_id
                    cfaDispatchProduct["C"] as! String, // base_pallet_serial_no
                    cfaDispatchProduct["D"] as! String, // base_pallet_qr_code
                    cfaDispatchProduct["E"] as! String, // pallet_serial_no
                    cfaDispatchProduct["F"] as! String, // pallet_qr_code
                    cfaDispatchProduct["G"] as! String, // pallet_details_id
                    cfaDispatchProduct["H"] as! String, // created_by_user
                    cfaDispatchProduct["I"] as! String, // created_on
                    cfaDispatchProduct["J"] as! String, // sync_code
                    cfaDispatchProduct["K"] as! String, // sync_flag
                    cfaDispatchProduct["L"] as! String, // sync_date
                    cfaDispatchProduct["M"] as! String, // sync_by_user
                    cfaDispatchProduct["N"] as! String, // modified_by_user
                    cfaDispatchProduct["O"] as! String, // modified_on
                    cfaDispatchProduct["P"] as! String  // android_sync
                ])
            }
        } catch {
            print("Error executing statement: \(error.localizedDescription)")
            //                if let callback = callback {
            //                    callback.onDatabaseError(String(describing: SyncErrorCode.ERROR_108), AppUtil.getStackTrace(error))
            //                }
            //                SynchronizationService.isSuccess = false
            //                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(error) + " In Method InsertPalletExtraStickerDetail"
        }
        
        managePalletExtraStickerDetailTable(database: database)
        database.commit()
    } catch {
        print("Error in insertPalletExtraStickerDetail: \(error.localizedDescription)")
        //            if let callback = callback {
        //                callback.onDatabaseError(String(describing: SyncErrorCode.ERROR_108), AppUtil.getStackTrace(error))
        //            }
        //            SynchronizationService.isSuccess = false
        //            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(error) + " In Method InsertPalletExtraStickerDetail"
    }
    //        finally {
    //            database.endTransaction()
    //        }
}

func managePalletExtraStickerDetailTable(database:FMDatabase) {
    do {
        // Delete new data from the original table
        try database.executeUpdate("DELETE FROM bf_ishop_extra_pallet_sticker_details " +
                                   "WHERE sync_code IN (" +
                                   "SELECT st.sync_code " +
                                   "FROM bf_ishop_extra_pallet_sticker_details AS st " +
                                   "INNER JOIN bf_ishop_extra_pallet_sticker_details_copy AS st_copy ON st.sync_code = st_copy.sync_code);",
                                   values: nil)
        
        // Delete records with android_sync='D' from the copy table
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_EXTRA_PALLET_STICKER_DETAIL_COPY) WHERE android_sync='D';",
                                   values: nil)
        
        // Insert into the original table from the copy table
        try database.executeUpdate("INSERT INTO bf_ishop_extra_pallet_sticker_details " +
                                   "(extra_pallet_sticker_detail_id, extra_sticker_id, base_pallet_serial_no, " +
                                   "base_pallet_qr_code, pallet_serial_no, pallet_qr_code, pallet_details_id, " +
                                   "created_by_user, created_on, sync_code, sync_flag, sync_date, sync_by_user, " +
                                   "modified_by_user, modified_on, android_sync) " +
                                   "SELECT extra_pallet_sticker_detail_id, extra_sticker_id, base_pallet_serial_no, " +
                                   "base_pallet_qr_code, pallet_serial_no, pallet_qr_code, pallet_details_id, " +
                                   "created_by_user, created_on, sync_code, sync_flag, sync_date, sync_by_user, " +
                                   "modified_by_user, modified_on, android_sync " +
                                   "FROM \(DBHelper.TABLE_EXTRA_PALLET_STICKER_DETAIL_COPY);",
                                   values: nil)
        
        // Delete copy table data
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_EXTRA_PALLET_STICKER_DETAIL_COPY);", values: nil)
    } catch {
        print("Error in managePalletExtraStickerDetailTable: \(error.localizedDescription)")
        //            if let callback = callback {
        //                callback.onDatabaseError(String(describing: SyncErrorCode.ERROR_108), AppUtil.getStackTrace(error))
        //            }
        //            SynchronizationService.isSuccess = false
        //            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(error) + " In Method managePalletExtraStickerDetailTable"
    }
}

func insertScmData(jsonScmData: [[String: Any]],database:FMDatabase) -> Bool {
    do {
        database.beginTransaction()
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_DISPATCH_WAREHOUSE_COPY);", values: nil)
        
        let sql = "INSERT INTO \(DBHelper.TABLE_DISPATCH_WAREHOUSE_COPY) " +
        "(\(DBHelper.SCM_CPM_ID), \(DBHelper.DO_STO_NO), \(DBHelper.FROM_USER_ID), \(DBHelper.TO_USER_ID), " +
        "\(DBHelper.TRUCK_NO), \(DBHelper.SHIPMENT_STATUS), \(DBHelper.ARTICLE_ID), \(DBHelper.BATCH_NO), " +
        "\(DBHelper.DEC_QTY), \(DBHelper.DELETED), \(DBHelper.CREATED_BY_USER), \(DBHelper.CREATED_ON), " +
        "\(DBHelper.MODIFIED_ON), \(DBHelper.DEC_QTY_KGL)) " +
        "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?);"
        
        for scmData in jsonScmData {
            do {
                try database.executeUpdate(sql, values: [
                    scmData["A"] as! String,
                    scmData["B"] as! String,
                    scmData["C"] as! String,
                    scmData["D"] as! String,
                    scmData["E"] as! String,
                    scmData["F"] as! String,
                    scmData["G"] as! String,
                    scmData["H"] as! String,
                    scmData["I"] as! String,
                    scmData["J"] as! String,
                    scmData["K"] as! String,
                    scmData["L"] as! String,
                    scmData["M"] as! String,
                    scmData["N"] as! String
                ])
            } catch {
                print("Error executing statement: \(error.localizedDescription)")
            }
        }
        
        try database.executeUpdate("DELETE FROM bf_scm_cpm_integration_data " +
                                   "WHERE scm_cpm_id IN (" +
                                   "SELECT st.scm_cpm_id " +
                                   "FROM bf_scm_cpm_integration_data AS st " +
                                   "INNER JOIN bf_scm_cpm_integration_data_copy AS st_copy ON st.scm_cpm_id = st_copy.scm_cpm_id);",
                                   values: nil)
        
        try database.executeUpdate("INSERT INTO \(DBHelper.TABLE_DISPATCH_WAREHOUSE) " +
                                   "(scm_cpm_id, do_sto_no, from_user_id, to_user_id, truck_no, shipment_status, " +
                                   "article_id, batch_no, dec_qty, deleted, created_by_user, created_on, modified_on, " +
                                   "dec_qty_kgl) " +
                                   "SELECT scm_cpm_id, do_sto_no, from_user_id, to_user_id, truck_no, shipment_status, " +
                                   "article_id, batch_no, dec_qty, deleted, created_by_user, created_on, modified_on, " +
                                   "dec_qty_kgl FROM \(DBHelper.TABLE_DISPATCH_WAREHOUSE_COPY);",
                                   values: nil)
        
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_DISPATCH_WAREHOUSE_COPY);", values: nil)
        
        database.commit()
    } catch {
        print("Error in insertScmData: \(error.localizedDescription)")
        //            if let callback = callback {
        //                callback.onDatabaseError(String(describing: SyncErrorCode.ERROR_108), AppUtil.getStackTrace(error))
        //            }
        //            SynchronizationService.isSuccess = false
        //            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(error) + " In Method insertScmData"
    }
    //        finally {
    //            database.endTransaction()
    //        }
    
    return true
}

func insertCFAReturnBulk(_ ishopCFAReturn: [[String: Any]],database:FMDatabase) {
    database.executeStatements("DELETE FROM \(DBHelper.TABLE_CFA_RETURN_COPY);")
    database.beginTransaction()
    
    do {
        //if let jsonArray = try JSONSerialization.jsonObject(with: ishopCFAReturn) as? [[String: Any]] {
        let sql = "INSERT INTO \(DBHelper.TABLE_CFA_RETURN_COPY) " +
        "(\(DBHelper.KEY_CFA_RETURN_ID), \(DBHelper.KEY_CUSTOMER_FROM_ID), " +
        "\(DBHelper.KEY_CUSTOMER_TO_ID), \(DBHelper.KEY_RETURN_DATE), " +
        "\(DBHelper.KEY_COUNTRY_ID), \(DBHelper.KEY_CREATED_BY_USER), " +
        "\(DBHelper.KEY_MODIFIED_BY_USER), \(DBHelper.KEY_STATUS), " +
        "\(DBHelper.KEY_CREATE_ON), \(DBHelper.KEY_MODIFIED_ON), " +
        "\(DBHelper.KEY_SYNC_CODE), \(DBHelper.KEY_SYNC_FLAG), " +
        "\(DBHelper.KEY_SYNC_DATE), \(DBHelper.KEY_IS_DISPATCH), " +
        "\(DBHelper.KEY_SYNC_USER)) " +
        "VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)"
        
        for object in ishopCFAReturn {
            do {
                try database.executeUpdate(sql, values: [
                    object["A"] as? String ?? "", // cfa_return_id
                    object["B"] as? String ?? "", // customer_from_id
                    object["C"] as? String ?? "", // customer_to_id
                    object["D"] as? String ?? "", // return_date
                    object["E"] as? String ?? "", // country_id
                    object["F"] as? String ?? "", // created_by_user
                    object["G"] as? String ?? "", // modified_by_user
                    object["H"] as? String ?? "", // status
                    object["I"] as? String ?? "", // created_on
                    object["J"] as? String ?? "", // modified_on
                    object["K"] as? String ?? "", // sync_code
                    object["L"] as? String ?? "", // sync_flag
                    object["M"] as? String ?? "", // sync_date
                    "1", // is_dispatch
                    object["N"] as? String ?? "" // sync_by_user
                ])
            } catch let error as NSError {
                print(error)
                //                        error.printStackTrace()
                //                        if let callback = callback {
                //                            callback.onDatabaseError(String(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(error))
                //                        }
                //                        SynchronizationService.isSuccess = false
                //                        SynchronizationService.exceptionDetails = AppUtil.getStackTrace(error) + " In Method InsertCFAReturnNew"
            }
        }
        //}
        
        manageCfaReturnCopy(database: database)
        database.commit()
        
    } catch let error as NSError {
        print(error)
        //            error.printStackTrace()
        //            if let callback = callback {
        //                callback.onDatabaseError(String(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(error))
        //            }
        //            SynchronizationService.isSuccess = false
        //            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(error) + " In Method InsertCFAReturnNew"
    }
    
    
}


private func manageCfaReturnCopy(database:FMDatabase) {
    database.executeStatements("DELETE FROM bf_ishop_cfa_return " +
                               "WHERE sync_code IN (" +
                               "SELECT st.sync_code " +
                               "FROM bf_ishop_cfa_return AS st " +
                               "INNER JOIN " +
                               "bf_ishop_cfa_return_copy AS st_copy ON st.sync_code = st_copy.sync_code);")
    
    database.executeStatements("INSERT INTO bf_ishop_cfa_return " +
                               "(cfa_return_id, customer_from_id, customer_to_id, return_date, " +
                               "country_id, created_by_user, modified_by_user, status, " +
                               "created_on, modified_on, sync_code, sync_flag, sync_date, " +
                               "isDispatch, sync_by_user) " +
                               "SELECT cfa_return_id, customer_from_id, customer_to_id, return_date, " +
                               "country_id, created_by_user, modified_by_user, status, " +
                               "created_on, modified_on, sync_code, sync_flag, sync_date, " +
                               "isDispatch, sync_by_user " +
                               "FROM bf_ishop_cfa_return_copy;")
    
    database.executeStatements("DELETE FROM \(DBHelper.TABLE_CFA_RETURN_COPY);")
}


func insertCFAReturnProductBulk(ishopCFAReturnProduct: [[String: Any?]],database:FMDatabase) {
    database.executeStatements("DELETE FROM \(DBHelper.TABLE_CFA_RETURN_PRODUCT_COPY)")
    database.beginTransaction()
    
    let sql = """
                INSERT INTO \(DBHelper.TABLE_CFA_RETURN_PRODUCT_COPY)
                (\(DBHelper.KEY_CFA_RETURN_PRODUCT_ID), \(DBHelper.KEY_CFA_RETURN_ID), \(DBHelper.KEY_PRODUCT_SKU_ID), \(DBHelper.KEY_STICKER_DETAILS_ID),
                \(DBHelper.KEY_BTC_NO_OUT), \(DBHelper.KEY_QUANTITY), \(DBHelper.KEY_AMOUNT), \(DBHelper.KEY_UNIT),
                \(DBHelper.KEY_QTY_KGL), \(DBHelper.KEY_IS_VALID), \(DBHelper.KEY_SYNC_CODE), \(DBHelper.KEY_SYNC_FLAG),
                \(DBHelper.KEY_SYNC_DATE), \(DBHelper.KEY_SYNC_USER))
                VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
            """
    
    do {
        for object in ishopCFAReturnProduct {
            if
                let cfaReturnProductID = object["A"] as? String,
                let cfaReturnID = object["B"] as? String,
                let productSKUId = object["C"] as? String,
                let stickerDetailsId = object["D"] as? String,
                let btcNoOut = object["E"] as? String,
                let quantity = object["G"] as? String,
                let amount = object["H"] as? String,
                let unit = object["I"] as? String,
                let qtyKgl = object["J"] as? String,
                let isValid = object["K"] as? String,
                let syncCode = object["L"] as? String,
                let syncFlag = object["M"] as? String,
                let syncDate = object["N"] as? String,
                let syncByUser = object["O"] as? String {
                
                try database.executeUpdate(sql, values: [
                    cfaReturnProductID,
                    cfaReturnID,
                    productSKUId,
                    stickerDetailsId,
                    btcNoOut,
                    quantity,
                    amount,
                    unit,
                    qtyKgl,
                    isValid,
                    syncCode,
                    syncFlag,
                    syncDate,
                    syncByUser,
                ])
            } else {
                // Handle the case where one or more values are nil
            }
        }
        manageCFAReturnProduct(database: database)
        database.commit()
    } catch let error {
        print("Error: \(error)")
        // Handle error as needed
        database.rollback() // Rollback the transaction in case of an error
    }
}

func manageCFAReturnProduct(database:FMDatabase) {
    database.executeStatements("DELETE FROM bf_ishop_cfa_return_product " +
                               "WHERE sync_code IN (SELECT st.sync_code " +
                               "FROM bf_ishop_cfa_return_product AS st " +
                               "INNER JOIN bf_ishop_cfa_return_product_copy AS st_copy ON st.sync_code = st_copy.sync_code);")
    
    database.executeStatements("INSERT INTO bf_ishop_cfa_return_product (" +
                               "cfa_return_product_id, cfa_return_id, product_sku_id, sticker_details_id, " +
                               "btc_no_out, qr_code_out, quantity, amount, unit, qty_kgl, is_valid, " +
                               "sync_code, sync_flag, sync_date, sync_by_user) " +
                               "SELECT cfa_return_product_id, cfa_return_id, product_sku_id, sticker_details_id, " +
                               "btc_no_out, qr_code_out, quantity, amount, unit, qty_kgl, is_valid, " +
                               "sync_code, sync_flag, sync_date, sync_by_user " +
                               "FROM bf_ishop_cfa_return_product_copy;")
    
    database.executeStatements("DELETE FROM \(DBHelper.TABLE_CFA_RETURN_PRODUCT_COPY);")
}

func insertDistributorReturnRequestBulk(_ ishopDistributorReturnRequest: [[String: Any]],database:FMDatabase) {
    database.executeStatements("DELETE FROM \(DBHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_COPY);")
    database.beginTransaction()
    
    do {
        // if let jsonArray = try JSONSerialization.jsonObject(with: ishopDistributorReturnRequest) as? [[String: Any]] {
        let sql = "INSERT INTO \(DBHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_COPY) " +
        "(\(DBHelper.KEY_DISTRIBUTOR_RETURN_REQUEST_ID), \(DBHelper.SRIP_ID), " +
        "\(DBHelper.KEY_CUSTOMER_FROM_ID), \(DBHelper.KEY_CUSTOMER_TO_ID), " +
        "\(DBHelper.KEY_RETURN_REQUEST_DATE), \(DBHelper.KEY_COUNTRY_ID), " +
        "\(DBHelper.KEY_CREATED_BY_USER), \(DBHelper.KEY_MODIFIED_BY_USER), " +
        "\(DBHelper.KEY_STATUS), \(DBHelper.KEY_CREATE_ON), \(DBHelper.KEY_MODIFIED_ON), " +
        "\(DBHelper.KEY_SYNC_CODE), \(DBHelper.KEY_SYNC_FLAG), " +
        "\(DBHelper.KEY_SYNC_DATE), \(DBHelper.KEY_isDispatch), " +
        "\(DBHelper.KEY_SYNC_USER)) " +
        "VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)"
        
        for object in ishopDistributorReturnRequest {
            do {
                try database.executeUpdate(sql, values: [
                    object["A"] as? String ?? "", // distributor_return_request_id
                    object["E"] as? String ?? "", // srip_id
                    object["B"] as? String ?? "", // customer_from_id
                    object["C"] as? String ?? "", // customer_to_id
                    object["D"] as? String ?? "", // return_request_date
                    object["F"] as? String ?? "", // country_id
                    object["G"] as? String ?? "", // created_by_user
                    object["H"] as? String ?? "", // modified_by_user
                    object["I"] as? String ?? "", // status
                    object["J"] as? String ?? "", // created_on
                    object["K"] as? String ?? "", // modified_on
                    object["L"] as? String ?? "", // sync_code
                    object["M"] as? String ?? "", // sync_flag
                    object["N"] as? String ?? "", // sync_date
                    "1", // is_dispatch
                    object["O"] as? String ?? "" // sync_by_user
                ])
            } catch let error as NSError {
                print(error)
                //                        error.printStackTrace()
                //                        if let callback = callback {
                //                            callback.onDatabaseError(String(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(error))
                //                        }
                //                        SynchronizationService.isSuccess = false
                //                        SynchronizationService.exceptionDetails = AppUtil.getStackTrace(error) + " In Method InsertDistributorReturnRequestNew"
            }
        }
        // }
        manageDistReturnRequestCopy(database: database)
        database.commit()
    } catch let error as NSError {
        print(error)
        //            error.printStackTrace()
        //            if let callback = callback {
        //                callback.onDatabaseError(String(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(error))
        //            }
        //            SynchronizationService.isSuccess = false
        //            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(error) + " In Method InsertDistributorReturnRequestNew"
    }
    
    
}


func manageDistReturnRequestCopy(database:FMDatabase) {
    database.executeStatements("DELETE FROM bf_ishop_distributor_return_request " +
                               "WHERE sync_code IN (" +
                               "SELECT st.sync_code " +
                               "FROM bf_ishop_distributor_return_request AS st " +
                               "INNER JOIN " +
                               "bf_ishop_distributor_return_request_copy AS st_copy ON st.sync_code = st_copy.sync_code);")
    
    database.executeStatements("INSERT INTO bf_ishop_distributor_return_request " +
                               "(distributor_return_request_id, srip_id, customer_from_id, customer_to_id, " +
                               "return_request_date, country_id, created_by_user, modified_by_user, status, " +
                               "created_on, modified_on, sync_code, sync_flag, sync_date, isDispatch, sync_by_user) " +
                               "SELECT " +
                               "distributor_return_request_id, srip_id, customer_from_id, customer_to_id, " +
                               "return_request_date, country_id, created_by_user, modified_by_user, status, " +
                               "created_on, modified_on, sync_code, sync_flag, sync_date, isDispatch, sync_by_user " +
                               "FROM bf_ishop_distributor_return_request_copy;")
    
    // Delete copy table data
    database.executeStatements("DELETE FROM \(DBHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_COPY);")
}

func deleteSaveOfflineLogTable(database:FMDatabase) {
    do {
        //            let db = try writeDB()
        try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_SAVE_OFFLINE_LOG);", values: nil)
    } catch {
        print("Error in deleteSaveOfflineLogTable: \(error.localizedDescription)")
    }
}

func deleteUnreceivedValidData(database:FMDatabase) {
    do {
        //            let db = try writeDB()
        
        // Delete from bf_ishop_distributor_received_product
        try database.executeUpdate("DELETE FROM bf_ishop_distributor_received_product WHERE distributor_received_id NOT IN (SELECT distributor_received_id FROM bf_ishop_distributor_received);", values: nil)
        
        // Delete from bf_ishop_retailer_received_product
        try database.executeUpdate("DELETE FROM bf_ishop_retailer_received_product WHERE retailer_received_id NOT IN (SELECT retailer_received_id FROM bf_ishop_retailer_received);", values: nil)
        
        // Delete from bf_ishop_retailer_dispatch_product
        try database.executeUpdate("DELETE FROM bf_ishop_retailer_dispatch_product WHERE retailer_dispatch_id NOT IN (SELECT retailer_dispatch_id FROM bf_ishop_retailer_dispatch);", values: nil)
        
        // Delete from bf_ishop_distributor_return_request_product
        try database.executeUpdate("DELETE FROM bf_ishop_distributor_return_request_product WHERE distributor_return_request_id NOT IN (SELECT distributor_return_request_id FROM bf_ishop_distributor_return_request);", values: nil)
        
        // Delete from bf_ishop_toller_dispatch_product
        try database.executeUpdate("DELETE FROM bf_ishop_toller_dispatch_product WHERE toller_dispatch_id NOT IN (SELECT toller_dispatch_id FROM bf_ishop_toller_dispatch);", values: nil)
        
    } catch {
        print("Error in deleteUnreceivedValidData: \(error.localizedDescription)")
    }
}

func deleteRejectedOrder(database:FMDatabase) {
    do {
        //            let db = try writeDB()
        
        // Assuming your table name is "table_rejected_order"
        try database.executeUpdate("DELETE FROM table_rejected_order;", values: nil)
        
    } catch {
        print("Error in deleteRejectedOrder: \(error.localizedDescription)")
    }
}


func deleteDamageData(database:FMDatabase) {
    do {
        //            let db = try writeDB()
        
        // Assuming the table names are the same as in the Android code
        try database.executeUpdate("DELETE FROM " + DBHelper.TABLE_CFA_DAMAGE, values: nil)
        try database.executeUpdate("DELETE FROM " + DBHelper.TABLE_CFA_DAMAGE_PRODUCT, values: nil)
        
        try database.executeUpdate("DELETE FROM " + DBHelper.TABLE_DISTRIBUTOR_DAMAGE, values: nil)
        try database.executeUpdate("DELETE FROM " + DBHelper.TABLE_DISTRIBUTOR_DAMAGE_PRODUCT, values: nil)
        
        try database.executeUpdate("DELETE FROM " + DBHelper.TABLE_RETAILER_DAMAGE, values: nil)
        try database.executeUpdate("DELETE FROM " + DBHelper.TABLE_RETAILER_DAMAGE_PRODUCT, values: nil)
        
    } catch {
        print("Error in deleteDamageData: \(error.localizedDescription)")
    }
}

func deleteDeviceTokenTable(database:FMDatabase) {
    do {
        //            let db = try writeDB()
        try database.executeUpdate("DELETE FROM table_device_token", values: nil)
    } catch {
        print("Error in deleteDeviceTokenTable: \(error.localizedDescription)")
    }
}


func deleteRejectedData(database:FMDatabase) {
    do {
        //            let db = try writeDB()
        
        let sql = "DELETE FROM bf_ishop_toller_dispatch WHERE reject = 1"
        try database.executeUpdate(sql, values: nil)
        
        let sql1 = "DELETE FROM bf_ishop_cfa_dispatch WHERE reject = 1"
        try database.executeUpdate(sql1, values: nil)
        
        //            db.close()
    } catch {
        print("Error in deleteRejectedData: \(error.localizedDescription)")
    }
}

func deleteCfaDispatchIDNotInProductTable(database:FMDatabase) {
    do {
        //            let db = try writeDB()
        
        let sql = """
                      DELETE FROM bf_ishop_cfa_dispatch
                      WHERE cfa_dispatch_id NOT IN (
                        SELECT bidp.cfa_dispatch_id
                        FROM bf_ishop_cfa_dispatch_product AS bidp
                      );
                      """
        try database.executeUpdate(sql, values: nil)
        
        //            db.close()
    } catch {
        print("Error in deleteCfaDispatchIDNotInProductTable: \(error.localizedDescription)")
    }
}

func deleteCfaDispatchIDNotInMainTable(database:FMDatabase) {
    do {
        //            let db = try writeDB()
        
        let sql = """
                      DELETE FROM bf_ishop_cfa_dispatch_product
                      WHERE cfa_dispatch_id NOT IN (
                        SELECT bidp.cfa_dispatch_id
                        FROM bf_ishop_cfa_dispatch AS bidp
                      );
                      """
        try database.executeUpdate(sql, values: nil)
        
        //            db.close()
    } catch {
        print("Error in deleteCfaDispatchIDNotInMainTable: \(error.localizedDescription)")
    }
}

func deleteTransactionErrorLog(database:FMDatabase) {
    do {
        //            let db = try writeDB()
        
        let sql = "DELETE FROM \(DBHelper.TABLE_TRANSACTION_ERROR_LOG);"
        try database.executeUpdate(sql, values: nil)
        
        //            db.close()
    } catch {
        print("Error in deleteTransactionErrorLog: \(error.localizedDescription)")
    }
}

func deleteDistributorReturnRequestData(customerId: String,database:FMDatabase) {
    do {
        //            let db = try writeDB()
        
        let sql = """
                DELETE FROM bf_ishop_distributor_return_request_product
                WHERE sticker_details_id IN (
                    SELECT bicrp.sticker_details_id
                    FROM bf_ishop_cfa_return_product AS bicrp
                        INNER JOIN bf_ishop_cfa_return AS bicr ON bicr.cfa_return_id = bicrp.cfa_return_id
                        INNER JOIN ishop_sticker_details AS isd ON isd.sticker_details_id = bicrp.sticker_details_id
                        INNER JOIN CustomerType_Details AS ctd ON ctd.customer_type_country_id = isd.customer_type_country_id
                    WHERE bicr.isDispatch = '1' AND
                          bicrp.is_valid = '1' AND
                          ctd.customer_level = 'L3' AND bicr.customer_to_id='\(customerId)'
                );
                """
        try database.executeUpdate(sql, values: nil)
        
        //            db.close()
    } catch {
        print("Error in deleteDistributorReturnRequestData: \(error.localizedDescription)")
    }
}

func insertCustomerProductDamageStock(arrayCPMCustomerProductStock: [[String: Any]], fileName: String,database:FMDatabase) {
        if fileName.lowercased() == "1.txt" {
            database.executeStatements("DELETE FROM \(DBHelper.TABLE_CUSTOMER_PRODUCT_DAMAGE_STOCK)")
        }

        database.beginTransaction()
        let sql = """
            INSERT INTO \(DBHelper.TABLE_CUSTOMER_PRODUCT_DAMAGE_STOCK) (
                \(DBHelper.KEY_CUSTOMER_PRODUCT_DAMAGE_STOCK_ID),
                \(DBHelper.KEY_CUSTOMER_ID),
                \(DBHelper.KEY_PRODUCT_SKU_ID),
                \(DBHelper.KEY_PRODUCT_STOCK_BOX),
                \(DBHelper.KEY_PRODUCT_STOCK_KGL),
                \(DBHelper.KEY_BATCH_NO),
                \(DBHelper.KEY_EXPIRE_DATE)
            ) VALUES (?,?,?,?,?,?,?)
        """

        for object in arrayCPMCustomerProductStock {
            do {
                try database.executeUpdate(sql, values: [
                    object["A"] as? String ?? "",
                    object["B"] as? String ?? "",
                    object["C"] as? String ?? "",
                    object["E"] as? String ?? "",
                    object["F"] as? String ?? "",
                    object["D"] as? String ?? "",
                    object["G"] as? String ?? ""
                ])
            } catch {
                print("Error executing SQL statement: \(error)")
            }
        }

        database.commit()
    }


func updateRetailerReceiveProductSyncFlag(database:FMDatabase) {
      
        let updateQuery = "UPDATE \(DBHelper.TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT) SET sync_flag = 'N' WHERE sync_flag = 'Y'"
        
        do {
            try database.executeUpdate(updateQuery, values: nil)
            
            let rowsUpdated = database.changes
            if rowsUpdated > 0 {
                print("updateRetiler_receive done")
            } else {
                print("updateRetiler_receive not done")
            }
        } catch {
            print("Error updating retailer receive product sync flag: \(error.localizedDescription)")
        }
        
    }


func updateRetailerDispatchProductSyncFlag(database:FMDatabase) {
   
        let updateQuery = "UPDATE bf_ishop_retailer_dispatch_product SET sync_flag = 'N' WHERE sync_flag = 'Y'"
        
        do {
            try database.executeUpdate(updateQuery, values: nil)
            
            let rowsUpdated = database.changes
            if rowsUpdated > 0 {
                print("updateRetailer_dispatch done")
            } else {
                print("updateRetailer_dispatch not done")
            }
        } catch {
            print("Error updating retailer dispatch product sync flag: \(error.localizedDescription)")
        }
        
    }

func insertCustomerDetails(jsonArrayCustomerDetails: [[String: Any]], fileName: String,database:FMDatabase) {
      
        if fileName == "1.txt" {
            do {
                try database.executeUpdate("DELETE FROM \(DBHelper.TABLE_CUSTOMER_DETAILS)", values: nil)
            } catch {
                print("Error deleting records from \(DBHelper.TABLE_CUSTOMER_DETAILS): \(database.lastErrorMessage())")
            }
        }

        database.beginTransaction()

        do {
            let sql = """
                INSERT INTO \(DBHelper.TABLE_CUSTOMER_DETAILS)
                (\(DBHelper.KEY_ID), \(DBHelper.KEY_EMAIL), \(DBHelper.KEY_USER_CODE),
                 \(DBHelper.KEY_BUSSINESS_CODE), \(DBHelper.KEY_DISPLAY_NAME),
                 \(DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID), \(DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_CODE),
                 \(DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_NAME), \(DBHelper.KEY_CUSTOMER_TYPE_REGIONAL_ID),
                 \(DBHelper.KEY_CUSTOMER_TYPE_REGIONAL_NAME), \(DBHelper.KEY_CUSTOMER_TYPE_REGIONAL_CODE),
                 \(DBHelper.KEY_CUSTOMER_TYPE_REGIONAL_LEVEL), \(DBHelper.KEY_POLITICAL_GEO_ID),
                 \(DBHelper.KEY_political_geography_countrylevel_id), \(DBHelper.KEY_political_regional_level),
                 \(DBHelper.KEY_SAP_ID), \(DBHelper.KEY_PARENT_USER_ID),
                 \(DBHelper.KEY_PRIMARY_MOBILE_NO))
                VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
            """

            for object in jsonArrayCustomerDetails {
                var args = [Any]()
                args.append(object["A"] as? String ?? "")  // id
                args.append(object["B"] as? String ?? "")  // email
                args.append(object["C"] as? String ?? "")  // user_code
                args.append(object["D"] as? String ?? "")  // bussiness_code
                args.append(object["E"] as? String ?? "")  // display_name
                args.append(object["G"] as? String ?? "")  // customer_type_country_id
                args.append(object["H"] as? String ?? "")  // customer_type_country_code
                args.append(object["I"] as? String ?? "")  // customer_type_country_name
                args.append(object["J"] as? String ?? "")  // customer_type_regional_id
                args.append(object["K"] as? String ?? "")  // customer_type_regional_name
                args.append(object["L"] as? String ?? "")  // customer_type_regional_code
                args.append(object["M"] as? String ?? "")  // customer_regional_level
                args.append(object["N"] as? String ?? "")  // political_geo_id
                args.append(object["O"] as? String ?? "")  // political_geography_countrylevel_id
                args.append(object["P"] as? String ?? "")  // political_regional_level
                args.append(object["Q"] as? String ?? "")  // sap_id
                args.append(object["F"] as? String ?? "")  // parent_user_id
                args.append(object["R"] as? String ?? "")  // parent_user_id

                do {
                    try database.executeUpdate(sql, values: args)
                } catch {
                    print("Error inserting records into \(DBHelper.TABLE_CUSTOMER_DETAILS): \(error.localizedDescription)")
                }
            }

            print("CUSTOMER_DETAILS INSERT COMPLETE")
            database.commit()
        } catch {
            print("Error in insertCustomerDetails: \(error)")
            
        }
    }

func getLoginId(db: FMDatabase) -> String {

    var loginId = ""

    do {
        let sql = "SELECT fk_personGlcode FROM login"
        print("getLoginId \(sql)")

        // Use try? to convert the result to an optional type
        if let cursor = try? db.executeQuery(sql, values: nil) {
            while cursor.next() {
                if let fetchedLoginId = cursor.string(forColumn: "fk_personGlcode") {
                    loginId = fetchedLoginId
                }
            }
        }

    } catch {
        print("Error in getLoginId: \(error.localizedDescription)")
    }

    return loginId
}

func updateLoginDetails(arrayCustomerDetails: [[String: Any]], database: FMDatabase) {
    do {
        // Use regular 'let' instead of 'guard let'
        let loginUserId = getLoginId(db: database)

        for objCustomer in arrayCustomerDetails {
            if let userId = objCustomer["A"] as? String,
               let displayName = objCustomer["E"] as? String,
               userId.lowercased() == loginUserId.lowercased() {

                let sql = "UPDATE login SET var_personname = ? WHERE fk_personGlcode = ?"
                let args: [Any] = [displayName, userId]

                do {
                    try database.executeUpdate(sql, values: args)
                    break
                } catch {
                    print("Error updating login details: \(error.localizedDescription)")
                }
            }
        }
    } catch {
        print("Error in updateLoginDetails: \(error)")
    }
}


//END_DIR_INSERT

//,database:FMDatabase

